
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.10.3
// timestamp : Mon May 22 12:14:28 2023 GMT
// usage     : riscv_ctg \
//                  -- cgf //                  --cgf /home/cm/src/riscv-ctg/zfa/sample_cgfs/dataset.cgf \
//                  --cgf /home/cm/src/riscv-ctg/zfa/sample_cgfs/zfa/fleq.d.cgf \
 \
//                  -- xlen 32  \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the fleq.d instruction of the RISC-V RV32FD_Zicsr_Zfa,RV64FD_Zicsr_Zfa extension for the fleq.d_b1 covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IFD_Zicsr_Zfa,RV64IFD_Zicsr_Zfa")

.section .text.init
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*I.*D.*Zfa.*);def TEST_CASE_1=True;",fleq.d_b1)

RVTEST_FP_ENABLE()
RVTEST_VALBASEUPD(x3,test_dataset_0)
RVTEST_SIGBASE(x1,signature_x1_1)

inst_0:// rs1 != rs2, rs1==f31, rs2==f30, rd==x31,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x0;
valaddr_reg:x3; val_offset:0*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x3, 0*FLEN/8, x4, x1, x2)

inst_1:// rs1 == rs2, rs1==f29, rs2==f29, rd==x30,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f29; op2:f29; dest:x30; op1val:0x0; op2val:0x0;
valaddr_reg:x3; val_offset:2*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x30, f29, f29, 0, 0, x3, 2*FLEN/8, x4, x1, x2)

inst_2:// rs1==f30, rs2==f31, rd==x29,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f30; op2:f31; dest:x29; op1val:0x0; op2val:0x1;
valaddr_reg:x3; val_offset:4*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x29, f30, f31, 0, 0, x3, 4*FLEN/8, x4, x1, x2)

inst_3:// rs1==f28, rs2==f27, rd==x28,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f28; op2:f27; dest:x28; op1val:0x0; op2val:0x8000000000000001;
valaddr_reg:x3; val_offset:6*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x28, f28, f27, 0, 0, x3, 6*FLEN/8, x4, x1, x2)

inst_4:// rs1==f27, rs2==f28, rd==x27,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f27; op2:f28; dest:x27; op1val:0x0; op2val:0x2;
valaddr_reg:x3; val_offset:8*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x27, f27, f28, 0, 0, x3, 8*FLEN/8, x4, x1, x2)

inst_5:// rs1==f26, rs2==f25, rd==x26,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f26; op2:f25; dest:x26; op1val:0x0; op2val:0x8000000000000002;
valaddr_reg:x3; val_offset:10*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x26, f26, f25, 0, 0, x3, 10*FLEN/8, x4, x1, x2)

inst_6:// rs1==f25, rs2==f26, rd==x25,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f25; op2:f26; dest:x25; op1val:0x0; op2val:0xfffffffffffff;
valaddr_reg:x3; val_offset:12*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x25, f25, f26, 0, 0, x3, 12*FLEN/8, x4, x1, x2)

inst_7:// rs1==f24, rs2==f23, rd==x24,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f24; op2:f23; dest:x24; op1val:0x0; op2val:0x800fffffffffffff;
valaddr_reg:x3; val_offset:14*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x24, f24, f23, 0, 0, x3, 14*FLEN/8, x4, x1, x2)

inst_8:// rs1==f23, rs2==f24, rd==x23,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f23; op2:f24; dest:x23; op1val:0x0; op2val:0x10000000000000;
valaddr_reg:x3; val_offset:16*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x23, f23, f24, 0, 0, x3, 16*FLEN/8, x4, x1, x2)

inst_9:// rs1==f22, rs2==f21, rd==x22,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f22; op2:f21; dest:x22; op1val:0x0; op2val:0x8010000000000000;
valaddr_reg:x3; val_offset:18*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x22, f22, f21, 0, 0, x3, 18*FLEN/8, x4, x1, x2)

inst_10:// rs1==f21, rs2==f22, rd==x21,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f21; op2:f22; dest:x21; op1val:0x0; op2val:0x10000000000002;
valaddr_reg:x3; val_offset:20*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x21, f21, f22, 0, 0, x3, 20*FLEN/8, x4, x1, x2)

inst_11:// rs1==f20, rs2==f19, rd==x20,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f20; op2:f19; dest:x20; op1val:0x0; op2val:0x8010000000000002;
valaddr_reg:x3; val_offset:22*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x20, f20, f19, 0, 0, x3, 22*FLEN/8, x4, x1, x2)

inst_12:// rs1==f19, rs2==f20, rd==x19,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f19; op2:f20; dest:x19; op1val:0x0; op2val:0x7fefffffffffffff;
valaddr_reg:x3; val_offset:24*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x19, f19, f20, 0, 0, x3, 24*FLEN/8, x4, x1, x2)

inst_13:// rs1==f18, rs2==f17, rd==x18,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f18; op2:f17; dest:x18; op1val:0x0; op2val:0xffefffffffffffff;
valaddr_reg:x3; val_offset:26*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x18, f18, f17, 0, 0, x3, 26*FLEN/8, x4, x1, x2)

inst_14:// rs1==f17, rs2==f18, rd==x17,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f17; op2:f18; dest:x17; op1val:0x0; op2val:0x7ff0000000000000;
valaddr_reg:x3; val_offset:28*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x17, f17, f18, 0, 0, x3, 28*FLEN/8, x4, x1, x2)

inst_15:// rs1==f16, rs2==f15, rd==x16,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f16; op2:f15; dest:x16; op1val:0x0; op2val:0xfff0000000000000;
valaddr_reg:x3; val_offset:30*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x16, f16, f15, 0, 0, x3, 30*FLEN/8, x4, x1, x2)

inst_16:// rs1==f15, rs2==f16, rd==x15,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f15; op2:f16; dest:x15; op1val:0x0; op2val:0x7ff8000000000000;
valaddr_reg:x3; val_offset:32*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x15, f15, f16, 0, 0, x3, 32*FLEN/8, x4, x1, x2)

inst_17:// rs1==f14, rs2==f13, rd==x14,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f14; op2:f13; dest:x14; op1val:0x0; op2val:0xfff8000000000000;
valaddr_reg:x3; val_offset:34*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x14, f14, f13, 0, 0, x3, 34*FLEN/8, x4, x1, x2)

inst_18:// rs1==f13, rs2==f14, rd==x13,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f13; op2:f14; dest:x13; op1val:0x0; op2val:0x7ff8000000000001;
valaddr_reg:x3; val_offset:36*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x13, f13, f14, 0, 0, x3, 36*FLEN/8, x4, x1, x2)

inst_19:// rs1==f12, rs2==f11, rd==x12,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f12; op2:f11; dest:x12; op1val:0x0; op2val:0xfff8000000000001;
valaddr_reg:x3; val_offset:38*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x12, f12, f11, 0, 0, x3, 38*FLEN/8, x4, x1, x2)

inst_20:// rs1==f11, rs2==f12, rd==x11,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f11; op2:f12; dest:x11; op1val:0x0; op2val:0x7ff0000000000001;
valaddr_reg:x3; val_offset:40*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x11, f11, f12, 0, 0, x3, 40*FLEN/8, x4, x1, x2)

inst_21:// rs1==f10, rs2==f9, rd==x10,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f10; op2:f9; dest:x10; op1val:0x0; op2val:0xfff0000000000001;
valaddr_reg:x3; val_offset:42*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x10, f10, f9, 0, 0, x3, 42*FLEN/8, x4, x1, x2)

inst_22:// rs1==f9, rs2==f10, rd==x9,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f9; op2:f10; dest:x9; op1val:0x0; op2val:0x3ff0000000000000;
valaddr_reg:x3; val_offset:44*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x9, f9, f10, 0, 0, x3, 44*FLEN/8, x4, x1, x2)
RVTEST_VALBASEUPD(x9,test_dataset_1)

inst_23:// rs1==f8, rs2==f7, rd==x8,fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f8; op2:f7; dest:x8; op1val:0x0; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:0*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x8, f8, f7, 0, 0, x9, 0*FLEN/8, x10, x1, x2)

inst_24:// rs1==f7, rs2==f8, rd==x7,fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f7; op2:f8; dest:x7; op1val:0x8000000000000000; op2val:0x0;
valaddr_reg:x9; val_offset:2*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x7, f7, f8, 0, 0, x9, 2*FLEN/8, x10, x1, x2)

inst_25:// rs1==f6, rs2==f5, rd==x6,fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f6; op2:f5; dest:x6; op1val:0x8000000000000000; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:4*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x6, f6, f5, 0, 0, x9, 4*FLEN/8, x10, x1, x7)
RVTEST_SIGBASE(x6,signature_x6_0)

inst_26:// rs1==f5, rs2==f6, rd==x5,fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f5; op2:f6; dest:x5; op1val:0x8000000000000000; op2val:0x1;
valaddr_reg:x9; val_offset:6*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x5, f5, f6, 0, 0, x9, 6*FLEN/8, x10, x6, x7)

inst_27:// rs1==f4, rs2==f3, rd==x4,fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f4; op2:f3; dest:x4; op1val:0x8000000000000000; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:8*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x4, f4, f3, 0, 0, x9, 8*FLEN/8, x10, x6, x7)

inst_28:// rs1==f3, rs2==f4, rd==x3,fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f3; op2:f4; dest:x3; op1val:0x8000000000000000; op2val:0x2;
valaddr_reg:x9; val_offset:10*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x3, f3, f4, 0, 0, x9, 10*FLEN/8, x10, x6, x7)

inst_29:// rs1==f2, rs2==f1, rd==x2,fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f2; op2:f1; dest:x2; op1val:0x8000000000000000; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:12*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x2, f2, f1, 0, 0, x9, 12*FLEN/8, x10, x6, x7)

inst_30:// rs1==f1, rs2==f2, rd==x1,fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f1; op2:f2; dest:x1; op1val:0x8000000000000000; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:14*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x1, f1, f2, 0, 0, x9, 14*FLEN/8, x10, x6, x7)

inst_31:// rs1==f0,fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f0; op2:f31; dest:x31; op1val:0x8000000000000000; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:16*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f0, f31, 0, 0, x9, 16*FLEN/8, x10, x6, x7)

inst_32:// rs2==f0,fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f0; dest:x31; op1val:0x8000000000000000; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:18*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f0, 0, 0, x9, 18*FLEN/8, x10, x6, x7)

inst_33:// rd==x0,fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x0; op1val:0x8000000000000000; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:20*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x0, f31, f30, 0, 0, x9, 20*FLEN/8, x10, x6, x7)

inst_34:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000000; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:22*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 22*FLEN/8, x10, x6, x7)

inst_35:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000000; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:24*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 24*FLEN/8, x10, x6, x7)

inst_36:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000000; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:26*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 26*FLEN/8, x10, x6, x7)

inst_37:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000000; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:28*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 28*FLEN/8, x10, x6, x7)

inst_38:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000000; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:30*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 30*FLEN/8, x10, x6, x7)

inst_39:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000000; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:32*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 32*FLEN/8, x10, x6, x7)

inst_40:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000000; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:34*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 34*FLEN/8, x10, x6, x7)

inst_41:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000000; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:36*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 36*FLEN/8, x10, x6, x7)

inst_42:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000000; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:38*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 38*FLEN/8, x10, x6, x7)

inst_43:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000000; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:40*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 40*FLEN/8, x10, x6, x7)

inst_44:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000000; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:42*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 42*FLEN/8, x10, x6, x7)

inst_45:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000000; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:44*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 44*FLEN/8, x10, x6, x7)

inst_46:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000000; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:46*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 46*FLEN/8, x10, x6, x7)

inst_47:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000000; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:48*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 48*FLEN/8, x10, x6, x7)

inst_48:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0x0;
valaddr_reg:x9; val_offset:50*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 50*FLEN/8, x10, x6, x7)

inst_49:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:52*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 52*FLEN/8, x10, x6, x7)

inst_50:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0x1;
valaddr_reg:x9; val_offset:54*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 54*FLEN/8, x10, x6, x7)

inst_51:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:56*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 56*FLEN/8, x10, x6, x7)

inst_52:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0x2;
valaddr_reg:x9; val_offset:58*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 58*FLEN/8, x10, x6, x7)

inst_53:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:60*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 60*FLEN/8, x10, x6, x7)

inst_54:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:62*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 62*FLEN/8, x10, x6, x7)

inst_55:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:64*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 64*FLEN/8, x10, x6, x7)

inst_56:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:66*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 66*FLEN/8, x10, x6, x7)

inst_57:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:68*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 68*FLEN/8, x10, x6, x7)

inst_58:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:70*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 70*FLEN/8, x10, x6, x7)

inst_59:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:72*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 72*FLEN/8, x10, x6, x7)

inst_60:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:74*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 74*FLEN/8, x10, x6, x7)

inst_61:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:76*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 76*FLEN/8, x10, x6, x7)

inst_62:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:78*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 78*FLEN/8, x10, x6, x7)

inst_63:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:80*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 80*FLEN/8, x10, x6, x7)

inst_64:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:82*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 82*FLEN/8, x10, x6, x7)

inst_65:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:84*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 84*FLEN/8, x10, x6, x7)

inst_66:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:86*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 86*FLEN/8, x10, x6, x7)

inst_67:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:88*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 88*FLEN/8, x10, x6, x7)

inst_68:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:90*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 90*FLEN/8, x10, x6, x7)

inst_69:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:92*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 92*FLEN/8, x10, x6, x7)

inst_70:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:94*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 94*FLEN/8, x10, x6, x7)

inst_71:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:96*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 96*FLEN/8, x10, x6, x7)

inst_72:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0x0;
valaddr_reg:x9; val_offset:98*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 98*FLEN/8, x10, x6, x7)

inst_73:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:100*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 100*FLEN/8, x10, x6, x7)

inst_74:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0x1;
valaddr_reg:x9; val_offset:102*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 102*FLEN/8, x10, x6, x7)

inst_75:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:104*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 104*FLEN/8, x10, x6, x7)

inst_76:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0x2;
valaddr_reg:x9; val_offset:106*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 106*FLEN/8, x10, x6, x7)

inst_77:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:108*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 108*FLEN/8, x10, x6, x7)

inst_78:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:110*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 110*FLEN/8, x10, x6, x7)

inst_79:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:112*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 112*FLEN/8, x10, x6, x7)

inst_80:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:114*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 114*FLEN/8, x10, x6, x7)

inst_81:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:116*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 116*FLEN/8, x10, x6, x7)

inst_82:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:118*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 118*FLEN/8, x10, x6, x7)

inst_83:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:120*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 120*FLEN/8, x10, x6, x7)

inst_84:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:122*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 122*FLEN/8, x10, x6, x7)

inst_85:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:124*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 124*FLEN/8, x10, x6, x7)

inst_86:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:126*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 126*FLEN/8, x10, x6, x7)

inst_87:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:128*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 128*FLEN/8, x10, x6, x7)

inst_88:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:130*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 130*FLEN/8, x10, x6, x7)

inst_89:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:132*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 132*FLEN/8, x10, x6, x7)

inst_90:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:134*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 134*FLEN/8, x10, x6, x7)

inst_91:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:136*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 136*FLEN/8, x10, x6, x7)

inst_92:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:138*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 138*FLEN/8, x10, x6, x7)

inst_93:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:140*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 140*FLEN/8, x10, x6, x7)

inst_94:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:142*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 142*FLEN/8, x10, x6, x7)

inst_95:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000001; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:144*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 144*FLEN/8, x10, x6, x7)

inst_96:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0x0;
valaddr_reg:x9; val_offset:146*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 146*FLEN/8, x10, x6, x7)

inst_97:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:148*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 148*FLEN/8, x10, x6, x7)

inst_98:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0x1;
valaddr_reg:x9; val_offset:150*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 150*FLEN/8, x10, x6, x7)

inst_99:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:152*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 152*FLEN/8, x10, x6, x7)

inst_100:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0x2;
valaddr_reg:x9; val_offset:154*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 154*FLEN/8, x10, x6, x7)

inst_101:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:156*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 156*FLEN/8, x10, x6, x7)

inst_102:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:158*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 158*FLEN/8, x10, x6, x7)

inst_103:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:160*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 160*FLEN/8, x10, x6, x7)

inst_104:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:162*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 162*FLEN/8, x10, x6, x7)

inst_105:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:164*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 164*FLEN/8, x10, x6, x7)

inst_106:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:166*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 166*FLEN/8, x10, x6, x7)

inst_107:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:168*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 168*FLEN/8, x10, x6, x7)

inst_108:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:170*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 170*FLEN/8, x10, x6, x7)

inst_109:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:172*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 172*FLEN/8, x10, x6, x7)

inst_110:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:174*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 174*FLEN/8, x10, x6, x7)

inst_111:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:176*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 176*FLEN/8, x10, x6, x7)

inst_112:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:178*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 178*FLEN/8, x10, x6, x7)

inst_113:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:180*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 180*FLEN/8, x10, x6, x7)

inst_114:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:182*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 182*FLEN/8, x10, x6, x7)

inst_115:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:184*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 184*FLEN/8, x10, x6, x7)

inst_116:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:186*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 186*FLEN/8, x10, x6, x7)

inst_117:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:188*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 188*FLEN/8, x10, x6, x7)

inst_118:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:190*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 190*FLEN/8, x10, x6, x7)

inst_119:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:192*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 192*FLEN/8, x10, x6, x7)

inst_120:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0x0;
valaddr_reg:x9; val_offset:194*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 194*FLEN/8, x10, x6, x7)

inst_121:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:196*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 196*FLEN/8, x10, x6, x7)

inst_122:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0x1;
valaddr_reg:x9; val_offset:198*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 198*FLEN/8, x10, x6, x7)

inst_123:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:200*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 200*FLEN/8, x10, x6, x7)

inst_124:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0x2;
valaddr_reg:x9; val_offset:202*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 202*FLEN/8, x10, x6, x7)

inst_125:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:204*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 204*FLEN/8, x10, x6, x7)

inst_126:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:206*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 206*FLEN/8, x10, x6, x7)

inst_127:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:208*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 208*FLEN/8, x10, x6, x7)

inst_128:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:210*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 210*FLEN/8, x10, x6, x7)

inst_129:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:212*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 212*FLEN/8, x10, x6, x7)

inst_130:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:214*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 214*FLEN/8, x10, x6, x7)

inst_131:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:216*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 216*FLEN/8, x10, x6, x7)

inst_132:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:218*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 218*FLEN/8, x10, x6, x7)

inst_133:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:220*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 220*FLEN/8, x10, x6, x7)

inst_134:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:222*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 222*FLEN/8, x10, x6, x7)

inst_135:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:224*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 224*FLEN/8, x10, x6, x7)

inst_136:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:226*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 226*FLEN/8, x10, x6, x7)

inst_137:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:228*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 228*FLEN/8, x10, x6, x7)

inst_138:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:230*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 230*FLEN/8, x10, x6, x7)

inst_139:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:232*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 232*FLEN/8, x10, x6, x7)

inst_140:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:234*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 234*FLEN/8, x10, x6, x7)

inst_141:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:236*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 236*FLEN/8, x10, x6, x7)

inst_142:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:238*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 238*FLEN/8, x10, x6, x7)

inst_143:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000002; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:240*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 240*FLEN/8, x10, x6, x7)

inst_144:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0x0;
valaddr_reg:x9; val_offset:242*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 242*FLEN/8, x10, x6, x7)

inst_145:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:244*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 244*FLEN/8, x10, x6, x7)

inst_146:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0x1;
valaddr_reg:x9; val_offset:246*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 246*FLEN/8, x10, x6, x7)

inst_147:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:248*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 248*FLEN/8, x10, x6, x7)

inst_148:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0x2;
valaddr_reg:x9; val_offset:250*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 250*FLEN/8, x10, x6, x7)

inst_149:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:252*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 252*FLEN/8, x10, x6, x7)

inst_150:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:254*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 254*FLEN/8, x10, x6, x7)

inst_151:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:256*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 256*FLEN/8, x10, x6, x7)

inst_152:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:258*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 258*FLEN/8, x10, x6, x7)

inst_153:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:260*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 260*FLEN/8, x10, x6, x7)
RVTEST_SIGBASE(x6,signature_x6_1)

inst_154:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:262*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 262*FLEN/8, x10, x6, x7)

inst_155:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:264*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 264*FLEN/8, x10, x6, x7)

inst_156:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:266*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 266*FLEN/8, x10, x6, x7)

inst_157:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:268*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 268*FLEN/8, x10, x6, x7)

inst_158:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:270*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 270*FLEN/8, x10, x6, x7)

inst_159:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:272*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 272*FLEN/8, x10, x6, x7)

inst_160:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:274*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 274*FLEN/8, x10, x6, x7)

inst_161:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:276*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 276*FLEN/8, x10, x6, x7)

inst_162:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:278*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 278*FLEN/8, x10, x6, x7)

inst_163:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:280*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 280*FLEN/8, x10, x6, x7)

inst_164:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:282*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 282*FLEN/8, x10, x6, x7)

inst_165:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:284*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 284*FLEN/8, x10, x6, x7)

inst_166:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:286*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 286*FLEN/8, x10, x6, x7)

inst_167:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfffffffffffff; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:288*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 288*FLEN/8, x10, x6, x7)

inst_168:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0x0;
valaddr_reg:x9; val_offset:290*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 290*FLEN/8, x10, x6, x7)

inst_169:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:292*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 292*FLEN/8, x10, x6, x7)

inst_170:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0x1;
valaddr_reg:x9; val_offset:294*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 294*FLEN/8, x10, x6, x7)

inst_171:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:296*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 296*FLEN/8, x10, x6, x7)

inst_172:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0x2;
valaddr_reg:x9; val_offset:298*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 298*FLEN/8, x10, x6, x7)

inst_173:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:300*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 300*FLEN/8, x10, x6, x7)

inst_174:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:302*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 302*FLEN/8, x10, x6, x7)

inst_175:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:304*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 304*FLEN/8, x10, x6, x7)

inst_176:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:306*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 306*FLEN/8, x10, x6, x7)

inst_177:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:308*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 308*FLEN/8, x10, x6, x7)

inst_178:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:310*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 310*FLEN/8, x10, x6, x7)

inst_179:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:312*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 312*FLEN/8, x10, x6, x7)

inst_180:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:314*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 314*FLEN/8, x10, x6, x7)

inst_181:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:316*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 316*FLEN/8, x10, x6, x7)

inst_182:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:318*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 318*FLEN/8, x10, x6, x7)

inst_183:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:320*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 320*FLEN/8, x10, x6, x7)

inst_184:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:322*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 322*FLEN/8, x10, x6, x7)

inst_185:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:324*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 324*FLEN/8, x10, x6, x7)

inst_186:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:326*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 326*FLEN/8, x10, x6, x7)

inst_187:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:328*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 328*FLEN/8, x10, x6, x7)

inst_188:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:330*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 330*FLEN/8, x10, x6, x7)

inst_189:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:332*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 332*FLEN/8, x10, x6, x7)

inst_190:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:334*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 334*FLEN/8, x10, x6, x7)

inst_191:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800fffffffffffff; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:336*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 336*FLEN/8, x10, x6, x7)

inst_192:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0x0;
valaddr_reg:x9; val_offset:338*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 338*FLEN/8, x10, x6, x7)

inst_193:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:340*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 340*FLEN/8, x10, x6, x7)

inst_194:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0x1;
valaddr_reg:x9; val_offset:342*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 342*FLEN/8, x10, x6, x7)

inst_195:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:344*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 344*FLEN/8, x10, x6, x7)

inst_196:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0x2;
valaddr_reg:x9; val_offset:346*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 346*FLEN/8, x10, x6, x7)

inst_197:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:348*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 348*FLEN/8, x10, x6, x7)

inst_198:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:350*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 350*FLEN/8, x10, x6, x7)

inst_199:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:352*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 352*FLEN/8, x10, x6, x7)

inst_200:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:354*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 354*FLEN/8, x10, x6, x7)

inst_201:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:356*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 356*FLEN/8, x10, x6, x7)

inst_202:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:358*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 358*FLEN/8, x10, x6, x7)

inst_203:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:360*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 360*FLEN/8, x10, x6, x7)

inst_204:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:362*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 362*FLEN/8, x10, x6, x7)

inst_205:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:364*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 364*FLEN/8, x10, x6, x7)

inst_206:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:366*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 366*FLEN/8, x10, x6, x7)

inst_207:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:368*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 368*FLEN/8, x10, x6, x7)

inst_208:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:370*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 370*FLEN/8, x10, x6, x7)

inst_209:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:372*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 372*FLEN/8, x10, x6, x7)

inst_210:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:374*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 374*FLEN/8, x10, x6, x7)

inst_211:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:376*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 376*FLEN/8, x10, x6, x7)

inst_212:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:378*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 378*FLEN/8, x10, x6, x7)

inst_213:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:380*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 380*FLEN/8, x10, x6, x7)

inst_214:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:382*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 382*FLEN/8, x10, x6, x7)

inst_215:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000000; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:384*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 384*FLEN/8, x10, x6, x7)

inst_216:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0x0;
valaddr_reg:x9; val_offset:386*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 386*FLEN/8, x10, x6, x7)

inst_217:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:388*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 388*FLEN/8, x10, x6, x7)

inst_218:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0x1;
valaddr_reg:x9; val_offset:390*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 390*FLEN/8, x10, x6, x7)

inst_219:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:392*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 392*FLEN/8, x10, x6, x7)

inst_220:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0x2;
valaddr_reg:x9; val_offset:394*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 394*FLEN/8, x10, x6, x7)

inst_221:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:396*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 396*FLEN/8, x10, x6, x7)

inst_222:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:398*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 398*FLEN/8, x10, x6, x7)

inst_223:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:400*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 400*FLEN/8, x10, x6, x7)

inst_224:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:402*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 402*FLEN/8, x10, x6, x7)

inst_225:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:404*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 404*FLEN/8, x10, x6, x7)

inst_226:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:406*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 406*FLEN/8, x10, x6, x7)

inst_227:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:408*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 408*FLEN/8, x10, x6, x7)

inst_228:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:410*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 410*FLEN/8, x10, x6, x7)

inst_229:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:412*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 412*FLEN/8, x10, x6, x7)

inst_230:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:414*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 414*FLEN/8, x10, x6, x7)

inst_231:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:416*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 416*FLEN/8, x10, x6, x7)

inst_232:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:418*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 418*FLEN/8, x10, x6, x7)

inst_233:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:420*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 420*FLEN/8, x10, x6, x7)

inst_234:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:422*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 422*FLEN/8, x10, x6, x7)

inst_235:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:424*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 424*FLEN/8, x10, x6, x7)

inst_236:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:426*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 426*FLEN/8, x10, x6, x7)

inst_237:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:428*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 428*FLEN/8, x10, x6, x7)

inst_238:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:430*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 430*FLEN/8, x10, x6, x7)

inst_239:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000000; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:432*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 432*FLEN/8, x10, x6, x7)

inst_240:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0x0;
valaddr_reg:x9; val_offset:434*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 434*FLEN/8, x10, x6, x7)

inst_241:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:436*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 436*FLEN/8, x10, x6, x7)

inst_242:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0x1;
valaddr_reg:x9; val_offset:438*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 438*FLEN/8, x10, x6, x7)

inst_243:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:440*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 440*FLEN/8, x10, x6, x7)

inst_244:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0x2;
valaddr_reg:x9; val_offset:442*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 442*FLEN/8, x10, x6, x7)

inst_245:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:444*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 444*FLEN/8, x10, x6, x7)

inst_246:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:446*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 446*FLEN/8, x10, x6, x7)

inst_247:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:448*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 448*FLEN/8, x10, x6, x7)

inst_248:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:450*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 450*FLEN/8, x10, x6, x7)

inst_249:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:452*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 452*FLEN/8, x10, x6, x7)

inst_250:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:454*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 454*FLEN/8, x10, x6, x7)

inst_251:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:456*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 456*FLEN/8, x10, x6, x7)

inst_252:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:458*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 458*FLEN/8, x10, x6, x7)

inst_253:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:460*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 460*FLEN/8, x10, x6, x7)

inst_254:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:462*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 462*FLEN/8, x10, x6, x7)

inst_255:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:464*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 464*FLEN/8, x10, x6, x7)

inst_256:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:466*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 466*FLEN/8, x10, x6, x7)

inst_257:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:468*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 468*FLEN/8, x10, x6, x7)

inst_258:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:470*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 470*FLEN/8, x10, x6, x7)

inst_259:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:472*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 472*FLEN/8, x10, x6, x7)

inst_260:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:474*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 474*FLEN/8, x10, x6, x7)

inst_261:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:476*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 476*FLEN/8, x10, x6, x7)

inst_262:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:478*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 478*FLEN/8, x10, x6, x7)

inst_263:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x10000000000002; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:480*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 480*FLEN/8, x10, x6, x7)

inst_264:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0x0;
valaddr_reg:x9; val_offset:482*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 482*FLEN/8, x10, x6, x7)

inst_265:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:484*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 484*FLEN/8, x10, x6, x7)

inst_266:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0x1;
valaddr_reg:x9; val_offset:486*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 486*FLEN/8, x10, x6, x7)

inst_267:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:488*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 488*FLEN/8, x10, x6, x7)

inst_268:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0x2;
valaddr_reg:x9; val_offset:490*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 490*FLEN/8, x10, x6, x7)

inst_269:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:492*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 492*FLEN/8, x10, x6, x7)

inst_270:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:494*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 494*FLEN/8, x10, x6, x7)

inst_271:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:496*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 496*FLEN/8, x10, x6, x7)

inst_272:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:498*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 498*FLEN/8, x10, x6, x7)

inst_273:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:500*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 500*FLEN/8, x10, x6, x7)

inst_274:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:502*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 502*FLEN/8, x10, x6, x7)

inst_275:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:504*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 504*FLEN/8, x10, x6, x7)

inst_276:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:506*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 506*FLEN/8, x10, x6, x7)

inst_277:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:508*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 508*FLEN/8, x10, x6, x7)

inst_278:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:510*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 510*FLEN/8, x10, x6, x7)

inst_279:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:512*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 512*FLEN/8, x10, x6, x7)

inst_280:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:514*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 514*FLEN/8, x10, x6, x7)

inst_281:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:516*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 516*FLEN/8, x10, x6, x7)
RVTEST_SIGBASE(x6,signature_x6_2)

inst_282:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:518*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 518*FLEN/8, x10, x6, x7)

inst_283:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:520*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 520*FLEN/8, x10, x6, x7)

inst_284:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:522*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 522*FLEN/8, x10, x6, x7)

inst_285:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:524*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 524*FLEN/8, x10, x6, x7)

inst_286:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:526*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 526*FLEN/8, x10, x6, x7)

inst_287:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x0000000000002 and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8010000000000002; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:528*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 528*FLEN/8, x10, x6, x7)

inst_288:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0x0;
valaddr_reg:x9; val_offset:530*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 530*FLEN/8, x10, x6, x7)

inst_289:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:532*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 532*FLEN/8, x10, x6, x7)

inst_290:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0x1;
valaddr_reg:x9; val_offset:534*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 534*FLEN/8, x10, x6, x7)

inst_291:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:536*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 536*FLEN/8, x10, x6, x7)

inst_292:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0x2;
valaddr_reg:x9; val_offset:538*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 538*FLEN/8, x10, x6, x7)

inst_293:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:540*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 540*FLEN/8, x10, x6, x7)

inst_294:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:542*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 542*FLEN/8, x10, x6, x7)

inst_295:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:544*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 544*FLEN/8, x10, x6, x7)

inst_296:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:546*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 546*FLEN/8, x10, x6, x7)

inst_297:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:548*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 548*FLEN/8, x10, x6, x7)

inst_298:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:550*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 550*FLEN/8, x10, x6, x7)

inst_299:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:552*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 552*FLEN/8, x10, x6, x7)

inst_300:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:554*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 554*FLEN/8, x10, x6, x7)

inst_301:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:556*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 556*FLEN/8, x10, x6, x7)

inst_302:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:558*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 558*FLEN/8, x10, x6, x7)

inst_303:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:560*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 560*FLEN/8, x10, x6, x7)

inst_304:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:562*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 562*FLEN/8, x10, x6, x7)

inst_305:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:564*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 564*FLEN/8, x10, x6, x7)

inst_306:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:566*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 566*FLEN/8, x10, x6, x7)

inst_307:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:568*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 568*FLEN/8, x10, x6, x7)

inst_308:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:570*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 570*FLEN/8, x10, x6, x7)

inst_309:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:572*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 572*FLEN/8, x10, x6, x7)

inst_310:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:574*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 574*FLEN/8, x10, x6, x7)

inst_311:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fefffffffffffff; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:576*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 576*FLEN/8, x10, x6, x7)

inst_312:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0x0;
valaddr_reg:x9; val_offset:578*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 578*FLEN/8, x10, x6, x7)

inst_313:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:580*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 580*FLEN/8, x10, x6, x7)

inst_314:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0x1;
valaddr_reg:x9; val_offset:582*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 582*FLEN/8, x10, x6, x7)

inst_315:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:584*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 584*FLEN/8, x10, x6, x7)

inst_316:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0x2;
valaddr_reg:x9; val_offset:586*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 586*FLEN/8, x10, x6, x7)

inst_317:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:588*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 588*FLEN/8, x10, x6, x7)

inst_318:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:590*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 590*FLEN/8, x10, x6, x7)

inst_319:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:592*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 592*FLEN/8, x10, x6, x7)

inst_320:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:594*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 594*FLEN/8, x10, x6, x7)

inst_321:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:596*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 596*FLEN/8, x10, x6, x7)

inst_322:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:598*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 598*FLEN/8, x10, x6, x7)

inst_323:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:600*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 600*FLEN/8, x10, x6, x7)

inst_324:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:602*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 602*FLEN/8, x10, x6, x7)

inst_325:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:604*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 604*FLEN/8, x10, x6, x7)

inst_326:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:606*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 606*FLEN/8, x10, x6, x7)

inst_327:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:608*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 608*FLEN/8, x10, x6, x7)

inst_328:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:610*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 610*FLEN/8, x10, x6, x7)

inst_329:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:612*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 612*FLEN/8, x10, x6, x7)

inst_330:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:614*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 614*FLEN/8, x10, x6, x7)

inst_331:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:616*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 616*FLEN/8, x10, x6, x7)

inst_332:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:618*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 618*FLEN/8, x10, x6, x7)

inst_333:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:620*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 620*FLEN/8, x10, x6, x7)

inst_334:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:622*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 622*FLEN/8, x10, x6, x7)

inst_335:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xfffffffffffff and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffefffffffffffff; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:624*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 624*FLEN/8, x10, x6, x7)

inst_336:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x0;
valaddr_reg:x9; val_offset:626*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 626*FLEN/8, x10, x6, x7)

inst_337:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:628*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 628*FLEN/8, x10, x6, x7)

inst_338:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x1;
valaddr_reg:x9; val_offset:630*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 630*FLEN/8, x10, x6, x7)

inst_339:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:632*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 632*FLEN/8, x10, x6, x7)

inst_340:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x2;
valaddr_reg:x9; val_offset:634*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 634*FLEN/8, x10, x6, x7)

inst_341:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:636*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 636*FLEN/8, x10, x6, x7)

inst_342:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:638*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 638*FLEN/8, x10, x6, x7)

inst_343:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:640*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 640*FLEN/8, x10, x6, x7)

inst_344:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:642*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 642*FLEN/8, x10, x6, x7)

inst_345:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:644*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 644*FLEN/8, x10, x6, x7)

inst_346:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:646*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 646*FLEN/8, x10, x6, x7)

inst_347:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:648*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 648*FLEN/8, x10, x6, x7)

inst_348:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:650*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 650*FLEN/8, x10, x6, x7)

inst_349:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:652*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 652*FLEN/8, x10, x6, x7)

inst_350:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:654*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 654*FLEN/8, x10, x6, x7)

inst_351:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:656*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 656*FLEN/8, x10, x6, x7)

inst_352:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:658*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 658*FLEN/8, x10, x6, x7)

inst_353:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:660*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 660*FLEN/8, x10, x6, x7)

inst_354:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:662*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 662*FLEN/8, x10, x6, x7)

inst_355:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:664*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 664*FLEN/8, x10, x6, x7)

inst_356:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:666*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 666*FLEN/8, x10, x6, x7)

inst_357:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:668*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 668*FLEN/8, x10, x6, x7)

inst_358:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:670*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 670*FLEN/8, x10, x6, x7)

inst_359:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:672*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 672*FLEN/8, x10, x6, x7)

inst_360:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x0;
valaddr_reg:x9; val_offset:674*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 674*FLEN/8, x10, x6, x7)

inst_361:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:676*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 676*FLEN/8, x10, x6, x7)

inst_362:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x1;
valaddr_reg:x9; val_offset:678*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 678*FLEN/8, x10, x6, x7)

inst_363:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:680*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 680*FLEN/8, x10, x6, x7)

inst_364:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x2;
valaddr_reg:x9; val_offset:682*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 682*FLEN/8, x10, x6, x7)

inst_365:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:684*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 684*FLEN/8, x10, x6, x7)

inst_366:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:686*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 686*FLEN/8, x10, x6, x7)

inst_367:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:688*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 688*FLEN/8, x10, x6, x7)

inst_368:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:690*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 690*FLEN/8, x10, x6, x7)

inst_369:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:692*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 692*FLEN/8, x10, x6, x7)

inst_370:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:694*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 694*FLEN/8, x10, x6, x7)

inst_371:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:696*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 696*FLEN/8, x10, x6, x7)

inst_372:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:698*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 698*FLEN/8, x10, x6, x7)

inst_373:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:700*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 700*FLEN/8, x10, x6, x7)

inst_374:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:702*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 702*FLEN/8, x10, x6, x7)

inst_375:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:704*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 704*FLEN/8, x10, x6, x7)

inst_376:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:706*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 706*FLEN/8, x10, x6, x7)

inst_377:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:708*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 708*FLEN/8, x10, x6, x7)

inst_378:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:710*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 710*FLEN/8, x10, x6, x7)

inst_379:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:712*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 712*FLEN/8, x10, x6, x7)

inst_380:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:714*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 714*FLEN/8, x10, x6, x7)

inst_381:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:716*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 716*FLEN/8, x10, x6, x7)

inst_382:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:718*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 718*FLEN/8, x10, x6, x7)

inst_383:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:720*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 720*FLEN/8, x10, x6, x7)

inst_384:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0x0;
valaddr_reg:x9; val_offset:722*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 722*FLEN/8, x10, x6, x7)

inst_385:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:724*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 724*FLEN/8, x10, x6, x7)

inst_386:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0x1;
valaddr_reg:x9; val_offset:726*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 726*FLEN/8, x10, x6, x7)

inst_387:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:728*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 728*FLEN/8, x10, x6, x7)

inst_388:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0x2;
valaddr_reg:x9; val_offset:730*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 730*FLEN/8, x10, x6, x7)

inst_389:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:732*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 732*FLEN/8, x10, x6, x7)

inst_390:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:734*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 734*FLEN/8, x10, x6, x7)

inst_391:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:736*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 736*FLEN/8, x10, x6, x7)

inst_392:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:738*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 738*FLEN/8, x10, x6, x7)

inst_393:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:740*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 740*FLEN/8, x10, x6, x7)

inst_394:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:742*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 742*FLEN/8, x10, x6, x7)

inst_395:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:744*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 744*FLEN/8, x10, x6, x7)

inst_396:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:746*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 746*FLEN/8, x10, x6, x7)

inst_397:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:748*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 748*FLEN/8, x10, x6, x7)

inst_398:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:750*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 750*FLEN/8, x10, x6, x7)

inst_399:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:752*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 752*FLEN/8, x10, x6, x7)

inst_400:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:754*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 754*FLEN/8, x10, x6, x7)

inst_401:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:756*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 756*FLEN/8, x10, x6, x7)

inst_402:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:758*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 758*FLEN/8, x10, x6, x7)

inst_403:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:760*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 760*FLEN/8, x10, x6, x7)

inst_404:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:762*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 762*FLEN/8, x10, x6, x7)

inst_405:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:764*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 764*FLEN/8, x10, x6, x7)

inst_406:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:766*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 766*FLEN/8, x10, x6, x7)

inst_407:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000000; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:768*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 768*FLEN/8, x10, x6, x7)

inst_408:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0x0;
valaddr_reg:x9; val_offset:770*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 770*FLEN/8, x10, x6, x7)

inst_409:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:772*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 772*FLEN/8, x10, x6, x7)
RVTEST_SIGBASE(x6,signature_x6_3)

inst_410:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0x1;
valaddr_reg:x9; val_offset:774*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 774*FLEN/8, x10, x6, x7)

inst_411:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:776*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 776*FLEN/8, x10, x6, x7)

inst_412:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0x2;
valaddr_reg:x9; val_offset:778*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 778*FLEN/8, x10, x6, x7)

inst_413:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:780*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 780*FLEN/8, x10, x6, x7)

inst_414:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:782*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 782*FLEN/8, x10, x6, x7)

inst_415:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:784*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 784*FLEN/8, x10, x6, x7)

inst_416:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:786*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 786*FLEN/8, x10, x6, x7)

inst_417:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:788*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 788*FLEN/8, x10, x6, x7)

inst_418:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:790*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 790*FLEN/8, x10, x6, x7)

inst_419:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:792*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 792*FLEN/8, x10, x6, x7)

inst_420:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:794*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 794*FLEN/8, x10, x6, x7)

inst_421:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:796*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 796*FLEN/8, x10, x6, x7)

inst_422:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:798*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 798*FLEN/8, x10, x6, x7)

inst_423:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:800*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 800*FLEN/8, x10, x6, x7)

inst_424:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:802*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 802*FLEN/8, x10, x6, x7)

inst_425:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:804*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 804*FLEN/8, x10, x6, x7)

inst_426:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:806*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 806*FLEN/8, x10, x6, x7)

inst_427:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:808*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 808*FLEN/8, x10, x6, x7)

inst_428:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:810*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 810*FLEN/8, x10, x6, x7)

inst_429:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:812*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 812*FLEN/8, x10, x6, x7)

inst_430:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:814*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 814*FLEN/8, x10, x6, x7)

inst_431:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000000 and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000000; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:816*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 816*FLEN/8, x10, x6, x7)

inst_432:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0x0;
valaddr_reg:x9; val_offset:818*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 818*FLEN/8, x10, x6, x7)

inst_433:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:820*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 820*FLEN/8, x10, x6, x7)

inst_434:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0x1;
valaddr_reg:x9; val_offset:822*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 822*FLEN/8, x10, x6, x7)

inst_435:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:824*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 824*FLEN/8, x10, x6, x7)

inst_436:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0x2;
valaddr_reg:x9; val_offset:826*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 826*FLEN/8, x10, x6, x7)

inst_437:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:828*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 828*FLEN/8, x10, x6, x7)

inst_438:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:830*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 830*FLEN/8, x10, x6, x7)

inst_439:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:832*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 832*FLEN/8, x10, x6, x7)

inst_440:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:834*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 834*FLEN/8, x10, x6, x7)

inst_441:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:836*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 836*FLEN/8, x10, x6, x7)

inst_442:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:838*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 838*FLEN/8, x10, x6, x7)

inst_443:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:840*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 840*FLEN/8, x10, x6, x7)

inst_444:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:842*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 842*FLEN/8, x10, x6, x7)

inst_445:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:844*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 844*FLEN/8, x10, x6, x7)

inst_446:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:846*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 846*FLEN/8, x10, x6, x7)

inst_447:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:848*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 848*FLEN/8, x10, x6, x7)

inst_448:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:850*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 850*FLEN/8, x10, x6, x7)

inst_449:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:852*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 852*FLEN/8, x10, x6, x7)

inst_450:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:854*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 854*FLEN/8, x10, x6, x7)

inst_451:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:856*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 856*FLEN/8, x10, x6, x7)

inst_452:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:858*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 858*FLEN/8, x10, x6, x7)

inst_453:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:860*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 860*FLEN/8, x10, x6, x7)

inst_454:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:862*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 862*FLEN/8, x10, x6, x7)

inst_455:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff8000000000001; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:864*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 864*FLEN/8, x10, x6, x7)

inst_456:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0x0;
valaddr_reg:x9; val_offset:866*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 866*FLEN/8, x10, x6, x7)

inst_457:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:868*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 868*FLEN/8, x10, x6, x7)

inst_458:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0x1;
valaddr_reg:x9; val_offset:870*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 870*FLEN/8, x10, x6, x7)

inst_459:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:872*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 872*FLEN/8, x10, x6, x7)

inst_460:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0x2;
valaddr_reg:x9; val_offset:874*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 874*FLEN/8, x10, x6, x7)

inst_461:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:876*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 876*FLEN/8, x10, x6, x7)

inst_462:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:878*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 878*FLEN/8, x10, x6, x7)

inst_463:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:880*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 880*FLEN/8, x10, x6, x7)

inst_464:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:882*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 882*FLEN/8, x10, x6, x7)

inst_465:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:884*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 884*FLEN/8, x10, x6, x7)

inst_466:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:886*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 886*FLEN/8, x10, x6, x7)

inst_467:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:888*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 888*FLEN/8, x10, x6, x7)

inst_468:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:890*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 890*FLEN/8, x10, x6, x7)

inst_469:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:892*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 892*FLEN/8, x10, x6, x7)

inst_470:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:894*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 894*FLEN/8, x10, x6, x7)

inst_471:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:896*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 896*FLEN/8, x10, x6, x7)

inst_472:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:898*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 898*FLEN/8, x10, x6, x7)

inst_473:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:900*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 900*FLEN/8, x10, x6, x7)

inst_474:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:902*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 902*FLEN/8, x10, x6, x7)

inst_475:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:904*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 904*FLEN/8, x10, x6, x7)

inst_476:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:906*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 906*FLEN/8, x10, x6, x7)

inst_477:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:908*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 908*FLEN/8, x10, x6, x7)

inst_478:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:910*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 910*FLEN/8, x10, x6, x7)

inst_479:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x8000000000001 and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff8000000000001; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:912*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 912*FLEN/8, x10, x6, x7)

inst_480:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0x0;
valaddr_reg:x9; val_offset:914*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 914*FLEN/8, x10, x6, x7)

inst_481:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:916*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 916*FLEN/8, x10, x6, x7)

inst_482:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0x1;
valaddr_reg:x9; val_offset:918*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 918*FLEN/8, x10, x6, x7)

inst_483:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:920*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 920*FLEN/8, x10, x6, x7)

inst_484:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0x2;
valaddr_reg:x9; val_offset:922*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 922*FLEN/8, x10, x6, x7)

inst_485:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:924*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 924*FLEN/8, x10, x6, x7)

inst_486:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:926*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 926*FLEN/8, x10, x6, x7)

inst_487:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:928*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 928*FLEN/8, x10, x6, x7)

inst_488:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:930*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 930*FLEN/8, x10, x6, x7)

inst_489:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:932*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 932*FLEN/8, x10, x6, x7)

inst_490:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:934*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 934*FLEN/8, x10, x6, x7)

inst_491:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:936*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 936*FLEN/8, x10, x6, x7)

inst_492:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:938*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 938*FLEN/8, x10, x6, x7)

inst_493:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:940*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 940*FLEN/8, x10, x6, x7)

inst_494:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:942*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 942*FLEN/8, x10, x6, x7)

inst_495:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:944*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 944*FLEN/8, x10, x6, x7)

inst_496:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:946*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 946*FLEN/8, x10, x6, x7)

inst_497:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:948*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 948*FLEN/8, x10, x6, x7)

inst_498:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:950*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 950*FLEN/8, x10, x6, x7)

inst_499:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:952*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 952*FLEN/8, x10, x6, x7)

inst_500:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:954*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 954*FLEN/8, x10, x6, x7)

inst_501:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:956*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 956*FLEN/8, x10, x6, x7)

inst_502:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:958*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 958*FLEN/8, x10, x6, x7)

inst_503:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000001; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:960*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 960*FLEN/8, x10, x6, x7)

inst_504:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0x0;
valaddr_reg:x9; val_offset:962*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 962*FLEN/8, x10, x6, x7)

inst_505:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:964*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 964*FLEN/8, x10, x6, x7)

inst_506:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0x1;
valaddr_reg:x9; val_offset:966*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 966*FLEN/8, x10, x6, x7)

inst_507:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:968*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 968*FLEN/8, x10, x6, x7)

inst_508:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0x2;
valaddr_reg:x9; val_offset:970*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 970*FLEN/8, x10, x6, x7)

inst_509:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:972*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 972*FLEN/8, x10, x6, x7)

inst_510:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:974*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 974*FLEN/8, x10, x6, x7)

inst_511:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:976*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 976*FLEN/8, x10, x6, x7)

inst_512:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:978*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 978*FLEN/8, x10, x6, x7)

inst_513:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:980*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 980*FLEN/8, x10, x6, x7)

inst_514:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:982*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 982*FLEN/8, x10, x6, x7)

inst_515:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:984*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 984*FLEN/8, x10, x6, x7)

inst_516:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:986*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 986*FLEN/8, x10, x6, x7)

inst_517:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:988*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 988*FLEN/8, x10, x6, x7)

inst_518:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:990*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 990*FLEN/8, x10, x6, x7)

inst_519:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:992*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 992*FLEN/8, x10, x6, x7)

inst_520:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:994*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 994*FLEN/8, x10, x6, x7)

inst_521:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:996*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 996*FLEN/8, x10, x6, x7)

inst_522:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:998*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 998*FLEN/8, x10, x6, x7)

inst_523:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:1000*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1000*FLEN/8, x10, x6, x7)

inst_524:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:1002*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1002*FLEN/8, x10, x6, x7)

inst_525:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:1004*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1004*FLEN/8, x10, x6, x7)

inst_526:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:1006*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1006*FLEN/8, x10, x6, x7)

inst_527:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000001 and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000001; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:1008*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1008*FLEN/8, x10, x6, x7)

inst_528:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0x0;
valaddr_reg:x9; val_offset:1010*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1010*FLEN/8, x10, x6, x7)

inst_529:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:1012*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1012*FLEN/8, x10, x6, x7)

inst_530:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0x1;
valaddr_reg:x9; val_offset:1014*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1014*FLEN/8, x10, x6, x7)

inst_531:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:1016*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1016*FLEN/8, x10, x6, x7)

inst_532:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0x2;
valaddr_reg:x9; val_offset:1018*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1018*FLEN/8, x10, x6, x7)

inst_533:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:1020*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1020*FLEN/8, x10, x6, x7)

inst_534:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:1022*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1022*FLEN/8, x10, x6, x7)

inst_535:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:1024*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1024*FLEN/8, x10, x6, x7)

inst_536:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:1026*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1026*FLEN/8, x10, x6, x7)

inst_537:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:1028*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1028*FLEN/8, x10, x6, x7)
RVTEST_SIGBASE(x6,signature_x6_4)

inst_538:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:1030*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1030*FLEN/8, x10, x6, x7)

inst_539:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:1032*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1032*FLEN/8, x10, x6, x7)

inst_540:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:1034*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1034*FLEN/8, x10, x6, x7)

inst_541:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:1036*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1036*FLEN/8, x10, x6, x7)

inst_542:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:1038*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1038*FLEN/8, x10, x6, x7)

inst_543:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:1040*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1040*FLEN/8, x10, x6, x7)

inst_544:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:1042*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1042*FLEN/8, x10, x6, x7)

inst_545:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:1044*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1044*FLEN/8, x10, x6, x7)

inst_546:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:1046*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1046*FLEN/8, x10, x6, x7)

inst_547:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:1048*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1048*FLEN/8, x10, x6, x7)

inst_548:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:1050*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1050*FLEN/8, x10, x6, x7)

inst_549:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:1052*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1052*FLEN/8, x10, x6, x7)

inst_550:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:1054*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1054*FLEN/8, x10, x6, x7)

inst_551:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff0000000000000; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:1056*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1056*FLEN/8, x10, x6, x7)

inst_552:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0x0;
valaddr_reg:x9; val_offset:1058*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1058*FLEN/8, x10, x6, x7)

inst_553:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:1060*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1060*FLEN/8, x10, x6, x7)

inst_554:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0x1;
valaddr_reg:x9; val_offset:1062*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1062*FLEN/8, x10, x6, x7)

inst_555:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0x8000000000000001;
valaddr_reg:x9; val_offset:1064*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1064*FLEN/8, x10, x6, x7)

inst_556:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0x2;
valaddr_reg:x9; val_offset:1066*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1066*FLEN/8, x10, x6, x7)

inst_557:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0x8000000000000002;
valaddr_reg:x9; val_offset:1068*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1068*FLEN/8, x10, x6, x7)

inst_558:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0xfffffffffffff;
valaddr_reg:x9; val_offset:1070*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1070*FLEN/8, x10, x6, x7)

inst_559:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0x800fffffffffffff;
valaddr_reg:x9; val_offset:1072*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1072*FLEN/8, x10, x6, x7)

inst_560:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0x10000000000000;
valaddr_reg:x9; val_offset:1074*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1074*FLEN/8, x10, x6, x7)

inst_561:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:1076*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1076*FLEN/8, x10, x6, x7)

inst_562:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0x10000000000002;
valaddr_reg:x9; val_offset:1078*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1078*FLEN/8, x10, x6, x7)

inst_563:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000002 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0x8010000000000002;
valaddr_reg:x9; val_offset:1080*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1080*FLEN/8, x10, x6, x7)

inst_564:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0x7fefffffffffffff;
valaddr_reg:x9; val_offset:1082*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1082*FLEN/8, x10, x6, x7)

inst_565:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xfffffffffffff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0xffefffffffffffff;
valaddr_reg:x9; val_offset:1084*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1084*FLEN/8, x10, x6, x7)

inst_566:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:1086*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1086*FLEN/8, x10, x6, x7)

inst_567:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:1088*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1088*FLEN/8, x10, x6, x7)

inst_568:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0x7ff8000000000000;
valaddr_reg:x9; val_offset:1090*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1090*FLEN/8, x10, x6, x7)

inst_569:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0xfff8000000000000;
valaddr_reg:x9; val_offset:1092*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1092*FLEN/8, x10, x6, x7)

inst_570:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0x7ff8000000000001;
valaddr_reg:x9; val_offset:1094*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1094*FLEN/8, x10, x6, x7)

inst_571:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x8000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0xfff8000000000001;
valaddr_reg:x9; val_offset:1096*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1096*FLEN/8, x10, x6, x7)

inst_572:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0x7ff0000000000001;
valaddr_reg:x9; val_offset:1098*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1098*FLEN/8, x10, x6, x7)

inst_573:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000001 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0xfff0000000000001;
valaddr_reg:x9; val_offset:1100*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1100*FLEN/8, x10, x6, x7)

inst_574:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0x3ff0000000000000;
valaddr_reg:x9; val_offset:1102*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1102*FLEN/8, x10, x6, x7)

inst_575:// fs1 == 1 and fe1 == 0x3f8 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x3f8 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbf80000000000000; op2val:0xbf80000000000000;
valaddr_reg:x9; val_offset:1104*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1104*FLEN/8, x10, x6, x7)

inst_576:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x8000000000000000;
valaddr_reg:x9; val_offset:1106*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1106*FLEN/8, x10, x6, x7)

inst_577:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000000000000000; op2val:0x8010000000000000;
valaddr_reg:x9; val_offset:1108*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1108*FLEN/8, x10, x6, x7)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
test_dataset_0:
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
test_dataset_1:
NAN_BOXED(0,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(1,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(9223372036854775809,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(2,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(9223372036854775810,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(4503599627370495,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(9227875636482146303,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(4503599627370496,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(4503599627370498,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(9227875636482146306,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(9218868437227405311,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(18442240474082181119,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(9221120237041090560,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(18444492273895866368,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(9221120237041090561,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(18444492273895866369,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(9218868437227405313,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(18442240474082181121,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(4607182418800017408,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(13799029258263199744,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9223372036854775808,64,FLEN)
NAN_BOXED(9227875636482146304,64,FLEN)
RVTEST_DATA_END

RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;



signature_x1_0:
    .fill 0*((SIGALIGN)/4),4,0xdeadbeef


signature_x1_1:
    .fill 52*((SIGALIGN)/4),4,0xdeadbeef


signature_x6_0:
    .fill 256*((SIGALIGN)/4),4,0xdeadbeef


signature_x6_1:
    .fill 256*((SIGALIGN)/4),4,0xdeadbeef


signature_x6_2:
    .fill 256*((SIGALIGN)/4),4,0xdeadbeef


signature_x6_3:
    .fill 256*((SIGALIGN)/4),4,0xdeadbeef


signature_x6_4:
    .fill 80*((SIGALIGN)/4),4,0xdeadbeef

#ifdef rvtest_mtrap_routine
tsig_begin_canary:
CANARY;

mtrap_sigptr:
    .fill 64*XLEN/32,4,0xdeadbeef

tsig_end_canary:
CANARY;
#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*XLEN/32,4,0xdeadbeef

#endif


sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
