
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.10.3
// timestamp : Mon May 22 12:14:28 2023 GMT
// usage     : riscv_ctg \
//                  -- cgf //                  --cgf /home/cm/src/riscv-ctg/zfa/sample_cgfs/dataset.cgf \
//                  --cgf /home/cm/src/riscv-ctg/zfa/sample_cgfs/zfa/fleq.d.cgf \
 \
//                  -- xlen 32  \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the fleq.d instruction of the RISC-V RV32FD_Zicsr_Zfa,RV64FD_Zicsr_Zfa extension for the fleq.d_b19 covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IFD_Zicsr_Zfa,RV64IFD_Zicsr_Zfa")

.section .text.init
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*I.*D.*Zfa.*);def TEST_CASE_1=True;",fleq.d_b19)

RVTEST_FP_ENABLE()
RVTEST_VALBASEUPD(x3,test_dataset_0)
RVTEST_SIGBASE(x1,signature_x1_1)

inst_0:// rs1 != rs2, rs1==f31, rs2==f30, rd==x31,fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fce759ff97b7507; op2val:0x7fce759ff97b7507;
valaddr_reg:x3; val_offset:0*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x3, 0*FLEN/8, x4, x1, x2)

inst_1:// rs1 == rs2, rs1==f29, rs2==f29, rd==x30,fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f29; op2:f29; dest:x30; op1val:0x7fce759ff97b7507; op2val:0x7fce759ff97b7507;
valaddr_reg:x3; val_offset:2*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x30, f29, f29, 0, 0, x3, 2*FLEN/8, x4, x1, x2)

inst_2:// rs1==f30, rs2==f31, rd==x29,fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0x004b878423be8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f30; op2:f31; dest:x29; op1val:0x7ff0000000000000; op2val:0x7fb004b878423be8;
valaddr_reg:x3; val_offset:4*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x29, f30, f31, 0, 0, x3, 4*FLEN/8, x4, x1, x2)

inst_3:// rs1==f28, rs2==f27, rd==x28,fs1 == 0 and fe1 == 0x7fb and fm1 == 0x004b878423be8 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f28; op2:f27; dest:x28; op1val:0x7fb004b878423be8; op2val:0x7ff0000000000000;
valaddr_reg:x3; val_offset:6*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x28, f28, f27, 0, 0, x3, 6*FLEN/8, x4, x1, x2)

inst_4:// rs1==f27, rs2==f28, rd==x27,fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f27; op2:f28; dest:x27; op1val:0x7ff0000000000000; op2val:0x7fe405e69652cae2;
valaddr_reg:x3; val_offset:8*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x27, f27, f28, 0, 0, x3, 8*FLEN/8, x4, x1, x2)

inst_5:// rs1==f26, rs2==f25, rd==x26,fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f26; op2:f25; dest:x26; op1val:0x7fce759ff97b7507; op2val:0x7ff0000000000000;
valaddr_reg:x3; val_offset:10*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x26, f26, f25, 0, 0, x3, 10*FLEN/8, x4, x1, x2)

inst_6:// rs1==f25, rs2==f26, rd==x25,fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f25; op2:f26; dest:x25; op1val:0x7fce759ff97b7507; op2val:0x7fd09941946801c5;
valaddr_reg:x3; val_offset:12*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x25, f25, f26, 0, 0, x3, 12*FLEN/8, x4, x1, x2)

inst_7:// rs1==f24, rs2==f23, rd==x24,fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f24; op2:f23; dest:x24; op1val:0x7fd09941946801c5; op2val:0x7fce759ff97b7507;
valaddr_reg:x3; val_offset:14*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x24, f24, f23, 0, 0, x3, 14*FLEN/8, x4, x1, x2)

inst_8:// rs1==f23, rs2==f24, rd==x23,fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f23; op2:f24; dest:x23; op1val:0x7fce759ff97b7507; op2val:0x7feac44ace32d282;
valaddr_reg:x3; val_offset:16*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x23, f23, f24, 0, 0, x3, 16*FLEN/8, x4, x1, x2)

inst_9:// rs1==f22, rs2==f21, rd==x22,fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0x569d571c24201 and  fcsr == 0  
/* opcode: fleq.d ; op1:f22; op2:f21; dest:x22; op1val:0x7ff0000000000000; op2val:0x7fb569d571c24201;
valaddr_reg:x3; val_offset:18*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x22, f22, f21, 0, 0, x3, 18*FLEN/8, x4, x1, x2)

inst_10:// rs1==f21, rs2==f22, rd==x21,fs1 == 0 and fe1 == 0x7fb and fm1 == 0x569d571c24201 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f21; op2:f22; dest:x21; op1val:0x7fb569d571c24201; op2val:0x7ff0000000000000;
valaddr_reg:x3; val_offset:20*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x21, f21, f22, 0, 0, x3, 20*FLEN/8, x4, x1, x2)

inst_11:// rs1==f20, rs2==f19, rd==x20,fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f20; op2:f19; dest:x20; op1val:0x7ff0000000000000; op2val:0x7feac44ace32d282;
valaddr_reg:x3; val_offset:22*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x20, f20, f19, 0, 0, x3, 22*FLEN/8, x4, x1, x2)

inst_12:// rs1==f19, rs2==f20, rd==x19,fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f19; op2:f20; dest:x19; op1val:0x7fce759ff97b7507; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x3; val_offset:24*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x19, f19, f20, 0, 0, x3, 24*FLEN/8, x4, x1, x2)

inst_13:// rs1==f18, rs2==f17, rd==x18,fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0x0409f707c3583 and  fcsr == 0  
/* opcode: fleq.d ; op1:f18; op2:f17; dest:x18; op1val:0x7ff0000000000000; op2val:0x7fb0409f707c3583;
valaddr_reg:x3; val_offset:26*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x18, f18, f17, 0, 0, x3, 26*FLEN/8, x4, x1, x2)

inst_14:// rs1==f17, rs2==f18, rd==x17,fs1 == 0 and fe1 == 0x7fb and fm1 == 0x0409f707c3583 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f17; op2:f18; dest:x17; op1val:0x7fb0409f707c3583; op2val:0x7ff0000000000000;
valaddr_reg:x3; val_offset:28*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x17, f17, f18, 0, 0, x3, 28*FLEN/8, x4, x1, x2)

inst_15:// rs1==f16, rs2==f15, rd==x16,fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f16; op2:f15; dest:x16; op1val:0x7ff0000000000000; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x3; val_offset:30*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x16, f16, f15, 0, 0, x3, 30*FLEN/8, x4, x1, x2)

inst_16:// rs1==f15, rs2==f16, rd==x15,fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f15; op2:f16; dest:x15; op1val:0x7fce759ff97b7507; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x3; val_offset:32*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x15, f15, f16, 0, 0, x3, 32*FLEN/8, x4, x1, x2)

inst_17:// rs1==f14, rs2==f13, rd==x14,fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f14; op2:f13; dest:x14; op1val:0xffdd2b592ef4e4e6; op2val:0x7fce759ff97b7507;
valaddr_reg:x3; val_offset:34*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x14, f14, f13, 0, 0, x3, 34*FLEN/8, x4, x1, x2)

inst_18:// rs1==f13, rs2==f14, rd==x13,fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f13; op2:f14; dest:x13; op1val:0x7fce759ff97b7507; op2val:0xffede7300593ddb7;
valaddr_reg:x3; val_offset:36*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x13, f13, f14, 0, 0, x3, 36*FLEN/8, x4, x1, x2)

inst_19:// rs1==f12, rs2==f11, rd==x12,fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7fb and fm2 == 0x7ec266adcb15f and  fcsr == 0  
/* opcode: fleq.d ; op1:f12; op2:f11; dest:x12; op1val:0x7ff0000000000000; op2val:0xffb7ec266adcb15f;
valaddr_reg:x3; val_offset:38*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x12, f12, f11, 0, 0, x3, 38*FLEN/8, x4, x1, x2)

inst_20:// rs1==f11, rs2==f12, rd==x11,fs1 == 1 and fe1 == 0x7fb and fm1 == 0x7ec266adcb15f and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f11; op2:f12; dest:x11; op1val:0xffb7ec266adcb15f; op2val:0x7ff0000000000000;
valaddr_reg:x3; val_offset:40*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x11, f11, f12, 0, 0, x3, 40*FLEN/8, x4, x1, x2)

inst_21:// rs1==f10, rs2==f9, rd==x10,fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f10; op2:f9; dest:x10; op1val:0x7ff0000000000000; op2val:0xffede7300593ddb7;
valaddr_reg:x3; val_offset:42*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x10, f10, f9, 0, 0, x3, 42*FLEN/8, x4, x1, x2)

inst_22:// rs1==f9, rs2==f10, rd==x9,fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f9; op2:f10; dest:x9; op1val:0x7fce759ff97b7507; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x3; val_offset:44*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x9, f9, f10, 0, 0, x3, 44*FLEN/8, x4, x1, x2)
RVTEST_VALBASEUPD(x9,test_dataset_1)

inst_23:// rs1==f8, rs2==f7, rd==x8,fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7fb and fm2 == 0x399e37c2fb926 and  fcsr == 0  
/* opcode: fleq.d ; op1:f8; op2:f7; dest:x8; op1val:0x7ff0000000000000; op2val:0xffb399e37c2fb926;
valaddr_reg:x9; val_offset:0*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x8, f8, f7, 0, 0, x9, 0*FLEN/8, x10, x1, x2)

inst_24:// rs1==f7, rs2==f8, rd==x7,fs1 == 1 and fe1 == 0x7fb and fm1 == 0x399e37c2fb926 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f7; op2:f8; dest:x7; op1val:0xffb399e37c2fb926; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:2*FLEN/8; correctval:??; testreg:x2;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x7, f7, f8, 0, 0, x9, 2*FLEN/8, x10, x1, x2)

inst_25:// rs1==f6, rs2==f5, rd==x6,fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f6; op2:f5; dest:x6; op1val:0x7ff0000000000000; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:4*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x6, f6, f5, 0, 0, x9, 4*FLEN/8, x10, x1, x7)
RVTEST_SIGBASE(x6,signature_x6_0)

inst_26:// rs1==f5, rs2==f6, rd==x5,fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f5; op2:f6; dest:x5; op1val:0x7fce759ff97b7507; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:6*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x5, f5, f6, 0, 0, x9, 6*FLEN/8, x10, x6, x7)

inst_27:// rs1==f4, rs2==f3, rd==x4,fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f4; op2:f3; dest:x4; op1val:0xffe0c1b6ea69558e; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:8*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x4, f4, f3, 0, 0, x9, 8*FLEN/8, x10, x6, x7)

inst_28:// rs1==f3, rs2==f4, rd==x3,fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f3; op2:f4; dest:x3; op1val:0x7fce759ff97b7507; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:10*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x3, f3, f4, 0, 0, x9, 10*FLEN/8, x10, x6, x7)

inst_29:// rs1==f2, rs2==f1, rd==x2,fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f2; op2:f1; dest:x2; op1val:0xffc0e3e4312fc728; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:12*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x2, f2, f1, 0, 0, x9, 12*FLEN/8, x10, x6, x7)

inst_30:// rs1==f1, rs2==f2, rd==x1,fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f1; op2:f2; dest:x1; op1val:0x7fce759ff97b7507; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:14*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x1, f1, f2, 0, 0, x9, 14*FLEN/8, x10, x6, x7)

inst_31:// rs1==f0,fs1 == 0 and fe1 == 0x000 and fm1 == 0x3137cb6875068 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0xd4e5c31a3975f and  fcsr == 0  
/* opcode: fleq.d ; op1:f0; op2:f31; dest:x31; op1val:0x3137cb6875068; op2val:0x7fdd4e5c31a3975f;
valaddr_reg:x9; val_offset:16*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f0, f31, 0, 0, x9, 16*FLEN/8, x10, x6, x7)

inst_32:// rs2==f0,fs1 == 0 and fe1 == 0x7fd and fm1 == 0xd4e5c31a3975f and fs2 == 0 and fe2 == 0x000 and fm2 == 0x3137cb6875068 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f0; dest:x31; op1val:0x7fdd4e5c31a3975f; op2val:0x3137cb6875068;
valaddr_reg:x9; val_offset:18*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f0, 0, 0, x9, 18*FLEN/8, x10, x6, x7)

inst_33:// rd==x0,fs1 == 0 and fe1 == 0x000 and fm1 == 0x3137cb6875068 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x0; op1val:0x3137cb6875068; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:20*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x0, f31, f30, 0, 0, x9, 20*FLEN/8, x10, x6, x7)

inst_34:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x3137cb6875068 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fce759ff97b7507; op2val:0x3137cb6875068;
valaddr_reg:x9; val_offset:22*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 22*FLEN/8, x10, x6, x7)

inst_35:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fce759ff97b7507; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:24*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 24*FLEN/8, x10, x6, x7)

inst_36:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x04ebfabda54d7 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0x4dcb3b62b25ff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x4ebfabda54d7; op2val:0x7fc4dcb3b62b25ff;
valaddr_reg:x9; val_offset:26*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 26*FLEN/8, x10, x6, x7)

inst_37:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0x4dcb3b62b25ff and fs2 == 0 and fe2 == 0x000 and fm2 == 0x04ebfabda54d7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fc4dcb3b62b25ff; op2val:0x4ebfabda54d7;
valaddr_reg:x9; val_offset:28*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 28*FLEN/8, x10, x6, x7)

inst_38:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x04ebfabda54d7 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x4ebfabda54d7; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:30*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 30*FLEN/8, x10, x6, x7)

inst_39:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x04ebfabda54d7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fce759ff97b7507; op2val:0x4ebfabda54d7;
valaddr_reg:x9; val_offset:32*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 32*FLEN/8, x10, x6, x7)

inst_40:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fce759ff97b7507; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:34*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 34*FLEN/8, x10, x6, x7)

inst_41:// fs1 == 0 and fe1 == 0x001 and fm1 == 0xec2df2149240f and fs2 == 0 and fe2 == 0x7fb and fm2 == 0xf8c50a18d0c04 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1ec2df2149240f; op2val:0x7fbf8c50a18d0c04;
valaddr_reg:x9; val_offset:36*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 36*FLEN/8, x10, x6, x7)

inst_42:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0xf8c50a18d0c04 and fs2 == 0 and fe2 == 0x001 and fm2 == 0xec2df2149240f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fbf8c50a18d0c04; op2val:0x1ec2df2149240f;
valaddr_reg:x9; val_offset:38*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 38*FLEN/8, x10, x6, x7)

inst_43:// fs1 == 0 and fe1 == 0x001 and fm1 == 0xec2df2149240f and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1ec2df2149240f; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:40*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 40*FLEN/8, x10, x6, x7)

inst_44:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 0 and fe2 == 0x001 and fm2 == 0xec2df2149240f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fce759ff97b7507; op2val:0x1ec2df2149240f;
valaddr_reg:x9; val_offset:42*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 42*FLEN/8, x10, x6, x7)

inst_45:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fce759ff97b7507; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:44*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 44*FLEN/8, x10, x6, x7)

inst_46:// fs1 == 0 and fe1 == 0x001 and fm1 == 0xec2df2149240f and fs2 == 0 and fe2 == 0x7fb and fm2 == 0x43fe46d2b7ce6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1ec2df2149240f; op2val:0x7fb43fe46d2b7ce6;
valaddr_reg:x9; val_offset:46*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 46*FLEN/8, x10, x6, x7)

inst_47:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x43fe46d2b7ce6 and fs2 == 0 and fe2 == 0x001 and fm2 == 0xec2df2149240f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb43fe46d2b7ce6; op2val:0x1ec2df2149240f;
valaddr_reg:x9; val_offset:48*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 48*FLEN/8, x10, x6, x7)

inst_48:// fs1 == 0 and fe1 == 0x001 and fm1 == 0xec2df2149240f and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1ec2df2149240f; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:50*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 50*FLEN/8, x10, x6, x7)

inst_49:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fce759ff97b7507; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:52*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 52*FLEN/8, x10, x6, x7)

inst_50:// fs1 == 0 and fe1 == 0x001 and fm1 == 0xec2df2149240f and fs2 == 0 and fe2 == 0x7fb and fm2 == 0x093dbe3aa0387 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1ec2df2149240f; op2val:0x7fb093dbe3aa0387;
valaddr_reg:x9; val_offset:54*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 54*FLEN/8, x10, x6, x7)

inst_51:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x093dbe3aa0387 and fs2 == 0 and fe2 == 0x001 and fm2 == 0xec2df2149240f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb093dbe3aa0387; op2val:0x1ec2df2149240f;
valaddr_reg:x9; val_offset:56*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 56*FLEN/8, x10, x6, x7)

inst_52:// fs1 == 0 and fe1 == 0x001 and fm1 == 0xec2df2149240f and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1ec2df2149240f; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:58*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 58*FLEN/8, x10, x6, x7)

inst_53:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fce759ff97b7507; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:60*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 60*FLEN/8, x10, x6, x7)

inst_54:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x3137cb6875068 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xf6025caa2d205 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3137cb6875068; op2val:0xffdf6025caa2d205;
valaddr_reg:x9; val_offset:62*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 62*FLEN/8, x10, x6, x7)

inst_55:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xf6025caa2d205 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x3137cb6875068 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdf6025caa2d205; op2val:0x3137cb6875068;
valaddr_reg:x9; val_offset:64*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 64*FLEN/8, x10, x6, x7)

inst_56:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x3137cb6875068 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3137cb6875068; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:66*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 66*FLEN/8, x10, x6, x7)

inst_57:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fce759ff97b7507; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:68*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 68*FLEN/8, x10, x6, x7)

inst_58:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x3137cb6875068 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x9bff6a8783cf3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3137cb6875068; op2val:0xffc9bff6a8783cf3;
valaddr_reg:x9; val_offset:70*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 70*FLEN/8, x10, x6, x7)

inst_59:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x9bff6a8783cf3 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x3137cb6875068 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc9bff6a8783cf3; op2val:0x3137cb6875068;
valaddr_reg:x9; val_offset:72*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 72*FLEN/8, x10, x6, x7)

inst_60:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x3137cb6875068 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3137cb6875068; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:74*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 74*FLEN/8, x10, x6, x7)

inst_61:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fce759ff97b7507; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:76*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 76*FLEN/8, x10, x6, x7)

inst_62:// fs1 == 0 and fe1 == 0x001 and fm1 == 0xec2df2149240f and fs2 == 1 and fe2 == 0x7fb and fm2 == 0x0c90875ccb5d8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1ec2df2149240f; op2val:0xffb0c90875ccb5d8;
valaddr_reg:x9; val_offset:78*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 78*FLEN/8, x10, x6, x7)

inst_63:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0x0c90875ccb5d8 and fs2 == 0 and fe2 == 0x001 and fm2 == 0xec2df2149240f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffb0c90875ccb5d8; op2val:0x1ec2df2149240f;
valaddr_reg:x9; val_offset:80*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 80*FLEN/8, x10, x6, x7)

inst_64:// fs1 == 0 and fe1 == 0x001 and fm1 == 0xec2df2149240f and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1ec2df2149240f; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:82*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 82*FLEN/8, x10, x6, x7)

inst_65:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fce759ff97b7507; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:84*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 84*FLEN/8, x10, x6, x7)

inst_66:// fs1 == 0 and fe1 == 0x001 and fm1 == 0xec2df2149240f and fs2 == 1 and fe2 == 0x7fb and fm2 == 0xae9e55abc765f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1ec2df2149240f; op2val:0xffbae9e55abc765f;
valaddr_reg:x9; val_offset:86*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 86*FLEN/8, x10, x6, x7)

inst_67:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0xae9e55abc765f and fs2 == 0 and fe2 == 0x001 and fm2 == 0xec2df2149240f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffbae9e55abc765f; op2val:0x1ec2df2149240f;
valaddr_reg:x9; val_offset:88*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 88*FLEN/8, x10, x6, x7)

inst_68:// fs1 == 0 and fe1 == 0x001 and fm1 == 0xec2df2149240f and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1ec2df2149240f; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:90*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 90*FLEN/8, x10, x6, x7)

inst_69:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fce759ff97b7507; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:92*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 92*FLEN/8, x10, x6, x7)

inst_70:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x3137cb6875068 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0x47f2e5cadc271 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3137cb6875068; op2val:0xffd47f2e5cadc271;
valaddr_reg:x9; val_offset:94*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 94*FLEN/8, x10, x6, x7)

inst_71:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0x47f2e5cadc271 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x3137cb6875068 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffd47f2e5cadc271; op2val:0x3137cb6875068;
valaddr_reg:x9; val_offset:96*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 96*FLEN/8, x10, x6, x7)

inst_72:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x3137cb6875068 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3137cb6875068; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:98*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 98*FLEN/8, x10, x6, x7)

inst_73:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fce759ff97b7507; op2val:0x0;
valaddr_reg:x9; val_offset:100*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 100*FLEN/8, x10, x6, x7)

inst_74:// fs1 == 0 and fe1 == 0x401 and fm1 == 0x11c8af0ae0986 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x40111c8af0ae0986; op2val:0x0;
valaddr_reg:x9; val_offset:102*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 102*FLEN/8, x10, x6, x7)

inst_75:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x401 and fm2 == 0x11c8af0ae0986 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x40111c8af0ae0986;
valaddr_reg:x9; val_offset:104*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 104*FLEN/8, x10, x6, x7)

inst_76:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 0 and fe2 == 0x401 and fm2 == 0x11c8af0ae0986 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fce759ff97b7507; op2val:0x40111c8af0ae0986;
valaddr_reg:x9; val_offset:106*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 106*FLEN/8, x10, x6, x7)

inst_77:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:108*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 108*FLEN/8, x10, x6, x7)

inst_78:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x004b878423be8 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb004b878423be8; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:110*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 110*FLEN/8, x10, x6, x7)

inst_79:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0x004b878423be8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0x7fb004b878423be8;
valaddr_reg:x9; val_offset:112*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 112*FLEN/8, x10, x6, x7)

inst_80:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:114*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 114*FLEN/8, x10, x6, x7)

inst_81:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:116*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 116*FLEN/8, x10, x6, x7)

inst_82:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x004b878423be8 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb004b878423be8; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:118*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 118*FLEN/8, x10, x6, x7)

inst_83:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:120*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 120*FLEN/8, x10, x6, x7)

inst_84:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:122*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 122*FLEN/8, x10, x6, x7)

inst_85:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:124*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 124*FLEN/8, x10, x6, x7)

inst_86:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:126*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 126*FLEN/8, x10, x6, x7)

inst_87:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:128*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 128*FLEN/8, x10, x6, x7)

inst_88:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x004b878423be8 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb004b878423be8; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:130*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 130*FLEN/8, x10, x6, x7)

inst_89:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0x004b878423be8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x7fb004b878423be8;
valaddr_reg:x9; val_offset:132*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 132*FLEN/8, x10, x6, x7)

inst_90:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x004b878423be8 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb004b878423be8; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:134*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 134*FLEN/8, x10, x6, x7)

inst_91:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:136*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 136*FLEN/8, x10, x6, x7)

inst_92:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:138*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 138*FLEN/8, x10, x6, x7)

inst_93:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:140*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 140*FLEN/8, x10, x6, x7)

inst_94:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:142*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 142*FLEN/8, x10, x6, x7)

inst_95:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:144*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 144*FLEN/8, x10, x6, x7)

inst_96:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x004b878423be8 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb004b878423be8; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:146*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 146*FLEN/8, x10, x6, x7)

inst_97:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:148*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 148*FLEN/8, x10, x6, x7)

inst_98:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x004b878423be8 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb004b878423be8; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:150*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 150*FLEN/8, x10, x6, x7)

inst_99:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:152*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 152*FLEN/8, x10, x6, x7)

inst_100:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0cf11346ee18e and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xcf11346ee18e; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:154*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 154*FLEN/8, x10, x6, x7)

inst_101:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0cf11346ee18e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0xcf11346ee18e;
valaddr_reg:x9; val_offset:156*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 156*FLEN/8, x10, x6, x7)

inst_102:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0cf11346ee18e and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xcf11346ee18e; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:158*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 158*FLEN/8, x10, x6, x7)

inst_103:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0cf11346ee18e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0xcf11346ee18e;
valaddr_reg:x9; val_offset:160*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 160*FLEN/8, x10, x6, x7)

inst_104:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:162*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 162*FLEN/8, x10, x6, x7)

inst_105:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x014b4eba4b028 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x14b4eba4b028; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:164*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 164*FLEN/8, x10, x6, x7)

inst_106:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x014b4eba4b028 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x14b4eba4b028;
valaddr_reg:x9; val_offset:166*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 166*FLEN/8, x10, x6, x7)

inst_107:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x014b4eba4b028 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x14b4eba4b028; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:168*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 168*FLEN/8, x10, x6, x7)

inst_108:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x014b4eba4b028 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0x14b4eba4b028;
valaddr_reg:x9; val_offset:170*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 170*FLEN/8, x10, x6, x7)

inst_109:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:172*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 172*FLEN/8, x10, x6, x7)

inst_110:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x816ac0c54cf8a and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x816ac0c54cf8a; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:174*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 174*FLEN/8, x10, x6, x7)

inst_111:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x816ac0c54cf8a and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x816ac0c54cf8a;
valaddr_reg:x9; val_offset:176*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 176*FLEN/8, x10, x6, x7)

inst_112:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x816ac0c54cf8a and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x816ac0c54cf8a; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:178*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 178*FLEN/8, x10, x6, x7)

inst_113:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x816ac0c54cf8a and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0x816ac0c54cf8a;
valaddr_reg:x9; val_offset:180*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 180*FLEN/8, x10, x6, x7)

inst_114:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:182*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 182*FLEN/8, x10, x6, x7)

inst_115:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x816ac0c54cf8a and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x94fdd88765c1f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x816ac0c54cf8a; op2val:0x7fe94fdd88765c1f;
valaddr_reg:x9; val_offset:184*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 184*FLEN/8, x10, x6, x7)

inst_116:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x94fdd88765c1f and fs2 == 0 and fe2 == 0x000 and fm2 == 0x816ac0c54cf8a and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe94fdd88765c1f; op2val:0x816ac0c54cf8a;
valaddr_reg:x9; val_offset:186*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 186*FLEN/8, x10, x6, x7)

inst_117:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x816ac0c54cf8a and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x816ac0c54cf8a; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:188*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 188*FLEN/8, x10, x6, x7)

inst_118:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:190*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 190*FLEN/8, x10, x6, x7)

inst_119:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x816ac0c54cf8a and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x4b8d2dc948469 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x816ac0c54cf8a; op2val:0x7fe4b8d2dc948469;
valaddr_reg:x9; val_offset:192*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 192*FLEN/8, x10, x6, x7)

inst_120:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x4b8d2dc948469 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x816ac0c54cf8a and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe4b8d2dc948469; op2val:0x816ac0c54cf8a;
valaddr_reg:x9; val_offset:194*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 194*FLEN/8, x10, x6, x7)

inst_121:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x816ac0c54cf8a and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x816ac0c54cf8a; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:196*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 196*FLEN/8, x10, x6, x7)

inst_122:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:198*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 198*FLEN/8, x10, x6, x7)

inst_123:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0cf11346ee18e and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xcf11346ee18e; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:200*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 200*FLEN/8, x10, x6, x7)

inst_124:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0cf11346ee18e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0xcf11346ee18e;
valaddr_reg:x9; val_offset:202*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 202*FLEN/8, x10, x6, x7)

inst_125:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0cf11346ee18e and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xcf11346ee18e; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:204*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 204*FLEN/8, x10, x6, x7)

inst_126:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:206*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 206*FLEN/8, x10, x6, x7)

inst_127:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0cf11346ee18e and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xcf11346ee18e; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:208*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 208*FLEN/8, x10, x6, x7)

inst_128:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:210*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 210*FLEN/8, x10, x6, x7)

inst_129:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x816ac0c54cf8a and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x4fb4a933fe34f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x816ac0c54cf8a; op2val:0xffe4fb4a933fe34f;
valaddr_reg:x9; val_offset:212*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 212*FLEN/8, x10, x6, x7)

inst_130:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x4fb4a933fe34f and fs2 == 0 and fe2 == 0x000 and fm2 == 0x816ac0c54cf8a and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe4fb4a933fe34f; op2val:0x816ac0c54cf8a;
valaddr_reg:x9; val_offset:214*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 214*FLEN/8, x10, x6, x7)

inst_131:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x816ac0c54cf8a and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x816ac0c54cf8a; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:216*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 216*FLEN/8, x10, x6, x7)

inst_132:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:218*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 218*FLEN/8, x10, x6, x7)

inst_133:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x816ac0c54cf8a and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x816ac0c54cf8a; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:220*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 220*FLEN/8, x10, x6, x7)

inst_134:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x816ac0c54cf8a and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x816ac0c54cf8a;
valaddr_reg:x9; val_offset:222*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 222*FLEN/8, x10, x6, x7)

inst_135:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x816ac0c54cf8a and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x816ac0c54cf8a; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:224*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 224*FLEN/8, x10, x6, x7)

inst_136:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:226*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 226*FLEN/8, x10, x6, x7)

inst_137:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0cf11346ee18e and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xcf11346ee18e; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:228*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 228*FLEN/8, x10, x6, x7)

inst_138:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0x0;
valaddr_reg:x9; val_offset:230*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 230*FLEN/8, x10, x6, x7)

inst_139:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x1ff65f57ff366 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff1ff65f57ff366; op2val:0x0;
valaddr_reg:x9; val_offset:232*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 232*FLEN/8, x10, x6, x7)

inst_140:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x1ff65f57ff366 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x3ff1ff65f57ff366;
valaddr_reg:x9; val_offset:234*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 234*FLEN/8, x10, x6, x7)

inst_141:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x405e69652cae2 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x1ff65f57ff366 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe405e69652cae2; op2val:0x3ff1ff65f57ff366;
valaddr_reg:x9; val_offset:236*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 236*FLEN/8, x10, x6, x7)

inst_142:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:238*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 238*FLEN/8, x10, x6, x7)

inst_143:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:240*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 240*FLEN/8, x10, x6, x7)

inst_144:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:242*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 242*FLEN/8, x10, x6, x7)

inst_145:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:244*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 244*FLEN/8, x10, x6, x7)

inst_146:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:246*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 246*FLEN/8, x10, x6, x7)

inst_147:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:248*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 248*FLEN/8, x10, x6, x7)

inst_148:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:250*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 250*FLEN/8, x10, x6, x7)

inst_149:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:252*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 252*FLEN/8, x10, x6, x7)

inst_150:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:254*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 254*FLEN/8, x10, x6, x7)

inst_151:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:256*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 256*FLEN/8, x10, x6, x7)

inst_152:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:258*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 258*FLEN/8, x10, x6, x7)

inst_153:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:260*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 260*FLEN/8, x10, x6, x7)
RVTEST_SIGBASE(x6,signature_x6_1)

inst_154:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:262*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 262*FLEN/8, x10, x6, x7)

inst_155:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:264*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 264*FLEN/8, x10, x6, x7)

inst_156:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x35a452e11324d and fs2 == 0 and fe2 == 0x7fd and fm2 == 0xd4e5c31a3975f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35a452e11324d; op2val:0x7fdd4e5c31a3975f;
valaddr_reg:x9; val_offset:266*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 266*FLEN/8, x10, x6, x7)

inst_157:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0xd4e5c31a3975f and fs2 == 0 and fe2 == 0x000 and fm2 == 0x35a452e11324d and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fdd4e5c31a3975f; op2val:0x35a452e11324d;
valaddr_reg:x9; val_offset:268*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 268*FLEN/8, x10, x6, x7)

inst_158:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x35a452e11324d and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35a452e11324d; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:270*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 270*FLEN/8, x10, x6, x7)

inst_159:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x35a452e11324d and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0x35a452e11324d;
valaddr_reg:x9; val_offset:272*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 272*FLEN/8, x10, x6, x7)

inst_160:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:274*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 274*FLEN/8, x10, x6, x7)

inst_161:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x055d3b7ce8508 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0x4dcb3b62b25ff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x55d3b7ce8508; op2val:0x7fc4dcb3b62b25ff;
valaddr_reg:x9; val_offset:276*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 276*FLEN/8, x10, x6, x7)

inst_162:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0x4dcb3b62b25ff and fs2 == 0 and fe2 == 0x000 and fm2 == 0x055d3b7ce8508 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fc4dcb3b62b25ff; op2val:0x55d3b7ce8508;
valaddr_reg:x9; val_offset:278*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 278*FLEN/8, x10, x6, x7)

inst_163:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x055d3b7ce8508 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x55d3b7ce8508; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:280*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 280*FLEN/8, x10, x6, x7)

inst_164:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x055d3b7ce8508 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0x55d3b7ce8508;
valaddr_reg:x9; val_offset:282*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 282*FLEN/8, x10, x6, x7)

inst_165:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:284*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 284*FLEN/8, x10, x6, x7)

inst_166:// fs1 == 0 and fe1 == 0x002 and fm1 == 0x0c359e655fb81 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0xf8c50a18d0c04 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x20c359e655fb81; op2val:0x7fbf8c50a18d0c04;
valaddr_reg:x9; val_offset:286*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 286*FLEN/8, x10, x6, x7)

inst_167:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0xf8c50a18d0c04 and fs2 == 0 and fe2 == 0x002 and fm2 == 0x0c359e655fb81 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fbf8c50a18d0c04; op2val:0x20c359e655fb81;
valaddr_reg:x9; val_offset:288*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 288*FLEN/8, x10, x6, x7)

inst_168:// fs1 == 0 and fe1 == 0x002 and fm1 == 0x0c359e655fb81 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x20c359e655fb81; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:290*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 290*FLEN/8, x10, x6, x7)

inst_169:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 0 and fe2 == 0x002 and fm2 == 0x0c359e655fb81 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0x20c359e655fb81;
valaddr_reg:x9; val_offset:292*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 292*FLEN/8, x10, x6, x7)

inst_170:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:294*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 294*FLEN/8, x10, x6, x7)

inst_171:// fs1 == 0 and fe1 == 0x002 and fm1 == 0x0c359e655fb81 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0x43fe46d2b7ce6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x20c359e655fb81; op2val:0x7fb43fe46d2b7ce6;
valaddr_reg:x9; val_offset:296*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 296*FLEN/8, x10, x6, x7)

inst_172:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x43fe46d2b7ce6 and fs2 == 0 and fe2 == 0x002 and fm2 == 0x0c359e655fb81 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb43fe46d2b7ce6; op2val:0x20c359e655fb81;
valaddr_reg:x9; val_offset:298*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 298*FLEN/8, x10, x6, x7)

inst_173:// fs1 == 0 and fe1 == 0x002 and fm1 == 0x0c359e655fb81 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x20c359e655fb81; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:300*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 300*FLEN/8, x10, x6, x7)

inst_174:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:302*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 302*FLEN/8, x10, x6, x7)

inst_175:// fs1 == 0 and fe1 == 0x002 and fm1 == 0x0c359e655fb81 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0x093dbe3aa0387 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x20c359e655fb81; op2val:0x7fb093dbe3aa0387;
valaddr_reg:x9; val_offset:304*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 304*FLEN/8, x10, x6, x7)

inst_176:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x093dbe3aa0387 and fs2 == 0 and fe2 == 0x002 and fm2 == 0x0c359e655fb81 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb093dbe3aa0387; op2val:0x20c359e655fb81;
valaddr_reg:x9; val_offset:306*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 306*FLEN/8, x10, x6, x7)

inst_177:// fs1 == 0 and fe1 == 0x002 and fm1 == 0x0c359e655fb81 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x20c359e655fb81; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:308*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 308*FLEN/8, x10, x6, x7)

inst_178:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:310*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 310*FLEN/8, x10, x6, x7)

inst_179:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x35a452e11324d and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xf6025caa2d205 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35a452e11324d; op2val:0xffdf6025caa2d205;
valaddr_reg:x9; val_offset:312*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 312*FLEN/8, x10, x6, x7)

inst_180:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xf6025caa2d205 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x35a452e11324d and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdf6025caa2d205; op2val:0x35a452e11324d;
valaddr_reg:x9; val_offset:314*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 314*FLEN/8, x10, x6, x7)

inst_181:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x35a452e11324d and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35a452e11324d; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:316*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 316*FLEN/8, x10, x6, x7)

inst_182:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:318*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 318*FLEN/8, x10, x6, x7)

inst_183:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x35a452e11324d and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x9bff6a8783cf3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35a452e11324d; op2val:0xffc9bff6a8783cf3;
valaddr_reg:x9; val_offset:320*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 320*FLEN/8, x10, x6, x7)

inst_184:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x9bff6a8783cf3 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x35a452e11324d and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc9bff6a8783cf3; op2val:0x35a452e11324d;
valaddr_reg:x9; val_offset:322*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 322*FLEN/8, x10, x6, x7)

inst_185:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x35a452e11324d and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35a452e11324d; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:324*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 324*FLEN/8, x10, x6, x7)

inst_186:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:326*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 326*FLEN/8, x10, x6, x7)

inst_187:// fs1 == 0 and fe1 == 0x002 and fm1 == 0x0c359e655fb81 and fs2 == 1 and fe2 == 0x7fb and fm2 == 0x0c90875ccb5d8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x20c359e655fb81; op2val:0xffb0c90875ccb5d8;
valaddr_reg:x9; val_offset:328*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 328*FLEN/8, x10, x6, x7)

inst_188:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0x0c90875ccb5d8 and fs2 == 0 and fe2 == 0x002 and fm2 == 0x0c359e655fb81 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffb0c90875ccb5d8; op2val:0x20c359e655fb81;
valaddr_reg:x9; val_offset:330*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 330*FLEN/8, x10, x6, x7)

inst_189:// fs1 == 0 and fe1 == 0x002 and fm1 == 0x0c359e655fb81 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x20c359e655fb81; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:332*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 332*FLEN/8, x10, x6, x7)

inst_190:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:334*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 334*FLEN/8, x10, x6, x7)

inst_191:// fs1 == 0 and fe1 == 0x002 and fm1 == 0x0c359e655fb81 and fs2 == 1 and fe2 == 0x7fb and fm2 == 0xae9e55abc765f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x20c359e655fb81; op2val:0xffbae9e55abc765f;
valaddr_reg:x9; val_offset:336*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 336*FLEN/8, x10, x6, x7)

inst_192:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0xae9e55abc765f and fs2 == 0 and fe2 == 0x002 and fm2 == 0x0c359e655fb81 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffbae9e55abc765f; op2val:0x20c359e655fb81;
valaddr_reg:x9; val_offset:338*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 338*FLEN/8, x10, x6, x7)

inst_193:// fs1 == 0 and fe1 == 0x002 and fm1 == 0x0c359e655fb81 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x20c359e655fb81; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:340*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 340*FLEN/8, x10, x6, x7)

inst_194:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:342*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 342*FLEN/8, x10, x6, x7)

inst_195:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x35a452e11324d and fs2 == 1 and fe2 == 0x7fd and fm2 == 0x47f2e5cadc271 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35a452e11324d; op2val:0xffd47f2e5cadc271;
valaddr_reg:x9; val_offset:344*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 344*FLEN/8, x10, x6, x7)

inst_196:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0x47f2e5cadc271 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x35a452e11324d and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffd47f2e5cadc271; op2val:0x35a452e11324d;
valaddr_reg:x9; val_offset:346*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 346*FLEN/8, x10, x6, x7)

inst_197:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x35a452e11324d and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35a452e11324d; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:348*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 348*FLEN/8, x10, x6, x7)

inst_198:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0x0;
valaddr_reg:x9; val_offset:350*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 350*FLEN/8, x10, x6, x7)

inst_199:// fs1 == 0 and fe1 == 0x401 and fm1 == 0x2a6496228606e and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x4012a6496228606e; op2val:0x0;
valaddr_reg:x9; val_offset:352*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 352*FLEN/8, x10, x6, x7)

inst_200:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x401 and fm2 == 0x2a6496228606e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x4012a6496228606e;
valaddr_reg:x9; val_offset:354*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 354*FLEN/8, x10, x6, x7)

inst_201:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0x09941946801c5 and fs2 == 0 and fe2 == 0x401 and fm2 == 0x2a6496228606e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fd09941946801c5; op2val:0x4012a6496228606e;
valaddr_reg:x9; val_offset:356*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 356*FLEN/8, x10, x6, x7)

inst_202:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:358*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 358*FLEN/8, x10, x6, x7)

inst_203:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x569d571c24201 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb569d571c24201; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:360*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 360*FLEN/8, x10, x6, x7)

inst_204:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0x569d571c24201 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0x7fb569d571c24201;
valaddr_reg:x9; val_offset:362*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 362*FLEN/8, x10, x6, x7)

inst_205:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:364*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 364*FLEN/8, x10, x6, x7)

inst_206:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:366*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 366*FLEN/8, x10, x6, x7)

inst_207:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x569d571c24201 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb569d571c24201; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:368*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 368*FLEN/8, x10, x6, x7)

inst_208:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:370*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 370*FLEN/8, x10, x6, x7)

inst_209:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:372*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 372*FLEN/8, x10, x6, x7)

inst_210:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:374*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 374*FLEN/8, x10, x6, x7)

inst_211:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x569d571c24201 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb569d571c24201; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:376*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 376*FLEN/8, x10, x6, x7)

inst_212:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0x569d571c24201 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x7fb569d571c24201;
valaddr_reg:x9; val_offset:378*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 378*FLEN/8, x10, x6, x7)

inst_213:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x569d571c24201 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb569d571c24201; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:380*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 380*FLEN/8, x10, x6, x7)

inst_214:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:382*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 382*FLEN/8, x10, x6, x7)

inst_215:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:384*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 384*FLEN/8, x10, x6, x7)

inst_216:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:386*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 386*FLEN/8, x10, x6, x7)

inst_217:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:388*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 388*FLEN/8, x10, x6, x7)

inst_218:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:390*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 390*FLEN/8, x10, x6, x7)

inst_219:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x569d571c24201 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb569d571c24201; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:392*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 392*FLEN/8, x10, x6, x7)

inst_220:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:394*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 394*FLEN/8, x10, x6, x7)

inst_221:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x569d571c24201 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb569d571c24201; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:396*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 396*FLEN/8, x10, x6, x7)

inst_222:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:398*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 398*FLEN/8, x10, x6, x7)

inst_223:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x114ce95016c16 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x114ce95016c16; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:400*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 400*FLEN/8, x10, x6, x7)

inst_224:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x114ce95016c16 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x114ce95016c16;
valaddr_reg:x9; val_offset:402*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 402*FLEN/8, x10, x6, x7)

inst_225:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x114ce95016c16 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x114ce95016c16; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:404*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 404*FLEN/8, x10, x6, x7)

inst_226:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x114ce95016c16 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0x114ce95016c16;
valaddr_reg:x9; val_offset:406*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 406*FLEN/8, x10, x6, x7)

inst_227:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:408*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 408*FLEN/8, x10, x6, x7)

inst_228:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x01bae4219be02 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1bae4219be02; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:410*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 410*FLEN/8, x10, x6, x7)

inst_229:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x01bae4219be02 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x1bae4219be02;
valaddr_reg:x9; val_offset:412*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 412*FLEN/8, x10, x6, x7)

inst_230:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x01bae4219be02 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1bae4219be02; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:414*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 414*FLEN/8, x10, x6, x7)

inst_231:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x01bae4219be02 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0x1bae4219be02;
valaddr_reg:x9; val_offset:416*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 416*FLEN/8, x10, x6, x7)

inst_232:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:418*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 418*FLEN/8, x10, x6, x7)

inst_233:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xad011d20e38de and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xad011d20e38de; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:420*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 420*FLEN/8, x10, x6, x7)

inst_234:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xad011d20e38de and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0xad011d20e38de;
valaddr_reg:x9; val_offset:422*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 422*FLEN/8, x10, x6, x7)

inst_235:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xad011d20e38de and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xad011d20e38de; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:424*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 424*FLEN/8, x10, x6, x7)

inst_236:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xad011d20e38de and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0xad011d20e38de;
valaddr_reg:x9; val_offset:426*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 426*FLEN/8, x10, x6, x7)

inst_237:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:428*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 428*FLEN/8, x10, x6, x7)

inst_238:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xad011d20e38de and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x94fdd88765c1f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xad011d20e38de; op2val:0x7fe94fdd88765c1f;
valaddr_reg:x9; val_offset:430*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 430*FLEN/8, x10, x6, x7)

inst_239:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x94fdd88765c1f and fs2 == 0 and fe2 == 0x000 and fm2 == 0xad011d20e38de and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe94fdd88765c1f; op2val:0xad011d20e38de;
valaddr_reg:x9; val_offset:432*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 432*FLEN/8, x10, x6, x7)

inst_240:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xad011d20e38de and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xad011d20e38de; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:434*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 434*FLEN/8, x10, x6, x7)

inst_241:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:436*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 436*FLEN/8, x10, x6, x7)

inst_242:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xad011d20e38de and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x4b8d2dc948469 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xad011d20e38de; op2val:0x7fe4b8d2dc948469;
valaddr_reg:x9; val_offset:438*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 438*FLEN/8, x10, x6, x7)

inst_243:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x4b8d2dc948469 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xad011d20e38de and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe4b8d2dc948469; op2val:0xad011d20e38de;
valaddr_reg:x9; val_offset:440*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 440*FLEN/8, x10, x6, x7)

inst_244:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xad011d20e38de and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xad011d20e38de; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:442*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 442*FLEN/8, x10, x6, x7)

inst_245:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:444*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 444*FLEN/8, x10, x6, x7)

inst_246:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x114ce95016c16 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x114ce95016c16; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:446*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 446*FLEN/8, x10, x6, x7)

inst_247:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x114ce95016c16 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x114ce95016c16;
valaddr_reg:x9; val_offset:448*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 448*FLEN/8, x10, x6, x7)

inst_248:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x114ce95016c16 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x114ce95016c16; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:450*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 450*FLEN/8, x10, x6, x7)

inst_249:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:452*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 452*FLEN/8, x10, x6, x7)

inst_250:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x114ce95016c16 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x114ce95016c16; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:454*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 454*FLEN/8, x10, x6, x7)

inst_251:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:456*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 456*FLEN/8, x10, x6, x7)

inst_252:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xad011d20e38de and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x4fb4a933fe34f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xad011d20e38de; op2val:0xffe4fb4a933fe34f;
valaddr_reg:x9; val_offset:458*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 458*FLEN/8, x10, x6, x7)

inst_253:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x4fb4a933fe34f and fs2 == 0 and fe2 == 0x000 and fm2 == 0xad011d20e38de and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe4fb4a933fe34f; op2val:0xad011d20e38de;
valaddr_reg:x9; val_offset:460*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 460*FLEN/8, x10, x6, x7)

inst_254:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xad011d20e38de and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xad011d20e38de; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:462*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 462*FLEN/8, x10, x6, x7)

inst_255:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:464*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 464*FLEN/8, x10, x6, x7)

inst_256:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xad011d20e38de and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xad011d20e38de; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:466*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 466*FLEN/8, x10, x6, x7)

inst_257:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xad011d20e38de and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0xad011d20e38de;
valaddr_reg:x9; val_offset:468*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 468*FLEN/8, x10, x6, x7)

inst_258:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xad011d20e38de and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xad011d20e38de; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:470*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 470*FLEN/8, x10, x6, x7)

inst_259:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:472*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 472*FLEN/8, x10, x6, x7)

inst_260:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x114ce95016c16 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x114ce95016c16; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:474*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 474*FLEN/8, x10, x6, x7)

inst_261:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0x0;
valaddr_reg:x9; val_offset:476*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 476*FLEN/8, x10, x6, x7)

inst_262:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x80f28c9e9c76b and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff80f28c9e9c76b; op2val:0x0;
valaddr_reg:x9; val_offset:478*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 478*FLEN/8, x10, x6, x7)

inst_263:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x80f28c9e9c76b and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x3ff80f28c9e9c76b;
valaddr_reg:x9; val_offset:480*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 480*FLEN/8, x10, x6, x7)

inst_264:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0xac44ace32d282 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x80f28c9e9c76b and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7feac44ace32d282; op2val:0x3ff80f28c9e9c76b;
valaddr_reg:x9; val_offset:482*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 482*FLEN/8, x10, x6, x7)

inst_265:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:484*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 484*FLEN/8, x10, x6, x7)

inst_266:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x0409f707c3583 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb0409f707c3583; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:486*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 486*FLEN/8, x10, x6, x7)

inst_267:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0x0409f707c3583 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0x7fb0409f707c3583;
valaddr_reg:x9; val_offset:488*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 488*FLEN/8, x10, x6, x7)

inst_268:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:490*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 490*FLEN/8, x10, x6, x7)

inst_269:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:492*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 492*FLEN/8, x10, x6, x7)

inst_270:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x0409f707c3583 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb0409f707c3583; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:494*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 494*FLEN/8, x10, x6, x7)

inst_271:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:496*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 496*FLEN/8, x10, x6, x7)

inst_272:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x0409f707c3583 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb0409f707c3583; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:498*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 498*FLEN/8, x10, x6, x7)

inst_273:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0x0409f707c3583 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x7fb0409f707c3583;
valaddr_reg:x9; val_offset:500*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 500*FLEN/8, x10, x6, x7)

inst_274:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x0409f707c3583 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb0409f707c3583; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:502*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 502*FLEN/8, x10, x6, x7)

inst_275:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:504*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 504*FLEN/8, x10, x6, x7)

inst_276:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:506*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 506*FLEN/8, x10, x6, x7)

inst_277:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:508*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 508*FLEN/8, x10, x6, x7)

inst_278:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:510*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 510*FLEN/8, x10, x6, x7)

inst_279:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:512*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 512*FLEN/8, x10, x6, x7)

inst_280:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x0409f707c3583 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb0409f707c3583; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:514*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 514*FLEN/8, x10, x6, x7)

inst_281:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:516*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 516*FLEN/8, x10, x6, x7)
RVTEST_SIGBASE(x6,signature_x6_2)

inst_282:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x0409f707c3583 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb0409f707c3583; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:518*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 518*FLEN/8, x10, x6, x7)

inst_283:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:520*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 520*FLEN/8, x10, x6, x7)

inst_284:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0d2178c8e4bc2 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xd2178c8e4bc2; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:522*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 522*FLEN/8, x10, x6, x7)

inst_285:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0d2178c8e4bc2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0xd2178c8e4bc2;
valaddr_reg:x9; val_offset:524*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 524*FLEN/8, x10, x6, x7)

inst_286:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0d2178c8e4bc2 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xd2178c8e4bc2; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:526*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 526*FLEN/8, x10, x6, x7)

inst_287:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0d2178c8e4bc2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0xd2178c8e4bc2;
valaddr_reg:x9; val_offset:528*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 528*FLEN/8, x10, x6, x7)

inst_288:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:530*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 530*FLEN/8, x10, x6, x7)

inst_289:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x015025adb0793 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x15025adb0793; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:532*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 532*FLEN/8, x10, x6, x7)

inst_290:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x015025adb0793 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x15025adb0793;
valaddr_reg:x9; val_offset:534*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 534*FLEN/8, x10, x6, x7)

inst_291:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x015025adb0793 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x15025adb0793; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:536*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 536*FLEN/8, x10, x6, x7)

inst_292:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x015025adb0793 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0x15025adb0793;
valaddr_reg:x9; val_offset:538*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 538*FLEN/8, x10, x6, x7)

inst_293:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:540*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 540*FLEN/8, x10, x6, x7)

inst_294:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x834eb7d8ef590 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x834eb7d8ef590; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:542*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 542*FLEN/8, x10, x6, x7)

inst_295:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x834eb7d8ef590 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x834eb7d8ef590;
valaddr_reg:x9; val_offset:544*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 544*FLEN/8, x10, x6, x7)

inst_296:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x834eb7d8ef590 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x834eb7d8ef590; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:546*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 546*FLEN/8, x10, x6, x7)

inst_297:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x834eb7d8ef590 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0x834eb7d8ef590;
valaddr_reg:x9; val_offset:548*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 548*FLEN/8, x10, x6, x7)

inst_298:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:550*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 550*FLEN/8, x10, x6, x7)

inst_299:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x834eb7d8ef590 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x94fdd88765c1f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x834eb7d8ef590; op2val:0x7fe94fdd88765c1f;
valaddr_reg:x9; val_offset:552*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 552*FLEN/8, x10, x6, x7)

inst_300:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x94fdd88765c1f and fs2 == 0 and fe2 == 0x000 and fm2 == 0x834eb7d8ef590 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe94fdd88765c1f; op2val:0x834eb7d8ef590;
valaddr_reg:x9; val_offset:554*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 554*FLEN/8, x10, x6, x7)

inst_301:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x834eb7d8ef590 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x834eb7d8ef590; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:556*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 556*FLEN/8, x10, x6, x7)

inst_302:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:558*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 558*FLEN/8, x10, x6, x7)

inst_303:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x834eb7d8ef590 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x4b8d2dc948469 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x834eb7d8ef590; op2val:0x7fe4b8d2dc948469;
valaddr_reg:x9; val_offset:560*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 560*FLEN/8, x10, x6, x7)

inst_304:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x4b8d2dc948469 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x834eb7d8ef590 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe4b8d2dc948469; op2val:0x834eb7d8ef590;
valaddr_reg:x9; val_offset:562*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 562*FLEN/8, x10, x6, x7)

inst_305:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x834eb7d8ef590 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x834eb7d8ef590; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:564*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 564*FLEN/8, x10, x6, x7)

inst_306:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:566*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 566*FLEN/8, x10, x6, x7)

inst_307:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0d2178c8e4bc2 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xd2178c8e4bc2; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:568*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 568*FLEN/8, x10, x6, x7)

inst_308:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0d2178c8e4bc2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0xd2178c8e4bc2;
valaddr_reg:x9; val_offset:570*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 570*FLEN/8, x10, x6, x7)

inst_309:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0d2178c8e4bc2 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xd2178c8e4bc2; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:572*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 572*FLEN/8, x10, x6, x7)

inst_310:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:574*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 574*FLEN/8, x10, x6, x7)

inst_311:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0d2178c8e4bc2 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xd2178c8e4bc2; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:576*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 576*FLEN/8, x10, x6, x7)

inst_312:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:578*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 578*FLEN/8, x10, x6, x7)

inst_313:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x834eb7d8ef590 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x4fb4a933fe34f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x834eb7d8ef590; op2val:0xffe4fb4a933fe34f;
valaddr_reg:x9; val_offset:580*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 580*FLEN/8, x10, x6, x7)

inst_314:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x4fb4a933fe34f and fs2 == 0 and fe2 == 0x000 and fm2 == 0x834eb7d8ef590 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe4fb4a933fe34f; op2val:0x834eb7d8ef590;
valaddr_reg:x9; val_offset:582*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 582*FLEN/8, x10, x6, x7)

inst_315:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x834eb7d8ef590 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x834eb7d8ef590; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:584*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 584*FLEN/8, x10, x6, x7)

inst_316:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:586*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 586*FLEN/8, x10, x6, x7)

inst_317:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x834eb7d8ef590 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x834eb7d8ef590; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:588*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 588*FLEN/8, x10, x6, x7)

inst_318:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x834eb7d8ef590 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x834eb7d8ef590;
valaddr_reg:x9; val_offset:590*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 590*FLEN/8, x10, x6, x7)

inst_319:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x834eb7d8ef590 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x834eb7d8ef590; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:592*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 592*FLEN/8, x10, x6, x7)

inst_320:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:594*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 594*FLEN/8, x10, x6, x7)

inst_321:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0d2178c8e4bc2 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xd2178c8e4bc2; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:596*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 596*FLEN/8, x10, x6, x7)

inst_322:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0x0;
valaddr_reg:x9; val_offset:598*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 598*FLEN/8, x10, x6, x7)

inst_323:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x242b3b0a4387a and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff242b3b0a4387a; op2val:0x0;
valaddr_reg:x9; val_offset:600*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 600*FLEN/8, x10, x6, x7)

inst_324:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x242b3b0a4387a and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x3ff242b3b0a4387a;
valaddr_reg:x9; val_offset:602*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 602*FLEN/8, x10, x6, x7)

inst_325:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x450c74c9b42e4 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x242b3b0a4387a and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe450c74c9b42e4; op2val:0x3ff242b3b0a4387a;
valaddr_reg:x9; val_offset:604*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 604*FLEN/8, x10, x6, x7)

inst_326:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:606*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 606*FLEN/8, x10, x6, x7)

inst_327:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:608*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 608*FLEN/8, x10, x6, x7)

inst_328:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:610*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 610*FLEN/8, x10, x6, x7)

inst_329:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:612*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 612*FLEN/8, x10, x6, x7)

inst_330:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:614*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 614*FLEN/8, x10, x6, x7)

inst_331:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:616*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 616*FLEN/8, x10, x6, x7)

inst_332:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:618*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 618*FLEN/8, x10, x6, x7)

inst_333:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:620*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 620*FLEN/8, x10, x6, x7)

inst_334:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:622*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 622*FLEN/8, x10, x6, x7)

inst_335:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7fb and fm2 == 0x7ec266adcb15f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0xffb7ec266adcb15f;
valaddr_reg:x9; val_offset:624*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 624*FLEN/8, x10, x6, x7)

inst_336:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0x7ec266adcb15f and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffb7ec266adcb15f; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:626*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 626*FLEN/8, x10, x6, x7)

inst_337:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:628*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 628*FLEN/8, x10, x6, x7)

inst_338:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:630*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 630*FLEN/8, x10, x6, x7)

inst_339:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7fb and fm2 == 0x399e37c2fb926 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0xffb399e37c2fb926;
valaddr_reg:x9; val_offset:632*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 632*FLEN/8, x10, x6, x7)

inst_340:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0x399e37c2fb926 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffb399e37c2fb926; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:634*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 634*FLEN/8, x10, x6, x7)

inst_341:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:636*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 636*FLEN/8, x10, x6, x7)

inst_342:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:638*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 638*FLEN/8, x10, x6, x7)

inst_343:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:640*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 640*FLEN/8, x10, x6, x7)

inst_344:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:642*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 642*FLEN/8, x10, x6, x7)

inst_345:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:644*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 644*FLEN/8, x10, x6, x7)

inst_346:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:646*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 646*FLEN/8, x10, x6, x7)

inst_347:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x5e443bf91c5dd and fs2 == 0 and fe2 == 0x7fd and fm2 == 0xd4e5c31a3975f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8005e443bf91c5dd; op2val:0x7fdd4e5c31a3975f;
valaddr_reg:x9; val_offset:648*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 648*FLEN/8, x10, x6, x7)

inst_348:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0xd4e5c31a3975f and fs2 == 1 and fe2 == 0x000 and fm2 == 0x5e443bf91c5dd and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fdd4e5c31a3975f; op2val:0x8005e443bf91c5dd;
valaddr_reg:x9; val_offset:650*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 650*FLEN/8, x10, x6, x7)

inst_349:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x5e443bf91c5dd and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8005e443bf91c5dd; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:652*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 652*FLEN/8, x10, x6, x7)

inst_350:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x5e443bf91c5dd and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0x8005e443bf91c5dd;
valaddr_reg:x9; val_offset:654*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 654*FLEN/8, x10, x6, x7)

inst_351:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:656*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 656*FLEN/8, x10, x6, x7)

inst_352:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x096d393282d63 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0x4dcb3b62b25ff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800096d393282d63; op2val:0x7fc4dcb3b62b25ff;
valaddr_reg:x9; val_offset:658*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 658*FLEN/8, x10, x6, x7)

inst_353:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0x4dcb3b62b25ff and fs2 == 1 and fe2 == 0x000 and fm2 == 0x096d393282d63 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fc4dcb3b62b25ff; op2val:0x800096d393282d63;
valaddr_reg:x9; val_offset:660*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 660*FLEN/8, x10, x6, x7)

inst_354:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x096d393282d63 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800096d393282d63; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:662*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 662*FLEN/8, x10, x6, x7)

inst_355:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x096d393282d63 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0x800096d393282d63;
valaddr_reg:x9; val_offset:664*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 664*FLEN/8, x10, x6, x7)

inst_356:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:666*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 666*FLEN/8, x10, x6, x7)

inst_357:// fs1 == 1 and fe1 == 0x002 and fm1 == 0xd7552bdd8dd50 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0xf8c50a18d0c04 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x802d7552bdd8dd50; op2val:0x7fbf8c50a18d0c04;
valaddr_reg:x9; val_offset:668*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 668*FLEN/8, x10, x6, x7)

inst_358:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0xf8c50a18d0c04 and fs2 == 1 and fe2 == 0x002 and fm2 == 0xd7552bdd8dd50 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fbf8c50a18d0c04; op2val:0x802d7552bdd8dd50;
valaddr_reg:x9; val_offset:670*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 670*FLEN/8, x10, x6, x7)

inst_359:// fs1 == 1 and fe1 == 0x002 and fm1 == 0xd7552bdd8dd50 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x802d7552bdd8dd50; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:672*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 672*FLEN/8, x10, x6, x7)

inst_360:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 1 and fe2 == 0x002 and fm2 == 0xd7552bdd8dd50 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0x802d7552bdd8dd50;
valaddr_reg:x9; val_offset:674*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 674*FLEN/8, x10, x6, x7)

inst_361:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:676*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 676*FLEN/8, x10, x6, x7)

inst_362:// fs1 == 1 and fe1 == 0x002 and fm1 == 0xd7552bdd8dd50 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0x43fe46d2b7ce6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x802d7552bdd8dd50; op2val:0x7fb43fe46d2b7ce6;
valaddr_reg:x9; val_offset:678*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 678*FLEN/8, x10, x6, x7)

inst_363:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x43fe46d2b7ce6 and fs2 == 1 and fe2 == 0x002 and fm2 == 0xd7552bdd8dd50 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb43fe46d2b7ce6; op2val:0x802d7552bdd8dd50;
valaddr_reg:x9; val_offset:680*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 680*FLEN/8, x10, x6, x7)

inst_364:// fs1 == 1 and fe1 == 0x002 and fm1 == 0xd7552bdd8dd50 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x802d7552bdd8dd50; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:682*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 682*FLEN/8, x10, x6, x7)

inst_365:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:684*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 684*FLEN/8, x10, x6, x7)

inst_366:// fs1 == 1 and fe1 == 0x002 and fm1 == 0xd7552bdd8dd50 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0x093dbe3aa0387 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x802d7552bdd8dd50; op2val:0x7fb093dbe3aa0387;
valaddr_reg:x9; val_offset:686*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 686*FLEN/8, x10, x6, x7)

inst_367:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x093dbe3aa0387 and fs2 == 1 and fe2 == 0x002 and fm2 == 0xd7552bdd8dd50 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb093dbe3aa0387; op2val:0x802d7552bdd8dd50;
valaddr_reg:x9; val_offset:688*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 688*FLEN/8, x10, x6, x7)

inst_368:// fs1 == 1 and fe1 == 0x002 and fm1 == 0xd7552bdd8dd50 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x802d7552bdd8dd50; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:690*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 690*FLEN/8, x10, x6, x7)

inst_369:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:692*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 692*FLEN/8, x10, x6, x7)

inst_370:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x5e443bf91c5dd and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xf6025caa2d205 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8005e443bf91c5dd; op2val:0xffdf6025caa2d205;
valaddr_reg:x9; val_offset:694*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 694*FLEN/8, x10, x6, x7)

inst_371:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xf6025caa2d205 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x5e443bf91c5dd and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdf6025caa2d205; op2val:0x8005e443bf91c5dd;
valaddr_reg:x9; val_offset:696*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 696*FLEN/8, x10, x6, x7)

inst_372:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x5e443bf91c5dd and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8005e443bf91c5dd; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:698*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 698*FLEN/8, x10, x6, x7)

inst_373:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:700*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 700*FLEN/8, x10, x6, x7)

inst_374:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x5e443bf91c5dd and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x9bff6a8783cf3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8005e443bf91c5dd; op2val:0xffc9bff6a8783cf3;
valaddr_reg:x9; val_offset:702*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 702*FLEN/8, x10, x6, x7)

inst_375:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x9bff6a8783cf3 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x5e443bf91c5dd and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc9bff6a8783cf3; op2val:0x8005e443bf91c5dd;
valaddr_reg:x9; val_offset:704*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 704*FLEN/8, x10, x6, x7)

inst_376:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x5e443bf91c5dd and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8005e443bf91c5dd; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:706*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 706*FLEN/8, x10, x6, x7)

inst_377:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:708*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 708*FLEN/8, x10, x6, x7)

inst_378:// fs1 == 1 and fe1 == 0x002 and fm1 == 0xd7552bdd8dd50 and fs2 == 1 and fe2 == 0x7fb and fm2 == 0x0c90875ccb5d8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x802d7552bdd8dd50; op2val:0xffb0c90875ccb5d8;
valaddr_reg:x9; val_offset:710*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 710*FLEN/8, x10, x6, x7)

inst_379:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0x0c90875ccb5d8 and fs2 == 1 and fe2 == 0x002 and fm2 == 0xd7552bdd8dd50 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffb0c90875ccb5d8; op2val:0x802d7552bdd8dd50;
valaddr_reg:x9; val_offset:712*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 712*FLEN/8, x10, x6, x7)

inst_380:// fs1 == 1 and fe1 == 0x002 and fm1 == 0xd7552bdd8dd50 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x802d7552bdd8dd50; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:714*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 714*FLEN/8, x10, x6, x7)

inst_381:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:716*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 716*FLEN/8, x10, x6, x7)

inst_382:// fs1 == 1 and fe1 == 0x002 and fm1 == 0xd7552bdd8dd50 and fs2 == 1 and fe2 == 0x7fb and fm2 == 0xae9e55abc765f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x802d7552bdd8dd50; op2val:0xffbae9e55abc765f;
valaddr_reg:x9; val_offset:718*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 718*FLEN/8, x10, x6, x7)

inst_383:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0xae9e55abc765f and fs2 == 1 and fe2 == 0x002 and fm2 == 0xd7552bdd8dd50 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffbae9e55abc765f; op2val:0x802d7552bdd8dd50;
valaddr_reg:x9; val_offset:720*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 720*FLEN/8, x10, x6, x7)

inst_384:// fs1 == 1 and fe1 == 0x002 and fm1 == 0xd7552bdd8dd50 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x802d7552bdd8dd50; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:722*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 722*FLEN/8, x10, x6, x7)

inst_385:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:724*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 724*FLEN/8, x10, x6, x7)

inst_386:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x5e443bf91c5dd and fs2 == 1 and fe2 == 0x7fd and fm2 == 0x47f2e5cadc271 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8005e443bf91c5dd; op2val:0xffd47f2e5cadc271;
valaddr_reg:x9; val_offset:726*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 726*FLEN/8, x10, x6, x7)

inst_387:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0x47f2e5cadc271 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x5e443bf91c5dd and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffd47f2e5cadc271; op2val:0x8005e443bf91c5dd;
valaddr_reg:x9; val_offset:728*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 728*FLEN/8, x10, x6, x7)

inst_388:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x5e443bf91c5dd and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8005e443bf91c5dd; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:730*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 730*FLEN/8, x10, x6, x7)

inst_389:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0x0;
valaddr_reg:x9; val_offset:732*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 732*FLEN/8, x10, x6, x7)

inst_390:// fs1 == 1 and fe1 == 0x402 and fm1 == 0x06300128a7be9 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xc0206300128a7be9; op2val:0x0;
valaddr_reg:x9; val_offset:734*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 734*FLEN/8, x10, x6, x7)

inst_391:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x402 and fm2 == 0x06300128a7be9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0xc0206300128a7be9;
valaddr_reg:x9; val_offset:736*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 736*FLEN/8, x10, x6, x7)

inst_392:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xd2b592ef4e4e6 and fs2 == 1 and fe2 == 0x402 and fm2 == 0x06300128a7be9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdd2b592ef4e4e6; op2val:0xc0206300128a7be9;
valaddr_reg:x9; val_offset:738*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 738*FLEN/8, x10, x6, x7)

inst_393:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:740*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 740*FLEN/8, x10, x6, x7)

inst_394:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0x7ec266adcb15f and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffb7ec266adcb15f; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:742*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 742*FLEN/8, x10, x6, x7)

inst_395:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 1 and fe2 == 0x7fb and fm2 == 0x7ec266adcb15f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0xffb7ec266adcb15f;
valaddr_reg:x9; val_offset:744*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 744*FLEN/8, x10, x6, x7)

inst_396:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:746*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 746*FLEN/8, x10, x6, x7)

inst_397:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:748*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 748*FLEN/8, x10, x6, x7)

inst_398:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0x7ec266adcb15f and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffb7ec266adcb15f; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:750*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 750*FLEN/8, x10, x6, x7)

inst_399:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:752*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 752*FLEN/8, x10, x6, x7)

inst_400:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0x7ec266adcb15f and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffb7ec266adcb15f; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:754*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 754*FLEN/8, x10, x6, x7)

inst_401:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:756*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 756*FLEN/8, x10, x6, x7)

inst_402:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:758*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 758*FLEN/8, x10, x6, x7)

inst_403:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:760*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 760*FLEN/8, x10, x6, x7)

inst_404:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0x7ec266adcb15f and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffb7ec266adcb15f; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:762*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 762*FLEN/8, x10, x6, x7)

inst_405:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:764*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 764*FLEN/8, x10, x6, x7)

inst_406:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0x7ec266adcb15f and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffb7ec266adcb15f; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:766*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 766*FLEN/8, x10, x6, x7)

inst_407:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:768*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 768*FLEN/8, x10, x6, x7)

inst_408:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x1353dad8f9fcc and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8001353dad8f9fcc; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:770*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 770*FLEN/8, x10, x6, x7)

inst_409:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x1353dad8f9fcc and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x8001353dad8f9fcc;
valaddr_reg:x9; val_offset:772*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 772*FLEN/8, x10, x6, x7)
RVTEST_SIGBASE(x6,signature_x6_3)

inst_410:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x1353dad8f9fcc and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8001353dad8f9fcc; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:774*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 774*FLEN/8, x10, x6, x7)

inst_411:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x1353dad8f9fcc and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0x8001353dad8f9fcc;
valaddr_reg:x9; val_offset:776*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 776*FLEN/8, x10, x6, x7)

inst_412:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:778*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 778*FLEN/8, x10, x6, x7)

inst_413:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x01eec915b2994 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80001eec915b2994; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:780*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 780*FLEN/8, x10, x6, x7)

inst_414:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x01eec915b2994 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x80001eec915b2994;
valaddr_reg:x9; val_offset:782*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 782*FLEN/8, x10, x6, x7)

inst_415:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x01eec915b2994 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80001eec915b2994; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:784*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 784*FLEN/8, x10, x6, x7)

inst_416:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x01eec915b2994 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0x80001eec915b2994;
valaddr_reg:x9; val_offset:786*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 786*FLEN/8, x10, x6, x7)

inst_417:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:788*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 788*FLEN/8, x10, x6, x7)

inst_418:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xc1468c79c3df8 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800c1468c79c3df8; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:790*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 790*FLEN/8, x10, x6, x7)

inst_419:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xc1468c79c3df8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x800c1468c79c3df8;
valaddr_reg:x9; val_offset:792*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 792*FLEN/8, x10, x6, x7)

inst_420:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xc1468c79c3df8 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800c1468c79c3df8; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:794*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 794*FLEN/8, x10, x6, x7)

inst_421:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xc1468c79c3df8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0x800c1468c79c3df8;
valaddr_reg:x9; val_offset:796*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 796*FLEN/8, x10, x6, x7)

inst_422:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:798*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 798*FLEN/8, x10, x6, x7)

inst_423:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xc1468c79c3df8 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x94fdd88765c1f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800c1468c79c3df8; op2val:0x7fe94fdd88765c1f;
valaddr_reg:x9; val_offset:800*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 800*FLEN/8, x10, x6, x7)

inst_424:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x94fdd88765c1f and fs2 == 1 and fe2 == 0x000 and fm2 == 0xc1468c79c3df8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe94fdd88765c1f; op2val:0x800c1468c79c3df8;
valaddr_reg:x9; val_offset:802*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 802*FLEN/8, x10, x6, x7)

inst_425:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xc1468c79c3df8 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800c1468c79c3df8; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:804*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 804*FLEN/8, x10, x6, x7)

inst_426:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:806*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 806*FLEN/8, x10, x6, x7)

inst_427:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xc1468c79c3df8 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x4b8d2dc948469 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800c1468c79c3df8; op2val:0x7fe4b8d2dc948469;
valaddr_reg:x9; val_offset:808*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 808*FLEN/8, x10, x6, x7)

inst_428:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x4b8d2dc948469 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xc1468c79c3df8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe4b8d2dc948469; op2val:0x800c1468c79c3df8;
valaddr_reg:x9; val_offset:810*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 810*FLEN/8, x10, x6, x7)

inst_429:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xc1468c79c3df8 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800c1468c79c3df8; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:812*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 812*FLEN/8, x10, x6, x7)

inst_430:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:814*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 814*FLEN/8, x10, x6, x7)

inst_431:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x1353dad8f9fcc and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8001353dad8f9fcc; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:816*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 816*FLEN/8, x10, x6, x7)

inst_432:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x1353dad8f9fcc and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x8001353dad8f9fcc;
valaddr_reg:x9; val_offset:818*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 818*FLEN/8, x10, x6, x7)

inst_433:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x1353dad8f9fcc and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8001353dad8f9fcc; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:820*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 820*FLEN/8, x10, x6, x7)

inst_434:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:822*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 822*FLEN/8, x10, x6, x7)

inst_435:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x1353dad8f9fcc and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8001353dad8f9fcc; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:824*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 824*FLEN/8, x10, x6, x7)

inst_436:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:826*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 826*FLEN/8, x10, x6, x7)

inst_437:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xc1468c79c3df8 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x4fb4a933fe34f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800c1468c79c3df8; op2val:0xffe4fb4a933fe34f;
valaddr_reg:x9; val_offset:828*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 828*FLEN/8, x10, x6, x7)

inst_438:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x4fb4a933fe34f and fs2 == 1 and fe2 == 0x000 and fm2 == 0xc1468c79c3df8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe4fb4a933fe34f; op2val:0x800c1468c79c3df8;
valaddr_reg:x9; val_offset:830*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 830*FLEN/8, x10, x6, x7)

inst_439:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xc1468c79c3df8 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800c1468c79c3df8; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:832*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 832*FLEN/8, x10, x6, x7)

inst_440:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:834*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 834*FLEN/8, x10, x6, x7)

inst_441:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xc1468c79c3df8 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800c1468c79c3df8; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:836*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 836*FLEN/8, x10, x6, x7)

inst_442:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xc1468c79c3df8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x800c1468c79c3df8;
valaddr_reg:x9; val_offset:838*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 838*FLEN/8, x10, x6, x7)

inst_443:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xc1468c79c3df8 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800c1468c79c3df8; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:840*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 840*FLEN/8, x10, x6, x7)

inst_444:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:842*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 842*FLEN/8, x10, x6, x7)

inst_445:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x1353dad8f9fcc and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8001353dad8f9fcc; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:844*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 844*FLEN/8, x10, x6, x7)

inst_446:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0x0;
valaddr_reg:x9; val_offset:846*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 846*FLEN/8, x10, x6, x7)

inst_447:// fs1 == 1 and fe1 == 0x3ff and fm1 == 0xae0d6ce341771 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbffae0d6ce341771; op2val:0x0;
valaddr_reg:x9; val_offset:848*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 848*FLEN/8, x10, x6, x7)

inst_448:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x3ff and fm2 == 0xae0d6ce341771 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0xbffae0d6ce341771;
valaddr_reg:x9; val_offset:850*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 850*FLEN/8, x10, x6, x7)

inst_449:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0xde7300593ddb7 and fs2 == 1 and fe2 == 0x3ff and fm2 == 0xae0d6ce341771 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffede7300593ddb7; op2val:0xbffae0d6ce341771;
valaddr_reg:x9; val_offset:852*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 852*FLEN/8, x10, x6, x7)

inst_450:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:854*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 854*FLEN/8, x10, x6, x7)

inst_451:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0x399e37c2fb926 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffb399e37c2fb926; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:856*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 856*FLEN/8, x10, x6, x7)

inst_452:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 1 and fe2 == 0x7fb and fm2 == 0x399e37c2fb926 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0xffb399e37c2fb926;
valaddr_reg:x9; val_offset:858*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 858*FLEN/8, x10, x6, x7)

inst_453:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:860*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 860*FLEN/8, x10, x6, x7)

inst_454:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:862*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 862*FLEN/8, x10, x6, x7)

inst_455:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0x399e37c2fb926 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffb399e37c2fb926; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:864*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 864*FLEN/8, x10, x6, x7)

inst_456:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:866*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 866*FLEN/8, x10, x6, x7)

inst_457:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0x399e37c2fb926 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffb399e37c2fb926; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:868*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 868*FLEN/8, x10, x6, x7)

inst_458:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:870*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 870*FLEN/8, x10, x6, x7)

inst_459:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0x399e37c2fb926 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffb399e37c2fb926; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:872*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 872*FLEN/8, x10, x6, x7)

inst_460:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:874*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 874*FLEN/8, x10, x6, x7)

inst_461:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0x399e37c2fb926 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffb399e37c2fb926; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:876*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 876*FLEN/8, x10, x6, x7)

inst_462:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:878*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 878*FLEN/8, x10, x6, x7)

inst_463:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0fd6141352983 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000fd6141352983; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:880*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 880*FLEN/8, x10, x6, x7)

inst_464:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0fd6141352983 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x8000fd6141352983;
valaddr_reg:x9; val_offset:882*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 882*FLEN/8, x10, x6, x7)

inst_465:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0fd6141352983 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000fd6141352983; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:884*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 884*FLEN/8, x10, x6, x7)

inst_466:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0fd6141352983 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0x8000fd6141352983;
valaddr_reg:x9; val_offset:886*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 886*FLEN/8, x10, x6, x7)

inst_467:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:888*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 888*FLEN/8, x10, x6, x7)

inst_468:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x01956868550f3 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80001956868550f3; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:890*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 890*FLEN/8, x10, x6, x7)

inst_469:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x01956868550f3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x80001956868550f3;
valaddr_reg:x9; val_offset:892*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 892*FLEN/8, x10, x6, x7)

inst_470:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x01956868550f3 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80001956868550f3; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:894*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 894*FLEN/8, x10, x6, x7)

inst_471:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 1 and fe2 == 0x000 and fm2 == 0x01956868550f3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0x80001956868550f3;
valaddr_reg:x9; val_offset:896*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 896*FLEN/8, x10, x6, x7)

inst_472:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:898*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 898*FLEN/8, x10, x6, x7)

inst_473:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x9e5cc8c139f1c and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8009e5cc8c139f1c; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:900*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 900*FLEN/8, x10, x6, x7)

inst_474:// fs1 == 0 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x9e5cc8c139f1c and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7ff0000000000000; op2val:0x8009e5cc8c139f1c;
valaddr_reg:x9; val_offset:902*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 902*FLEN/8, x10, x6, x7)

inst_475:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x9e5cc8c139f1c and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8009e5cc8c139f1c; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:904*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 904*FLEN/8, x10, x6, x7)

inst_476:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 1 and fe2 == 0x000 and fm2 == 0x9e5cc8c139f1c and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0x8009e5cc8c139f1c;
valaddr_reg:x9; val_offset:906*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 906*FLEN/8, x10, x6, x7)

inst_477:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:908*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 908*FLEN/8, x10, x6, x7)

inst_478:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x9e5cc8c139f1c and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x94fdd88765c1f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8009e5cc8c139f1c; op2val:0x7fe94fdd88765c1f;
valaddr_reg:x9; val_offset:910*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 910*FLEN/8, x10, x6, x7)

inst_479:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x94fdd88765c1f and fs2 == 1 and fe2 == 0x000 and fm2 == 0x9e5cc8c139f1c and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe94fdd88765c1f; op2val:0x8009e5cc8c139f1c;
valaddr_reg:x9; val_offset:912*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 912*FLEN/8, x10, x6, x7)

inst_480:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x9e5cc8c139f1c and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8009e5cc8c139f1c; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:914*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 914*FLEN/8, x10, x6, x7)

inst_481:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:916*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 916*FLEN/8, x10, x6, x7)

inst_482:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x9e5cc8c139f1c and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x4b8d2dc948469 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8009e5cc8c139f1c; op2val:0x7fe4b8d2dc948469;
valaddr_reg:x9; val_offset:918*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 918*FLEN/8, x10, x6, x7)

inst_483:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x4b8d2dc948469 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x9e5cc8c139f1c and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe4b8d2dc948469; op2val:0x8009e5cc8c139f1c;
valaddr_reg:x9; val_offset:920*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 920*FLEN/8, x10, x6, x7)

inst_484:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x9e5cc8c139f1c and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8009e5cc8c139f1c; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:922*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 922*FLEN/8, x10, x6, x7)

inst_485:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:924*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 924*FLEN/8, x10, x6, x7)

inst_486:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0fd6141352983 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000fd6141352983; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:926*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 926*FLEN/8, x10, x6, x7)

inst_487:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0fd6141352983 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x8000fd6141352983;
valaddr_reg:x9; val_offset:928*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 928*FLEN/8, x10, x6, x7)

inst_488:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0fd6141352983 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000fd6141352983; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:930*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 930*FLEN/8, x10, x6, x7)

inst_489:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:932*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 932*FLEN/8, x10, x6, x7)

inst_490:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0fd6141352983 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000fd6141352983; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:934*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 934*FLEN/8, x10, x6, x7)

inst_491:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:936*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 936*FLEN/8, x10, x6, x7)

inst_492:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x9e5cc8c139f1c and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x4fb4a933fe34f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8009e5cc8c139f1c; op2val:0xffe4fb4a933fe34f;
valaddr_reg:x9; val_offset:938*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 938*FLEN/8, x10, x6, x7)

inst_493:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x4fb4a933fe34f and fs2 == 1 and fe2 == 0x000 and fm2 == 0x9e5cc8c139f1c and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe4fb4a933fe34f; op2val:0x8009e5cc8c139f1c;
valaddr_reg:x9; val_offset:940*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 940*FLEN/8, x10, x6, x7)

inst_494:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x9e5cc8c139f1c and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8009e5cc8c139f1c; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:942*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 942*FLEN/8, x10, x6, x7)

inst_495:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:944*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 944*FLEN/8, x10, x6, x7)

inst_496:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x9e5cc8c139f1c and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8009e5cc8c139f1c; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:946*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 946*FLEN/8, x10, x6, x7)

inst_497:// fs1 == 1 and fe1 == 0x7ff and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x9e5cc8c139f1c and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfff0000000000000; op2val:0x8009e5cc8c139f1c;
valaddr_reg:x9; val_offset:948*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 948*FLEN/8, x10, x6, x7)

inst_498:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x9e5cc8c139f1c and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8009e5cc8c139f1c; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:950*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 950*FLEN/8, x10, x6, x7)

inst_499:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:952*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 952*FLEN/8, x10, x6, x7)

inst_500:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0fd6141352983 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000fd6141352983; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:954*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 954*FLEN/8, x10, x6, x7)

inst_501:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0x0;
valaddr_reg:x9; val_offset:956*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 956*FLEN/8, x10, x6, x7)

inst_502:// fs1 == 1 and fe1 == 0x3ff and fm1 == 0x605e3d372e471 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbff605e3d372e471; op2val:0x0;
valaddr_reg:x9; val_offset:958*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 958*FLEN/8, x10, x6, x7)

inst_503:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x3ff and fm2 == 0x605e3d372e471 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0xbff605e3d372e471;
valaddr_reg:x9; val_offset:960*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 960*FLEN/8, x10, x6, x7)

inst_504:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x8805c5b3ba76f and fs2 == 1 and fe2 == 0x3ff and fm2 == 0x605e3d372e471 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe8805c5b3ba76f; op2val:0xbff605e3d372e471;
valaddr_reg:x9; val_offset:962*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 962*FLEN/8, x10, x6, x7)

inst_505:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:964*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 964*FLEN/8, x10, x6, x7)

inst_506:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:966*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 966*FLEN/8, x10, x6, x7)

inst_507:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:968*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 968*FLEN/8, x10, x6, x7)

inst_508:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:970*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 970*FLEN/8, x10, x6, x7)

inst_509:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:972*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 972*FLEN/8, x10, x6, x7)

inst_510:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:974*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 974*FLEN/8, x10, x6, x7)

inst_511:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:976*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 976*FLEN/8, x10, x6, x7)

inst_512:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:978*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 978*FLEN/8, x10, x6, x7)

inst_513:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:980*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 980*FLEN/8, x10, x6, x7)

inst_514:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:982*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 982*FLEN/8, x10, x6, x7)

inst_515:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x6c4e25604ed00 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0xd4e5c31a3975f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8006c4e25604ed00; op2val:0x7fdd4e5c31a3975f;
valaddr_reg:x9; val_offset:984*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 984*FLEN/8, x10, x6, x7)

inst_516:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0xd4e5c31a3975f and fs2 == 1 and fe2 == 0x000 and fm2 == 0x6c4e25604ed00 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fdd4e5c31a3975f; op2val:0x8006c4e25604ed00;
valaddr_reg:x9; val_offset:986*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 986*FLEN/8, x10, x6, x7)

inst_517:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x6c4e25604ed00 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8006c4e25604ed00; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:988*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 988*FLEN/8, x10, x6, x7)

inst_518:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 1 and fe2 == 0x000 and fm2 == 0x6c4e25604ed00 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0x8006c4e25604ed00;
valaddr_reg:x9; val_offset:990*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 990*FLEN/8, x10, x6, x7)

inst_519:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:992*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 992*FLEN/8, x10, x6, x7)

inst_520:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0ad49d566e480 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0x4dcb3b62b25ff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000ad49d566e480; op2val:0x7fc4dcb3b62b25ff;
valaddr_reg:x9; val_offset:994*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 994*FLEN/8, x10, x6, x7)

inst_521:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0x4dcb3b62b25ff and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0ad49d566e480 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fc4dcb3b62b25ff; op2val:0x8000ad49d566e480;
valaddr_reg:x9; val_offset:996*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 996*FLEN/8, x10, x6, x7)

inst_522:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0ad49d566e480 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000ad49d566e480; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:998*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 998*FLEN/8, x10, x6, x7)

inst_523:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0ad49d566e480 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0x8000ad49d566e480;
valaddr_reg:x9; val_offset:1000*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1000*FLEN/8, x10, x6, x7)

inst_524:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:1002*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1002*FLEN/8, x10, x6, x7)

inst_525:// fs1 == 1 and fe1 == 0x003 and fm1 == 0x0ec35d70c5080 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0xf8c50a18d0c04 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8030ec35d70c5080; op2val:0x7fbf8c50a18d0c04;
valaddr_reg:x9; val_offset:1004*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1004*FLEN/8, x10, x6, x7)

inst_526:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0xf8c50a18d0c04 and fs2 == 1 and fe2 == 0x003 and fm2 == 0x0ec35d70c5080 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fbf8c50a18d0c04; op2val:0x8030ec35d70c5080;
valaddr_reg:x9; val_offset:1006*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1006*FLEN/8, x10, x6, x7)

inst_527:// fs1 == 1 and fe1 == 0x003 and fm1 == 0x0ec35d70c5080 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8030ec35d70c5080; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:1008*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1008*FLEN/8, x10, x6, x7)

inst_528:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 1 and fe2 == 0x003 and fm2 == 0x0ec35d70c5080 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0x8030ec35d70c5080;
valaddr_reg:x9; val_offset:1010*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1010*FLEN/8, x10, x6, x7)

inst_529:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:1012*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1012*FLEN/8, x10, x6, x7)

inst_530:// fs1 == 1 and fe1 == 0x003 and fm1 == 0x0ec35d70c5080 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0x43fe46d2b7ce6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8030ec35d70c5080; op2val:0x7fb43fe46d2b7ce6;
valaddr_reg:x9; val_offset:1014*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1014*FLEN/8, x10, x6, x7)

inst_531:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x43fe46d2b7ce6 and fs2 == 1 and fe2 == 0x003 and fm2 == 0x0ec35d70c5080 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb43fe46d2b7ce6; op2val:0x8030ec35d70c5080;
valaddr_reg:x9; val_offset:1016*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1016*FLEN/8, x10, x6, x7)

inst_532:// fs1 == 1 and fe1 == 0x003 and fm1 == 0x0ec35d70c5080 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8030ec35d70c5080; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:1018*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1018*FLEN/8, x10, x6, x7)

inst_533:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:1020*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1020*FLEN/8, x10, x6, x7)

inst_534:// fs1 == 1 and fe1 == 0x003 and fm1 == 0x0ec35d70c5080 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0x093dbe3aa0387 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8030ec35d70c5080; op2val:0x7fb093dbe3aa0387;
valaddr_reg:x9; val_offset:1022*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1022*FLEN/8, x10, x6, x7)

inst_535:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x093dbe3aa0387 and fs2 == 1 and fe2 == 0x003 and fm2 == 0x0ec35d70c5080 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb093dbe3aa0387; op2val:0x8030ec35d70c5080;
valaddr_reg:x9; val_offset:1024*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1024*FLEN/8, x10, x6, x7)

inst_536:// fs1 == 1 and fe1 == 0x003 and fm1 == 0x0ec35d70c5080 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8030ec35d70c5080; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:1026*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1026*FLEN/8, x10, x6, x7)

inst_537:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:1028*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1028*FLEN/8, x10, x6, x7)
RVTEST_SIGBASE(x6,signature_x6_4)

inst_538:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x6c4e25604ed00 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xf6025caa2d205 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8006c4e25604ed00; op2val:0xffdf6025caa2d205;
valaddr_reg:x9; val_offset:1030*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1030*FLEN/8, x10, x6, x7)

inst_539:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xf6025caa2d205 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x6c4e25604ed00 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdf6025caa2d205; op2val:0x8006c4e25604ed00;
valaddr_reg:x9; val_offset:1032*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1032*FLEN/8, x10, x6, x7)

inst_540:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x6c4e25604ed00 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8006c4e25604ed00; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:1034*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1034*FLEN/8, x10, x6, x7)

inst_541:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:1036*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1036*FLEN/8, x10, x6, x7)

inst_542:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x6c4e25604ed00 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x9bff6a8783cf3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8006c4e25604ed00; op2val:0xffc9bff6a8783cf3;
valaddr_reg:x9; val_offset:1038*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1038*FLEN/8, x10, x6, x7)

inst_543:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x9bff6a8783cf3 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x6c4e25604ed00 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc9bff6a8783cf3; op2val:0x8006c4e25604ed00;
valaddr_reg:x9; val_offset:1040*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1040*FLEN/8, x10, x6, x7)

inst_544:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x6c4e25604ed00 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8006c4e25604ed00; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:1042*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1042*FLEN/8, x10, x6, x7)

inst_545:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:1044*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1044*FLEN/8, x10, x6, x7)

inst_546:// fs1 == 1 and fe1 == 0x003 and fm1 == 0x0ec35d70c5080 and fs2 == 1 and fe2 == 0x7fb and fm2 == 0x0c90875ccb5d8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8030ec35d70c5080; op2val:0xffb0c90875ccb5d8;
valaddr_reg:x9; val_offset:1046*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1046*FLEN/8, x10, x6, x7)

inst_547:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0x0c90875ccb5d8 and fs2 == 1 and fe2 == 0x003 and fm2 == 0x0ec35d70c5080 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffb0c90875ccb5d8; op2val:0x8030ec35d70c5080;
valaddr_reg:x9; val_offset:1048*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1048*FLEN/8, x10, x6, x7)

inst_548:// fs1 == 1 and fe1 == 0x003 and fm1 == 0x0ec35d70c5080 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8030ec35d70c5080; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:1050*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1050*FLEN/8, x10, x6, x7)

inst_549:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:1052*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1052*FLEN/8, x10, x6, x7)

inst_550:// fs1 == 1 and fe1 == 0x003 and fm1 == 0x0ec35d70c5080 and fs2 == 1 and fe2 == 0x7fb and fm2 == 0xae9e55abc765f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8030ec35d70c5080; op2val:0xffbae9e55abc765f;
valaddr_reg:x9; val_offset:1054*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1054*FLEN/8, x10, x6, x7)

inst_551:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0xae9e55abc765f and fs2 == 1 and fe2 == 0x003 and fm2 == 0x0ec35d70c5080 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffbae9e55abc765f; op2val:0x8030ec35d70c5080;
valaddr_reg:x9; val_offset:1056*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1056*FLEN/8, x10, x6, x7)

inst_552:// fs1 == 1 and fe1 == 0x003 and fm1 == 0x0ec35d70c5080 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8030ec35d70c5080; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:1058*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1058*FLEN/8, x10, x6, x7)

inst_553:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:1060*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1060*FLEN/8, x10, x6, x7)

inst_554:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x6c4e25604ed00 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0x47f2e5cadc271 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8006c4e25604ed00; op2val:0xffd47f2e5cadc271;
valaddr_reg:x9; val_offset:1062*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1062*FLEN/8, x10, x6, x7)

inst_555:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0x47f2e5cadc271 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x6c4e25604ed00 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffd47f2e5cadc271; op2val:0x8006c4e25604ed00;
valaddr_reg:x9; val_offset:1064*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1064*FLEN/8, x10, x6, x7)

inst_556:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x6c4e25604ed00 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8006c4e25604ed00; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:1066*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1066*FLEN/8, x10, x6, x7)

inst_557:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0x0;
valaddr_reg:x9; val_offset:1068*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1068*FLEN/8, x10, x6, x7)

inst_558:// fs1 == 1 and fe1 == 0x402 and fm1 == 0x2d3be740985a9 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xc022d3be740985a9; op2val:0x0;
valaddr_reg:x9; val_offset:1070*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1070*FLEN/8, x10, x6, x7)

inst_559:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x402 and fm2 == 0x2d3be740985a9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0xc022d3be740985a9;
valaddr_reg:x9; val_offset:1072*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1072*FLEN/8, x10, x6, x7)

inst_560:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x0c1b6ea69558e and fs2 == 1 and fe2 == 0x402 and fm2 == 0x2d3be740985a9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe0c1b6ea69558e; op2val:0xc022d3be740985a9;
valaddr_reg:x9; val_offset:1074*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1074*FLEN/8, x10, x6, x7)

inst_561:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:1076*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1076*FLEN/8, x10, x6, x7)

inst_562:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:1078*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1078*FLEN/8, x10, x6, x7)

inst_563:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:1080*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1080*FLEN/8, x10, x6, x7)

inst_564:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:1082*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1082*FLEN/8, x10, x6, x7)

inst_565:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:1084*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1084*FLEN/8, x10, x6, x7)

inst_566:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:1086*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1086*FLEN/8, x10, x6, x7)

inst_567:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:1088*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1088*FLEN/8, x10, x6, x7)

inst_568:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:1090*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1090*FLEN/8, x10, x6, x7)

inst_569:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x1b4ac2dd761b7 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0xd4e5c31a3975f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8001b4ac2dd761b7; op2val:0x7fdd4e5c31a3975f;
valaddr_reg:x9; val_offset:1092*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1092*FLEN/8, x10, x6, x7)

inst_570:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0xd4e5c31a3975f and fs2 == 1 and fe2 == 0x000 and fm2 == 0x1b4ac2dd761b7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fdd4e5c31a3975f; op2val:0x8001b4ac2dd761b7;
valaddr_reg:x9; val_offset:1094*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1094*FLEN/8, x10, x6, x7)

inst_571:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x1b4ac2dd761b7 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8001b4ac2dd761b7; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:1096*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1096*FLEN/8, x10, x6, x7)

inst_572:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x1b4ac2dd761b7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0x8001b4ac2dd761b7;
valaddr_reg:x9; val_offset:1098*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1098*FLEN/8, x10, x6, x7)

inst_573:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:1100*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1100*FLEN/8, x10, x6, x7)

inst_574:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x02baad1625692 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0x4dcb3b62b25ff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80002baad1625692; op2val:0x7fc4dcb3b62b25ff;
valaddr_reg:x9; val_offset:1102*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1102*FLEN/8, x10, x6, x7)

inst_575:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0x4dcb3b62b25ff and fs2 == 1 and fe2 == 0x000 and fm2 == 0x02baad1625692 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fc4dcb3b62b25ff; op2val:0x80002baad1625692;
valaddr_reg:x9; val_offset:1104*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1104*FLEN/8, x10, x6, x7)

inst_576:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x02baad1625692 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80002baad1625692; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:1106*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1106*FLEN/8, x10, x6, x7)

inst_577:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x02baad1625692 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0x80002baad1625692;
valaddr_reg:x9; val_offset:1108*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1108*FLEN/8, x10, x6, x7)

inst_578:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:1110*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1110*FLEN/8, x10, x6, x7)

inst_579:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x10eb9ca69d123 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0xf8c50a18d0c04 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80110eb9ca69d123; op2val:0x7fbf8c50a18d0c04;
valaddr_reg:x9; val_offset:1112*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1112*FLEN/8, x10, x6, x7)

inst_580:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0xf8c50a18d0c04 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x10eb9ca69d123 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fbf8c50a18d0c04; op2val:0x80110eb9ca69d123;
valaddr_reg:x9; val_offset:1114*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1114*FLEN/8, x10, x6, x7)

inst_581:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x10eb9ca69d123 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80110eb9ca69d123; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:1116*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1116*FLEN/8, x10, x6, x7)

inst_582:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x10eb9ca69d123 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0x80110eb9ca69d123;
valaddr_reg:x9; val_offset:1118*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1118*FLEN/8, x10, x6, x7)

inst_583:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:1120*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1120*FLEN/8, x10, x6, x7)

inst_584:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x10eb9ca69d123 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0x43fe46d2b7ce6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80110eb9ca69d123; op2val:0x7fb43fe46d2b7ce6;
valaddr_reg:x9; val_offset:1122*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1122*FLEN/8, x10, x6, x7)

inst_585:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x43fe46d2b7ce6 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x10eb9ca69d123 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb43fe46d2b7ce6; op2val:0x80110eb9ca69d123;
valaddr_reg:x9; val_offset:1124*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1124*FLEN/8, x10, x6, x7)

inst_586:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x10eb9ca69d123 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80110eb9ca69d123; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:1126*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1126*FLEN/8, x10, x6, x7)

inst_587:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:1128*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1128*FLEN/8, x10, x6, x7)

inst_588:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x10eb9ca69d123 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0x093dbe3aa0387 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80110eb9ca69d123; op2val:0x7fb093dbe3aa0387;
valaddr_reg:x9; val_offset:1130*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1130*FLEN/8, x10, x6, x7)

inst_589:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x093dbe3aa0387 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x10eb9ca69d123 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb093dbe3aa0387; op2val:0x80110eb9ca69d123;
valaddr_reg:x9; val_offset:1132*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1132*FLEN/8, x10, x6, x7)

inst_590:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x10eb9ca69d123 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80110eb9ca69d123; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:1134*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1134*FLEN/8, x10, x6, x7)

inst_591:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:1136*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1136*FLEN/8, x10, x6, x7)

inst_592:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x1b4ac2dd761b7 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xf6025caa2d205 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8001b4ac2dd761b7; op2val:0xffdf6025caa2d205;
valaddr_reg:x9; val_offset:1138*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1138*FLEN/8, x10, x6, x7)

inst_593:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xf6025caa2d205 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x1b4ac2dd761b7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdf6025caa2d205; op2val:0x8001b4ac2dd761b7;
valaddr_reg:x9; val_offset:1140*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1140*FLEN/8, x10, x6, x7)

inst_594:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x1b4ac2dd761b7 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8001b4ac2dd761b7; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:1142*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1142*FLEN/8, x10, x6, x7)

inst_595:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:1144*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1144*FLEN/8, x10, x6, x7)

inst_596:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x1b4ac2dd761b7 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x9bff6a8783cf3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8001b4ac2dd761b7; op2val:0xffc9bff6a8783cf3;
valaddr_reg:x9; val_offset:1146*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1146*FLEN/8, x10, x6, x7)

inst_597:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x9bff6a8783cf3 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x1b4ac2dd761b7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc9bff6a8783cf3; op2val:0x8001b4ac2dd761b7;
valaddr_reg:x9; val_offset:1148*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1148*FLEN/8, x10, x6, x7)

inst_598:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x1b4ac2dd761b7 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8001b4ac2dd761b7; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:1150*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1150*FLEN/8, x10, x6, x7)

inst_599:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:1152*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1152*FLEN/8, x10, x6, x7)

inst_600:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x10eb9ca69d123 and fs2 == 1 and fe2 == 0x7fb and fm2 == 0x0c90875ccb5d8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80110eb9ca69d123; op2val:0xffb0c90875ccb5d8;
valaddr_reg:x9; val_offset:1154*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1154*FLEN/8, x10, x6, x7)

inst_601:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0x0c90875ccb5d8 and fs2 == 1 and fe2 == 0x001 and fm2 == 0x10eb9ca69d123 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffb0c90875ccb5d8; op2val:0x80110eb9ca69d123;
valaddr_reg:x9; val_offset:1156*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1156*FLEN/8, x10, x6, x7)

inst_602:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x10eb9ca69d123 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80110eb9ca69d123; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:1158*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1158*FLEN/8, x10, x6, x7)

inst_603:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:1160*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1160*FLEN/8, x10, x6, x7)

inst_604:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x10eb9ca69d123 and fs2 == 1 and fe2 == 0x7fb and fm2 == 0xae9e55abc765f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80110eb9ca69d123; op2val:0xffbae9e55abc765f;
valaddr_reg:x9; val_offset:1162*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1162*FLEN/8, x10, x6, x7)

inst_605:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0xae9e55abc765f and fs2 == 1 and fe2 == 0x001 and fm2 == 0x10eb9ca69d123 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffbae9e55abc765f; op2val:0x80110eb9ca69d123;
valaddr_reg:x9; val_offset:1164*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1164*FLEN/8, x10, x6, x7)

inst_606:// fs1 == 1 and fe1 == 0x001 and fm1 == 0x10eb9ca69d123 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80110eb9ca69d123; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:1166*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1166*FLEN/8, x10, x6, x7)

inst_607:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:1168*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1168*FLEN/8, x10, x6, x7)

inst_608:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x1b4ac2dd761b7 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0x47f2e5cadc271 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8001b4ac2dd761b7; op2val:0xffd47f2e5cadc271;
valaddr_reg:x9; val_offset:1170*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1170*FLEN/8, x10, x6, x7)

inst_609:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0x47f2e5cadc271 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x1b4ac2dd761b7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffd47f2e5cadc271; op2val:0x8001b4ac2dd761b7;
valaddr_reg:x9; val_offset:1172*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1172*FLEN/8, x10, x6, x7)

inst_610:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x1b4ac2dd761b7 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8001b4ac2dd761b7; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:1174*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1174*FLEN/8, x10, x6, x7)

inst_611:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0x0;
valaddr_reg:x9; val_offset:1176*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1176*FLEN/8, x10, x6, x7)

inst_612:// fs1 == 1 and fe1 == 0x400 and fm1 == 0x2fa24c650ac14 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xc002fa24c650ac14; op2val:0x0;
valaddr_reg:x9; val_offset:1178*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1178*FLEN/8, x10, x6, x7)

inst_613:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x400 and fm2 == 0x2fa24c650ac14 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0xc002fa24c650ac14;
valaddr_reg:x9; val_offset:1180*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1180*FLEN/8, x10, x6, x7)

inst_614:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x0e3e4312fc728 and fs2 == 1 and fe2 == 0x400 and fm2 == 0x2fa24c650ac14 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc0e3e4312fc728; op2val:0xc002fa24c650ac14;
valaddr_reg:x9; val_offset:1182*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1182*FLEN/8, x10, x6, x7)

inst_615:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:1184*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1184*FLEN/8, x10, x6, x7)

inst_616:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0xd4e5c31a3975f and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fdd4e5c31a3975f; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:1186*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1186*FLEN/8, x10, x6, x7)

inst_617:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0xd4e5c31a3975f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0x7fdd4e5c31a3975f;
valaddr_reg:x9; val_offset:1188*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1188*FLEN/8, x10, x6, x7)

inst_618:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:1190*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1190*FLEN/8, x10, x6, x7)

inst_619:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:1192*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1192*FLEN/8, x10, x6, x7)

inst_620:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:1194*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1194*FLEN/8, x10, x6, x7)

inst_621:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:1196*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1196*FLEN/8, x10, x6, x7)

inst_622:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0xd4e5c31a3975f and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fdd4e5c31a3975f; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:1198*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1198*FLEN/8, x10, x6, x7)

inst_623:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:1200*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1200*FLEN/8, x10, x6, x7)

inst_624:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:1202*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1202*FLEN/8, x10, x6, x7)

inst_625:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:1204*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1204*FLEN/8, x10, x6, x7)

inst_626:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0xd4e5c31a3975f and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fdd4e5c31a3975f; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:1206*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1206*FLEN/8, x10, x6, x7)

inst_627:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:1208*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1208*FLEN/8, x10, x6, x7)

inst_628:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:1210*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1210*FLEN/8, x10, x6, x7)

inst_629:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:1212*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1212*FLEN/8, x10, x6, x7)

inst_630:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0xd4e5c31a3975f and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fdd4e5c31a3975f; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:1214*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1214*FLEN/8, x10, x6, x7)

inst_631:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:1216*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1216*FLEN/8, x10, x6, x7)

inst_632:// fs1 == 0 and fe1 == 0x7fd and fm1 == 0xd4e5c31a3975f and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fdd4e5c31a3975f; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:1218*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1218*FLEN/8, x10, x6, x7)

inst_633:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:1220*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1220*FLEN/8, x10, x6, x7)

inst_634:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x097889c6218ac and fs2 == 0 and fe2 == 0x000 and fm2 == 0x21b5c662d267b and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x97889c6218ac; op2val:0x21b5c662d267b;
valaddr_reg:x9; val_offset:1222*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1222*FLEN/8, x10, x6, x7)

inst_635:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x21b5c662d267b and fs2 == 0 and fe2 == 0x000 and fm2 == 0x097889c6218ac and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x21b5c662d267b; op2val:0x97889c6218ac;
valaddr_reg:x9; val_offset:1224*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1224*FLEN/8, x10, x6, x7)

inst_636:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x097889c6218ac and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x97889c6218ac; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:1226*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1226*FLEN/8, x10, x6, x7)

inst_637:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x097889c6218ac and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0x97889c6218ac;
valaddr_reg:x9; val_offset:1228*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1228*FLEN/8, x10, x6, x7)

inst_638:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:1230*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1230*FLEN/8, x10, x6, x7)

inst_639:// fs1 == 0 and fe1 == 0x002 and fm1 == 0xd98ae8b28d198 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x197d0ed8b1e34 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2d98ae8b28d198; op2val:0x197d0ed8b1e34;
valaddr_reg:x9; val_offset:1232*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1232*FLEN/8, x10, x6, x7)

inst_640:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x197d0ed8b1e34 and fs2 == 0 and fe2 == 0x002 and fm2 == 0xd98ae8b28d198 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x197d0ed8b1e34; op2val:0x2d98ae8b28d198;
valaddr_reg:x9; val_offset:1234*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1234*FLEN/8, x10, x6, x7)

inst_641:// fs1 == 0 and fe1 == 0x002 and fm1 == 0xd98ae8b28d198 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2d98ae8b28d198; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:1236*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1236*FLEN/8, x10, x6, x7)

inst_642:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 0 and fe2 == 0x002 and fm2 == 0xd98ae8b28d198 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0x2d98ae8b28d198;
valaddr_reg:x9; val_offset:1238*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1238*FLEN/8, x10, x6, x7)

inst_643:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:1240*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1240*FLEN/8, x10, x6, x7)

inst_644:// fs1 == 0 and fe1 == 0x002 and fm1 == 0xd98ae8b28d198 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x105c326c5af30 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2d98ae8b28d198; op2val:0x105c326c5af30;
valaddr_reg:x9; val_offset:1242*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1242*FLEN/8, x10, x6, x7)

inst_645:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x105c326c5af30 and fs2 == 0 and fe2 == 0x002 and fm2 == 0xd98ae8b28d198 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x105c326c5af30; op2val:0x2d98ae8b28d198;
valaddr_reg:x9; val_offset:1244*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1244*FLEN/8, x10, x6, x7)

inst_646:// fs1 == 0 and fe1 == 0x002 and fm1 == 0xd98ae8b28d198 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2d98ae8b28d198; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:1246*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1246*FLEN/8, x10, x6, x7)

inst_647:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:1248*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1248*FLEN/8, x10, x6, x7)

inst_648:// fs1 == 0 and fe1 == 0x002 and fm1 == 0xd98ae8b28d198 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0d64b86ad9094 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2d98ae8b28d198; op2val:0xd64b86ad9094;
valaddr_reg:x9; val_offset:1250*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1250*FLEN/8, x10, x6, x7)

inst_649:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0d64b86ad9094 and fs2 == 0 and fe2 == 0x002 and fm2 == 0xd98ae8b28d198 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xd64b86ad9094; op2val:0x2d98ae8b28d198;
valaddr_reg:x9; val_offset:1252*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1252*FLEN/8, x10, x6, x7)

inst_650:// fs1 == 0 and fe1 == 0x002 and fm1 == 0xd98ae8b28d198 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2d98ae8b28d198; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:1254*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1254*FLEN/8, x10, x6, x7)

inst_651:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:1256*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1256*FLEN/8, x10, x6, x7)

inst_652:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:1258*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1258*FLEN/8, x10, x6, x7)

inst_653:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:1260*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1260*FLEN/8, x10, x6, x7)

inst_654:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:1262*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1262*FLEN/8, x10, x6, x7)

inst_655:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:1264*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1264*FLEN/8, x10, x6, x7)

inst_656:// fs1 == 0 and fe1 == 0x002 and fm1 == 0xd98ae8b28d198 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0d8fae5b11a26 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2d98ae8b28d198; op2val:0x8000d8fae5b11a26;
valaddr_reg:x9; val_offset:1266*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1266*FLEN/8, x10, x6, x7)

inst_657:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0d8fae5b11a26 and fs2 == 0 and fe2 == 0x002 and fm2 == 0xd98ae8b28d198 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000d8fae5b11a26; op2val:0x2d98ae8b28d198;
valaddr_reg:x9; val_offset:1268*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1268*FLEN/8, x10, x6, x7)

inst_658:// fs1 == 0 and fe1 == 0x002 and fm1 == 0xd98ae8b28d198 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2d98ae8b28d198; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:1270*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1270*FLEN/8, x10, x6, x7)

inst_659:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:1272*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1272*FLEN/8, x10, x6, x7)

inst_660:// fs1 == 0 and fe1 == 0x002 and fm1 == 0xd98ae8b28d198 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x15be852c0ecf4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2d98ae8b28d198; op2val:0x80015be852c0ecf4;
valaddr_reg:x9; val_offset:1274*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1274*FLEN/8, x10, x6, x7)

inst_661:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x15be852c0ecf4 and fs2 == 0 and fe2 == 0x002 and fm2 == 0xd98ae8b28d198 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80015be852c0ecf4; op2val:0x2d98ae8b28d198;
valaddr_reg:x9; val_offset:1276*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1276*FLEN/8, x10, x6, x7)

inst_662:// fs1 == 0 and fe1 == 0x002 and fm1 == 0xd98ae8b28d198 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x2d98ae8b28d198; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:1278*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1278*FLEN/8, x10, x6, x7)

inst_663:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:1280*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1280*FLEN/8, x10, x6, x7)

inst_664:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:1282*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1282*FLEN/8, x10, x6, x7)

inst_665:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0x0;
valaddr_reg:x9; val_offset:1284*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1284*FLEN/8, x10, x6, x7)
RVTEST_SIGBASE(x6,signature_x6_5)

inst_666:// fs1 == 0 and fe1 == 0x402 and fm1 == 0x076ab4deeec91 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x402076ab4deeec91; op2val:0x0;
valaddr_reg:x9; val_offset:1286*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1286*FLEN/8, x10, x6, x7)

inst_667:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x402 and fm2 == 0x076ab4deeec91 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x402076ab4deeec91;
valaddr_reg:x9; val_offset:1288*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1288*FLEN/8, x10, x6, x7)

inst_668:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x5eb561bd4f6b8 and fs2 == 0 and fe2 == 0x402 and fm2 == 0x076ab4deeec91 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x5eb561bd4f6b8; op2val:0x402076ab4deeec91;
valaddr_reg:x9; val_offset:1290*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1290*FLEN/8, x10, x6, x7)

inst_669:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:1292*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1292*FLEN/8, x10, x6, x7)

inst_670:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0x4dcb3b62b25ff and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fc4dcb3b62b25ff; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:1294*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1294*FLEN/8, x10, x6, x7)

inst_671:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0x4dcb3b62b25ff and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0x7fc4dcb3b62b25ff;
valaddr_reg:x9; val_offset:1296*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1296*FLEN/8, x10, x6, x7)

inst_672:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:1298*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1298*FLEN/8, x10, x6, x7)

inst_673:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:1300*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1300*FLEN/8, x10, x6, x7)

inst_674:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:1302*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1302*FLEN/8, x10, x6, x7)

inst_675:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:1304*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1304*FLEN/8, x10, x6, x7)

inst_676:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0x4dcb3b62b25ff and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fc4dcb3b62b25ff; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:1306*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1306*FLEN/8, x10, x6, x7)

inst_677:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:1308*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1308*FLEN/8, x10, x6, x7)

inst_678:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:1310*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1310*FLEN/8, x10, x6, x7)

inst_679:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:1312*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1312*FLEN/8, x10, x6, x7)

inst_680:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0x4dcb3b62b25ff and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fc4dcb3b62b25ff; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:1314*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1314*FLEN/8, x10, x6, x7)

inst_681:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:1316*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1316*FLEN/8, x10, x6, x7)

inst_682:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:1318*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1318*FLEN/8, x10, x6, x7)

inst_683:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:1320*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1320*FLEN/8, x10, x6, x7)

inst_684:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0x4dcb3b62b25ff and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fc4dcb3b62b25ff; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:1322*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1322*FLEN/8, x10, x6, x7)

inst_685:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:1324*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1324*FLEN/8, x10, x6, x7)

inst_686:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0x4dcb3b62b25ff and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fc4dcb3b62b25ff; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:1326*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1326*FLEN/8, x10, x6, x7)

inst_687:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:1328*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1328*FLEN/8, x10, x6, x7)

inst_688:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x21b5c662d267b and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x21b5c662d267b; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:1330*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1330*FLEN/8, x10, x6, x7)

inst_689:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x21b5c662d267b and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0x21b5c662d267b;
valaddr_reg:x9; val_offset:1332*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1332*FLEN/8, x10, x6, x7)

inst_690:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:1334*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1334*FLEN/8, x10, x6, x7)

inst_691:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x5119bfdc380d2 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x028c817c11c9f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x15119bfdc380d2; op2val:0x28c817c11c9f;
valaddr_reg:x9; val_offset:1336*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1336*FLEN/8, x10, x6, x7)

inst_692:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x028c817c11c9f and fs2 == 0 and fe2 == 0x001 and fm2 == 0x5119bfdc380d2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x28c817c11c9f; op2val:0x15119bfdc380d2;
valaddr_reg:x9; val_offset:1338*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1338*FLEN/8, x10, x6, x7)

inst_693:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x5119bfdc380d2 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x15119bfdc380d2; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:1340*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1340*FLEN/8, x10, x6, x7)

inst_694:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x5119bfdc380d2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0x15119bfdc380d2;
valaddr_reg:x9; val_offset:1342*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1342*FLEN/8, x10, x6, x7)

inst_695:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:1344*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1344*FLEN/8, x10, x6, x7)

inst_696:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x5119bfdc380d2 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x01a2d1d7a2b1e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x15119bfdc380d2; op2val:0x1a2d1d7a2b1e;
valaddr_reg:x9; val_offset:1346*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1346*FLEN/8, x10, x6, x7)

inst_697:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x01a2d1d7a2b1e and fs2 == 0 and fe2 == 0x001 and fm2 == 0x5119bfdc380d2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1a2d1d7a2b1e; op2val:0x15119bfdc380d2;
valaddr_reg:x9; val_offset:1348*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1348*FLEN/8, x10, x6, x7)

inst_698:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x5119bfdc380d2 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x15119bfdc380d2; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:1350*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1350*FLEN/8, x10, x6, x7)

inst_699:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:1352*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1352*FLEN/8, x10, x6, x7)

inst_700:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x5119bfdc380d2 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0156df3de280f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x15119bfdc380d2; op2val:0x156df3de280f;
valaddr_reg:x9; val_offset:1354*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1354*FLEN/8, x10, x6, x7)

inst_701:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0156df3de280f and fs2 == 0 and fe2 == 0x001 and fm2 == 0x5119bfdc380d2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x156df3de280f; op2val:0x15119bfdc380d2;
valaddr_reg:x9; val_offset:1356*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1356*FLEN/8, x10, x6, x7)

inst_702:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x5119bfdc380d2 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x15119bfdc380d2; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:1358*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1358*FLEN/8, x10, x6, x7)

inst_703:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:1360*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1360*FLEN/8, x10, x6, x7)

inst_704:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x21b5c662d267b and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0a23bfe815416 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x21b5c662d267b; op2val:0x8000a23bfe815416;
valaddr_reg:x9; val_offset:1362*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1362*FLEN/8, x10, x6, x7)

inst_705:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0a23bfe815416 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x21b5c662d267b and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000a23bfe815416; op2val:0x21b5c662d267b;
valaddr_reg:x9; val_offset:1364*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1364*FLEN/8, x10, x6, x7)

inst_706:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x21b5c662d267b and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x21b5c662d267b; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:1366*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1366*FLEN/8, x10, x6, x7)

inst_707:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:1368*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1368*FLEN/8, x10, x6, x7)

inst_708:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x21b5c662d267b and fs2 == 1 and fe2 == 0x000 and fm2 == 0x042929a1b2ce1 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x21b5c662d267b; op2val:0x800042929a1b2ce1;
valaddr_reg:x9; val_offset:1370*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1370*FLEN/8, x10, x6, x7)

inst_709:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x042929a1b2ce1 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x21b5c662d267b and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800042929a1b2ce1; op2val:0x21b5c662d267b;
valaddr_reg:x9; val_offset:1372*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1372*FLEN/8, x10, x6, x7)

inst_710:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x21b5c662d267b and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x21b5c662d267b; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:1374*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1374*FLEN/8, x10, x6, x7)

inst_711:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:1376*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1376*FLEN/8, x10, x6, x7)

inst_712:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x5119bfdc380d2 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x015b2b091b5d1 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x15119bfdc380d2; op2val:0x800015b2b091b5d1;
valaddr_reg:x9; val_offset:1378*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1378*FLEN/8, x10, x6, x7)

inst_713:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x015b2b091b5d1 and fs2 == 0 and fe2 == 0x001 and fm2 == 0x5119bfdc380d2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800015b2b091b5d1; op2val:0x15119bfdc380d2;
valaddr_reg:x9; val_offset:1380*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1380*FLEN/8, x10, x6, x7)

inst_714:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x5119bfdc380d2 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x15119bfdc380d2; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:1382*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1382*FLEN/8, x10, x6, x7)

inst_715:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:1384*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1384*FLEN/8, x10, x6, x7)

inst_716:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x5119bfdc380d2 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x022ca6eace47f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x15119bfdc380d2; op2val:0x800022ca6eace47f;
valaddr_reg:x9; val_offset:1386*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1386*FLEN/8, x10, x6, x7)

inst_717:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x022ca6eace47f and fs2 == 0 and fe2 == 0x001 and fm2 == 0x5119bfdc380d2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800022ca6eace47f; op2val:0x15119bfdc380d2;
valaddr_reg:x9; val_offset:1388*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1388*FLEN/8, x10, x6, x7)

inst_718:// fs1 == 0 and fe1 == 0x001 and fm1 == 0x5119bfdc380d2 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x15119bfdc380d2; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:1390*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1390*FLEN/8, x10, x6, x7)

inst_719:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:1392*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1392*FLEN/8, x10, x6, x7)

inst_720:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x21b5c662d267b and fs2 == 1 and fe2 == 0x000 and fm2 == 0x069fbb598d312 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x21b5c662d267b; op2val:0x800069fbb598d312;
valaddr_reg:x9; val_offset:1394*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1394*FLEN/8, x10, x6, x7)

inst_721:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x069fbb598d312 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x21b5c662d267b and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800069fbb598d312; op2val:0x21b5c662d267b;
valaddr_reg:x9; val_offset:1396*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1396*FLEN/8, x10, x6, x7)

inst_722:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x21b5c662d267b and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x21b5c662d267b; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:1398*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1398*FLEN/8, x10, x6, x7)

inst_723:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0x0;
valaddr_reg:x9; val_offset:1400*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1400*FLEN/8, x10, x6, x7)

inst_724:// fs1 == 0 and fe1 == 0x400 and fm1 == 0x77096ee4d2f12 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x40077096ee4d2f12; op2val:0x0;
valaddr_reg:x9; val_offset:1402*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1402*FLEN/8, x10, x6, x7)

inst_725:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x400 and fm2 == 0x77096ee4d2f12 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x40077096ee4d2f12;
valaddr_reg:x9; val_offset:1404*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1404*FLEN/8, x10, x6, x7)

inst_726:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x035efa3d150a6 and fs2 == 0 and fe2 == 0x400 and fm2 == 0x77096ee4d2f12 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x35efa3d150a6; op2val:0x40077096ee4d2f12;
valaddr_reg:x9; val_offset:1406*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1406*FLEN/8, x10, x6, x7)

inst_727:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:1408*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1408*FLEN/8, x10, x6, x7)

inst_728:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0xf8c50a18d0c04 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fbf8c50a18d0c04; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:1410*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1410*FLEN/8, x10, x6, x7)

inst_729:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0xf8c50a18d0c04 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0x7fbf8c50a18d0c04;
valaddr_reg:x9; val_offset:1412*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1412*FLEN/8, x10, x6, x7)

inst_730:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:1414*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1414*FLEN/8, x10, x6, x7)

inst_731:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:1416*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1416*FLEN/8, x10, x6, x7)

inst_732:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 0 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0x7ff0000000000000;
valaddr_reg:x9; val_offset:1418*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1418*FLEN/8, x10, x6, x7)

inst_733:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:1420*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1420*FLEN/8, x10, x6, x7)

inst_734:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0xf8c50a18d0c04 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fbf8c50a18d0c04; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:1422*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1422*FLEN/8, x10, x6, x7)

inst_735:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:1424*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1424*FLEN/8, x10, x6, x7)

inst_736:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:1426*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1426*FLEN/8, x10, x6, x7)

inst_737:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:1428*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1428*FLEN/8, x10, x6, x7)

inst_738:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0xf8c50a18d0c04 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fbf8c50a18d0c04; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:1430*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1430*FLEN/8, x10, x6, x7)

inst_739:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:1432*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1432*FLEN/8, x10, x6, x7)

inst_740:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:1434*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1434*FLEN/8, x10, x6, x7)

inst_741:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:1436*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1436*FLEN/8, x10, x6, x7)

inst_742:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0xf8c50a18d0c04 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fbf8c50a18d0c04; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:1438*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1438*FLEN/8, x10, x6, x7)

inst_743:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:1440*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1440*FLEN/8, x10, x6, x7)

inst_744:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0xf8c50a18d0c04 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fbf8c50a18d0c04; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:1442*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1442*FLEN/8, x10, x6, x7)

inst_745:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:1444*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1444*FLEN/8, x10, x6, x7)

inst_746:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x197d0ed8b1e34 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x197d0ed8b1e34; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:1446*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1446*FLEN/8, x10, x6, x7)

inst_747:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x197d0ed8b1e34 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0x197d0ed8b1e34;
valaddr_reg:x9; val_offset:1448*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1448*FLEN/8, x10, x6, x7)

inst_748:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:1450*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1450*FLEN/8, x10, x6, x7)

inst_749:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x028c817c11c9f and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x28c817c11c9f; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:1452*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1452*FLEN/8, x10, x6, x7)

inst_750:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x028c817c11c9f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0x28c817c11c9f;
valaddr_reg:x9; val_offset:1454*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1454*FLEN/8, x10, x6, x7)

inst_751:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:1456*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1456*FLEN/8, x10, x6, x7)

inst_752:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:1458*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1458*FLEN/8, x10, x6, x7)

inst_753:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:1460*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1460*FLEN/8, x10, x6, x7)

inst_754:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:1462*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1462*FLEN/8, x10, x6, x7)

inst_755:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:1464*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1464*FLEN/8, x10, x6, x7)

inst_756:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x197d0ed8b1e34 and fs2 == 1 and fe2 == 0x002 and fm2 == 0xfafb7b5426c47 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x197d0ed8b1e34; op2val:0x802fafb7b5426c47;
valaddr_reg:x9; val_offset:1466*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1466*FLEN/8, x10, x6, x7)

inst_757:// fs1 == 1 and fe1 == 0x002 and fm1 == 0xfafb7b5426c47 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x197d0ed8b1e34 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x802fafb7b5426c47; op2val:0x197d0ed8b1e34;
valaddr_reg:x9; val_offset:1468*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1468*FLEN/8, x10, x6, x7)

inst_758:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x197d0ed8b1e34 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x197d0ed8b1e34; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:1470*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1470*FLEN/8, x10, x6, x7)

inst_759:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:1472*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1472*FLEN/8, x10, x6, x7)

inst_760:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x197d0ed8b1e34 and fs2 == 1 and fe2 == 0x001 and fm2 == 0xa0144329d87cc and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x197d0ed8b1e34; op2val:0x801a0144329d87cc;
valaddr_reg:x9; val_offset:1474*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1474*FLEN/8, x10, x6, x7)

inst_761:// fs1 == 1 and fe1 == 0x001 and fm1 == 0xa0144329d87cc and fs2 == 0 and fe2 == 0x000 and fm2 == 0x197d0ed8b1e34 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x801a0144329d87cc; op2val:0x197d0ed8b1e34;
valaddr_reg:x9; val_offset:1476*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1476*FLEN/8, x10, x6, x7)

inst_762:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x197d0ed8b1e34 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x197d0ed8b1e34; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:1478*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1478*FLEN/8, x10, x6, x7)

inst_763:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:1480*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1480*FLEN/8, x10, x6, x7)

inst_764:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:1482*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1482*FLEN/8, x10, x6, x7)

inst_765:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:1484*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1484*FLEN/8, x10, x6, x7)

inst_766:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:1486*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1486*FLEN/8, x10, x6, x7)

inst_767:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:1488*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1488*FLEN/8, x10, x6, x7)

inst_768:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x197d0ed8b1e34 and fs2 == 1 and fe2 == 0x002 and fm2 == 0x4b32977d93970 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x197d0ed8b1e34; op2val:0x8024b32977d93970;
valaddr_reg:x9; val_offset:1490*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1490*FLEN/8, x10, x6, x7)

inst_769:// fs1 == 1 and fe1 == 0x002 and fm1 == 0x4b32977d93970 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x197d0ed8b1e34 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8024b32977d93970; op2val:0x197d0ed8b1e34;
valaddr_reg:x9; val_offset:1492*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1492*FLEN/8, x10, x6, x7)

inst_770:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x197d0ed8b1e34 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x197d0ed8b1e34; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:1494*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1494*FLEN/8, x10, x6, x7)

inst_771:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0x0;
valaddr_reg:x9; val_offset:1496*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1496*FLEN/8, x10, x6, x7)

inst_772:// fs1 == 0 and fe1 == 0x400 and fm1 == 0x1b91ae09e503b and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x4001b91ae09e503b; op2val:0x0;
valaddr_reg:x9; val_offset:1498*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1498*FLEN/8, x10, x6, x7)

inst_773:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x400 and fm2 == 0x1b91ae09e503b and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x4001b91ae09e503b;
valaddr_reg:x9; val_offset:1500*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1500*FLEN/8, x10, x6, x7)

inst_774:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xfee29476f2e06 and fs2 == 0 and fe2 == 0x400 and fm2 == 0x1b91ae09e503b and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xfee29476f2e06; op2val:0x4001b91ae09e503b;
valaddr_reg:x9; val_offset:1502*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1502*FLEN/8, x10, x6, x7)

inst_775:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:1504*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1504*FLEN/8, x10, x6, x7)

inst_776:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x43fe46d2b7ce6 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb43fe46d2b7ce6; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:1506*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1506*FLEN/8, x10, x6, x7)

inst_777:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0x43fe46d2b7ce6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0x7fb43fe46d2b7ce6;
valaddr_reg:x9; val_offset:1508*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1508*FLEN/8, x10, x6, x7)

inst_778:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:1510*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1510*FLEN/8, x10, x6, x7)

inst_779:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:1512*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1512*FLEN/8, x10, x6, x7)

inst_780:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x94fdd88765c1f and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe94fdd88765c1f; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:1514*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1514*FLEN/8, x10, x6, x7)

inst_781:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x94fdd88765c1f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0x7fe94fdd88765c1f;
valaddr_reg:x9; val_offset:1516*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1516*FLEN/8, x10, x6, x7)

inst_782:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:1518*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1518*FLEN/8, x10, x6, x7)

inst_783:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x43fe46d2b7ce6 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb43fe46d2b7ce6; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:1520*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1520*FLEN/8, x10, x6, x7)

inst_784:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:1522*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1522*FLEN/8, x10, x6, x7)

inst_785:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x94fdd88765c1f and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe94fdd88765c1f; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:1524*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1524*FLEN/8, x10, x6, x7)

inst_786:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:1526*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1526*FLEN/8, x10, x6, x7)

inst_787:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x94fdd88765c1f and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe94fdd88765c1f; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:1528*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1528*FLEN/8, x10, x6, x7)

inst_788:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:1530*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1530*FLEN/8, x10, x6, x7)

inst_789:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x43fe46d2b7ce6 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb43fe46d2b7ce6; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:1532*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1532*FLEN/8, x10, x6, x7)

inst_790:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:1534*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1534*FLEN/8, x10, x6, x7)

inst_791:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x94fdd88765c1f and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe94fdd88765c1f; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:1536*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1536*FLEN/8, x10, x6, x7)

inst_792:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:1538*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1538*FLEN/8, x10, x6, x7)

inst_793:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x94fdd88765c1f and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe94fdd88765c1f; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:1540*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1540*FLEN/8, x10, x6, x7)
RVTEST_SIGBASE(x6,signature_x6_6)

inst_794:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:1542*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1542*FLEN/8, x10, x6, x7)

inst_795:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x43fe46d2b7ce6 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb43fe46d2b7ce6; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:1544*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1544*FLEN/8, x10, x6, x7)

inst_796:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:1546*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1546*FLEN/8, x10, x6, x7)

inst_797:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x43fe46d2b7ce6 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb43fe46d2b7ce6; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:1548*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1548*FLEN/8, x10, x6, x7)

inst_798:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:1550*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1550*FLEN/8, x10, x6, x7)

inst_799:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x105c326c5af30 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x105c326c5af30; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:1552*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1552*FLEN/8, x10, x6, x7)

inst_800:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x105c326c5af30 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0x105c326c5af30;
valaddr_reg:x9; val_offset:1554*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1554*FLEN/8, x10, x6, x7)

inst_801:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:1556*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1556*FLEN/8, x10, x6, x7)

inst_802:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x01a2d1d7a2b1e and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x1a2d1d7a2b1e; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:1558*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1558*FLEN/8, x10, x6, x7)

inst_803:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x01a2d1d7a2b1e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0x1a2d1d7a2b1e;
valaddr_reg:x9; val_offset:1560*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1560*FLEN/8, x10, x6, x7)

inst_804:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:1562*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1562*FLEN/8, x10, x6, x7)

inst_805:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:1564*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1564*FLEN/8, x10, x6, x7)

inst_806:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:1566*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1566*FLEN/8, x10, x6, x7)

inst_807:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x105c326c5af30 and fs2 == 1 and fe2 == 0x002 and fm2 == 0xfafb7b5426c47 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x105c326c5af30; op2val:0x802fafb7b5426c47;
valaddr_reg:x9; val_offset:1568*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1568*FLEN/8, x10, x6, x7)

inst_808:// fs1 == 1 and fe1 == 0x002 and fm1 == 0xfafb7b5426c47 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x105c326c5af30 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x802fafb7b5426c47; op2val:0x105c326c5af30;
valaddr_reg:x9; val_offset:1570*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1570*FLEN/8, x10, x6, x7)

inst_809:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x105c326c5af30 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x105c326c5af30; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:1572*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1572*FLEN/8, x10, x6, x7)

inst_810:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:1574*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1574*FLEN/8, x10, x6, x7)

inst_811:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x105c326c5af30 and fs2 == 1 and fe2 == 0x001 and fm2 == 0xa0144329d87cc and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x105c326c5af30; op2val:0x801a0144329d87cc;
valaddr_reg:x9; val_offset:1576*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1576*FLEN/8, x10, x6, x7)

inst_812:// fs1 == 1 and fe1 == 0x001 and fm1 == 0xa0144329d87cc and fs2 == 0 and fe2 == 0x000 and fm2 == 0x105c326c5af30 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x801a0144329d87cc; op2val:0x105c326c5af30;
valaddr_reg:x9; val_offset:1578*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1578*FLEN/8, x10, x6, x7)

inst_813:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x105c326c5af30 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x105c326c5af30; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:1580*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1580*FLEN/8, x10, x6, x7)

inst_814:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:1582*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1582*FLEN/8, x10, x6, x7)

inst_815:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:1584*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1584*FLEN/8, x10, x6, x7)

inst_816:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:1586*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1586*FLEN/8, x10, x6, x7)

inst_817:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:1588*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1588*FLEN/8, x10, x6, x7)

inst_818:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:1590*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1590*FLEN/8, x10, x6, x7)

inst_819:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x105c326c5af30 and fs2 == 1 and fe2 == 0x002 and fm2 == 0x4b32977d93970 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x105c326c5af30; op2val:0x8024b32977d93970;
valaddr_reg:x9; val_offset:1592*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1592*FLEN/8, x10, x6, x7)

inst_820:// fs1 == 1 and fe1 == 0x002 and fm1 == 0x4b32977d93970 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x105c326c5af30 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8024b32977d93970; op2val:0x105c326c5af30;
valaddr_reg:x9; val_offset:1594*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1594*FLEN/8, x10, x6, x7)

inst_821:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x105c326c5af30 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x105c326c5af30; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:1596*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1596*FLEN/8, x10, x6, x7)

inst_822:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0x0;
valaddr_reg:x9; val_offset:1598*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1598*FLEN/8, x10, x6, x7)

inst_823:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x6c0679d004e5b and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff6c0679d004e5b; op2val:0x0;
valaddr_reg:x9; val_offset:1600*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1600*FLEN/8, x10, x6, x7)

inst_824:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x6c0679d004e5b and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x3ff6c0679d004e5b;
valaddr_reg:x9; val_offset:1602*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1602*FLEN/8, x10, x6, x7)

inst_825:// fs1 == 0 and fe1 == 0x000 and fm1 == 0xa399f83b8d7e3 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x6c0679d004e5b and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xa399f83b8d7e3; op2val:0x3ff6c0679d004e5b;
valaddr_reg:x9; val_offset:1604*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1604*FLEN/8, x10, x6, x7)

inst_826:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:1606*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1606*FLEN/8, x10, x6, x7)

inst_827:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x093dbe3aa0387 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb093dbe3aa0387; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:1608*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1608*FLEN/8, x10, x6, x7)

inst_828:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 0 and fe2 == 0x7fb and fm2 == 0x093dbe3aa0387 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0x7fb093dbe3aa0387;
valaddr_reg:x9; val_offset:1610*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1610*FLEN/8, x10, x6, x7)

inst_829:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:1612*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1612*FLEN/8, x10, x6, x7)

inst_830:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:1614*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1614*FLEN/8, x10, x6, x7)

inst_831:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x4b8d2dc948469 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe4b8d2dc948469; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:1616*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1616*FLEN/8, x10, x6, x7)

inst_832:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x4b8d2dc948469 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0x7fe4b8d2dc948469;
valaddr_reg:x9; val_offset:1618*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1618*FLEN/8, x10, x6, x7)

inst_833:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:1620*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1620*FLEN/8, x10, x6, x7)

inst_834:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x093dbe3aa0387 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb093dbe3aa0387; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:1622*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1622*FLEN/8, x10, x6, x7)

inst_835:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:1624*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1624*FLEN/8, x10, x6, x7)

inst_836:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x4b8d2dc948469 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe4b8d2dc948469; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:1626*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1626*FLEN/8, x10, x6, x7)

inst_837:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:1628*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1628*FLEN/8, x10, x6, x7)

inst_838:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x4b8d2dc948469 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe4b8d2dc948469; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:1630*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1630*FLEN/8, x10, x6, x7)

inst_839:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:1632*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1632*FLEN/8, x10, x6, x7)

inst_840:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x093dbe3aa0387 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb093dbe3aa0387; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:1634*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1634*FLEN/8, x10, x6, x7)

inst_841:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:1636*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1636*FLEN/8, x10, x6, x7)

inst_842:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x4b8d2dc948469 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe4b8d2dc948469; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:1638*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1638*FLEN/8, x10, x6, x7)

inst_843:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:1640*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1640*FLEN/8, x10, x6, x7)

inst_844:// fs1 == 0 and fe1 == 0x7fe and fm1 == 0x4b8d2dc948469 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fe4b8d2dc948469; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:1642*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1642*FLEN/8, x10, x6, x7)

inst_845:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:1644*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1644*FLEN/8, x10, x6, x7)

inst_846:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x093dbe3aa0387 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb093dbe3aa0387; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:1646*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1646*FLEN/8, x10, x6, x7)

inst_847:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:1648*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1648*FLEN/8, x10, x6, x7)

inst_848:// fs1 == 0 and fe1 == 0x7fb and fm1 == 0x093dbe3aa0387 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fb093dbe3aa0387; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:1650*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1650*FLEN/8, x10, x6, x7)

inst_849:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:1652*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1652*FLEN/8, x10, x6, x7)

inst_850:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0d64b86ad9094 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xd64b86ad9094; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:1654*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1654*FLEN/8, x10, x6, x7)

inst_851:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0d64b86ad9094 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0xd64b86ad9094;
valaddr_reg:x9; val_offset:1656*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1656*FLEN/8, x10, x6, x7)

inst_852:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:1658*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1658*FLEN/8, x10, x6, x7)

inst_853:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0156df3de280f and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x156df3de280f; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:1660*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1660*FLEN/8, x10, x6, x7)

inst_854:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0156df3de280f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0x156df3de280f;
valaddr_reg:x9; val_offset:1662*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1662*FLEN/8, x10, x6, x7)

inst_855:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:1664*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1664*FLEN/8, x10, x6, x7)

inst_856:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0d64b86ad9094 and fs2 == 1 and fe2 == 0x002 and fm2 == 0xfafb7b5426c47 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xd64b86ad9094; op2val:0x802fafb7b5426c47;
valaddr_reg:x9; val_offset:1666*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1666*FLEN/8, x10, x6, x7)

inst_857:// fs1 == 1 and fe1 == 0x002 and fm1 == 0xfafb7b5426c47 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0d64b86ad9094 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x802fafb7b5426c47; op2val:0xd64b86ad9094;
valaddr_reg:x9; val_offset:1668*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1668*FLEN/8, x10, x6, x7)

inst_858:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0d64b86ad9094 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xd64b86ad9094; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:1670*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1670*FLEN/8, x10, x6, x7)

inst_859:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:1672*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1672*FLEN/8, x10, x6, x7)

inst_860:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0d64b86ad9094 and fs2 == 1 and fe2 == 0x001 and fm2 == 0xa0144329d87cc and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xd64b86ad9094; op2val:0x801a0144329d87cc;
valaddr_reg:x9; val_offset:1674*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1674*FLEN/8, x10, x6, x7)

inst_861:// fs1 == 1 and fe1 == 0x001 and fm1 == 0xa0144329d87cc and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0d64b86ad9094 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x801a0144329d87cc; op2val:0xd64b86ad9094;
valaddr_reg:x9; val_offset:1676*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1676*FLEN/8, x10, x6, x7)

inst_862:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0d64b86ad9094 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xd64b86ad9094; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:1678*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1678*FLEN/8, x10, x6, x7)

inst_863:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:1680*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1680*FLEN/8, x10, x6, x7)

inst_864:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:1682*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1682*FLEN/8, x10, x6, x7)

inst_865:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:1684*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1684*FLEN/8, x10, x6, x7)

inst_866:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:1686*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1686*FLEN/8, x10, x6, x7)

inst_867:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:1688*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1688*FLEN/8, x10, x6, x7)

inst_868:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0d64b86ad9094 and fs2 == 1 and fe2 == 0x002 and fm2 == 0x4b32977d93970 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xd64b86ad9094; op2val:0x8024b32977d93970;
valaddr_reg:x9; val_offset:1690*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1690*FLEN/8, x10, x6, x7)

inst_869:// fs1 == 1 and fe1 == 0x002 and fm1 == 0x4b32977d93970 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0d64b86ad9094 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8024b32977d93970; op2val:0xd64b86ad9094;
valaddr_reg:x9; val_offset:1692*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1692*FLEN/8, x10, x6, x7)

inst_870:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0d64b86ad9094 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xd64b86ad9094; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:1694*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1694*FLEN/8, x10, x6, x7)

inst_871:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0x0;
valaddr_reg:x9; val_offset:1696*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1696*FLEN/8, x10, x6, x7)

inst_872:// fs1 == 0 and fe1 == 0x3ff and fm1 == 0x2a038f94d730b and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3ff2a038f94d730b; op2val:0x0;
valaddr_reg:x9; val_offset:1698*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1698*FLEN/8, x10, x6, x7)

inst_873:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x2a038f94d730b and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x3ff2a038f94d730b;
valaddr_reg:x9; val_offset:1700*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1700*FLEN/8, x10, x6, x7)

inst_874:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x85ef342c7a5c9 and fs2 == 0 and fe2 == 0x3ff and fm2 == 0x2a038f94d730b and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x85ef342c7a5c9; op2val:0x3ff2a038f94d730b;
valaddr_reg:x9; val_offset:1702*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1702*FLEN/8, x10, x6, x7)

inst_875:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:1704*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1704*FLEN/8, x10, x6, x7)

inst_876:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xf6025caa2d205 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdf6025caa2d205; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:1706*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1706*FLEN/8, x10, x6, x7)

inst_877:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xf6025caa2d205 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0xffdf6025caa2d205;
valaddr_reg:x9; val_offset:1708*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1708*FLEN/8, x10, x6, x7)

inst_878:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:1710*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1710*FLEN/8, x10, x6, x7)

inst_879:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:1712*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1712*FLEN/8, x10, x6, x7)

inst_880:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:1714*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1714*FLEN/8, x10, x6, x7)

inst_881:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:1716*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1716*FLEN/8, x10, x6, x7)

inst_882:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xf6025caa2d205 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdf6025caa2d205; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:1718*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1718*FLEN/8, x10, x6, x7)

inst_883:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:1720*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1720*FLEN/8, x10, x6, x7)

inst_884:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:1722*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1722*FLEN/8, x10, x6, x7)

inst_885:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:1724*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1724*FLEN/8, x10, x6, x7)

inst_886:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xf6025caa2d205 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdf6025caa2d205; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:1726*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1726*FLEN/8, x10, x6, x7)

inst_887:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:1728*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1728*FLEN/8, x10, x6, x7)

inst_888:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:1730*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1730*FLEN/8, x10, x6, x7)

inst_889:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:1732*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1732*FLEN/8, x10, x6, x7)

inst_890:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xf6025caa2d205 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdf6025caa2d205; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:1734*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1734*FLEN/8, x10, x6, x7)

inst_891:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:1736*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1736*FLEN/8, x10, x6, x7)

inst_892:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0xf6025caa2d205 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffdf6025caa2d205; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:1738*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1738*FLEN/8, x10, x6, x7)

inst_893:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:1740*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1740*FLEN/8, x10, x6, x7)

inst_894:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0a23bfe815416 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000a23bfe815416; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:1742*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1742*FLEN/8, x10, x6, x7)

inst_895:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0a23bfe815416 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0x8000a23bfe815416;
valaddr_reg:x9; val_offset:1744*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1744*FLEN/8, x10, x6, x7)

inst_896:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:1746*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1746*FLEN/8, x10, x6, x7)

inst_897:// fs1 == 1 and fe1 == 0x002 and fm1 == 0xfafb7b5426c47 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x802fafb7b5426c47; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:1748*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1748*FLEN/8, x10, x6, x7)

inst_898:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 1 and fe2 == 0x002 and fm2 == 0xfafb7b5426c47 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0x802fafb7b5426c47;
valaddr_reg:x9; val_offset:1750*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1750*FLEN/8, x10, x6, x7)

inst_899:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:1752*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1752*FLEN/8, x10, x6, x7)

inst_900:// fs1 == 1 and fe1 == 0x002 and fm1 == 0xfafb7b5426c47 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x802fafb7b5426c47; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:1754*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1754*FLEN/8, x10, x6, x7)

inst_901:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:1756*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1756*FLEN/8, x10, x6, x7)

inst_902:// fs1 == 1 and fe1 == 0x002 and fm1 == 0xfafb7b5426c47 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x802fafb7b5426c47; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:1758*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1758*FLEN/8, x10, x6, x7)

inst_903:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:1760*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1760*FLEN/8, x10, x6, x7)

inst_904:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:1762*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1762*FLEN/8, x10, x6, x7)

inst_905:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:1764*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1764*FLEN/8, x10, x6, x7)

inst_906:// fs1 == 1 and fe1 == 0x002 and fm1 == 0xfafb7b5426c47 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0d8fae5b11a26 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x802fafb7b5426c47; op2val:0x8000d8fae5b11a26;
valaddr_reg:x9; val_offset:1766*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1766*FLEN/8, x10, x6, x7)

inst_907:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0d8fae5b11a26 and fs2 == 1 and fe2 == 0x002 and fm2 == 0xfafb7b5426c47 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000d8fae5b11a26; op2val:0x802fafb7b5426c47;
valaddr_reg:x9; val_offset:1768*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1768*FLEN/8, x10, x6, x7)

inst_908:// fs1 == 1 and fe1 == 0x002 and fm1 == 0xfafb7b5426c47 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x802fafb7b5426c47; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:1770*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1770*FLEN/8, x10, x6, x7)

inst_909:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:1772*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1772*FLEN/8, x10, x6, x7)

inst_910:// fs1 == 1 and fe1 == 0x002 and fm1 == 0xfafb7b5426c47 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x15be852c0ecf4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x802fafb7b5426c47; op2val:0x80015be852c0ecf4;
valaddr_reg:x9; val_offset:1774*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1774*FLEN/8, x10, x6, x7)

inst_911:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x15be852c0ecf4 and fs2 == 1 and fe2 == 0x002 and fm2 == 0xfafb7b5426c47 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80015be852c0ecf4; op2val:0x802fafb7b5426c47;
valaddr_reg:x9; val_offset:1776*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1776*FLEN/8, x10, x6, x7)

inst_912:// fs1 == 1 and fe1 == 0x002 and fm1 == 0xfafb7b5426c47 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x802fafb7b5426c47; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:1778*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1778*FLEN/8, x10, x6, x7)

inst_913:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:1780*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1780*FLEN/8, x10, x6, x7)

inst_914:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:1782*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1782*FLEN/8, x10, x6, x7)

inst_915:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0x0;
valaddr_reg:x9; val_offset:1784*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1784*FLEN/8, x10, x6, x7)

inst_916:// fs1 == 1 and fe1 == 0x402 and fm1 == 0x1a04aee65a608 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xc021a04aee65a608; op2val:0x0;
valaddr_reg:x9; val_offset:1786*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1786*FLEN/8, x10, x6, x7)

inst_917:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x402 and fm2 == 0x1a04aee65a608 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0xc021a04aee65a608;
valaddr_reg:x9; val_offset:1788*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1788*FLEN/8, x10, x6, x7)

inst_918:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x65657f10d48db and fs2 == 1 and fe2 == 0x402 and fm2 == 0x1a04aee65a608 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80065657f10d48db; op2val:0xc021a04aee65a608;
valaddr_reg:x9; val_offset:1790*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1790*FLEN/8, x10, x6, x7)

inst_919:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:1792*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1792*FLEN/8, x10, x6, x7)

inst_920:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x9bff6a8783cf3 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc9bff6a8783cf3; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:1794*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1794*FLEN/8, x10, x6, x7)

inst_921:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x9bff6a8783cf3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0xffc9bff6a8783cf3;
valaddr_reg:x9; val_offset:1796*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1796*FLEN/8, x10, x6, x7)
RVTEST_SIGBASE(x6,signature_x6_7)

inst_922:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:1798*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1798*FLEN/8, x10, x6, x7)

inst_923:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:1800*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1800*FLEN/8, x10, x6, x7)

inst_924:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:1802*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1802*FLEN/8, x10, x6, x7)

inst_925:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:1804*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1804*FLEN/8, x10, x6, x7)

inst_926:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x9bff6a8783cf3 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc9bff6a8783cf3; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:1806*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1806*FLEN/8, x10, x6, x7)

inst_927:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:1808*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1808*FLEN/8, x10, x6, x7)

inst_928:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:1810*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1810*FLEN/8, x10, x6, x7)

inst_929:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:1812*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1812*FLEN/8, x10, x6, x7)

inst_930:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x9bff6a8783cf3 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc9bff6a8783cf3; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:1814*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1814*FLEN/8, x10, x6, x7)

inst_931:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:1816*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1816*FLEN/8, x10, x6, x7)

inst_932:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:1818*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1818*FLEN/8, x10, x6, x7)

inst_933:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:1820*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1820*FLEN/8, x10, x6, x7)

inst_934:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x9bff6a8783cf3 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc9bff6a8783cf3; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:1822*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1822*FLEN/8, x10, x6, x7)

inst_935:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:1824*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1824*FLEN/8, x10, x6, x7)

inst_936:// fs1 == 1 and fe1 == 0x7fc and fm1 == 0x9bff6a8783cf3 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffc9bff6a8783cf3; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:1826*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1826*FLEN/8, x10, x6, x7)

inst_937:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:1828*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1828*FLEN/8, x10, x6, x7)

inst_938:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x042929a1b2ce1 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800042929a1b2ce1; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:1830*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1830*FLEN/8, x10, x6, x7)

inst_939:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x042929a1b2ce1 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0x800042929a1b2ce1;
valaddr_reg:x9; val_offset:1832*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1832*FLEN/8, x10, x6, x7)

inst_940:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:1834*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1834*FLEN/8, x10, x6, x7)

inst_941:// fs1 == 1 and fe1 == 0x001 and fm1 == 0xa0144329d87cc and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x801a0144329d87cc; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:1836*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1836*FLEN/8, x10, x6, x7)

inst_942:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 1 and fe2 == 0x001 and fm2 == 0xa0144329d87cc and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0x801a0144329d87cc;
valaddr_reg:x9; val_offset:1838*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1838*FLEN/8, x10, x6, x7)

inst_943:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:1840*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1840*FLEN/8, x10, x6, x7)

inst_944:// fs1 == 1 and fe1 == 0x001 and fm1 == 0xa0144329d87cc and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x801a0144329d87cc; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:1842*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1842*FLEN/8, x10, x6, x7)

inst_945:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:1844*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1844*FLEN/8, x10, x6, x7)

inst_946:// fs1 == 1 and fe1 == 0x001 and fm1 == 0xa0144329d87cc and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x801a0144329d87cc; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:1846*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1846*FLEN/8, x10, x6, x7)

inst_947:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:1848*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1848*FLEN/8, x10, x6, x7)

inst_948:// fs1 == 1 and fe1 == 0x001 and fm1 == 0xa0144329d87cc and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0d8fae5b11a26 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x801a0144329d87cc; op2val:0x8000d8fae5b11a26;
valaddr_reg:x9; val_offset:1850*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1850*FLEN/8, x10, x6, x7)

inst_949:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0d8fae5b11a26 and fs2 == 1 and fe2 == 0x001 and fm2 == 0xa0144329d87cc and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000d8fae5b11a26; op2val:0x801a0144329d87cc;
valaddr_reg:x9; val_offset:1852*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1852*FLEN/8, x10, x6, x7)

inst_950:// fs1 == 1 and fe1 == 0x001 and fm1 == 0xa0144329d87cc and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x801a0144329d87cc; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:1854*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1854*FLEN/8, x10, x6, x7)

inst_951:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:1856*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1856*FLEN/8, x10, x6, x7)

inst_952:// fs1 == 1 and fe1 == 0x001 and fm1 == 0xa0144329d87cc and fs2 == 1 and fe2 == 0x000 and fm2 == 0x15be852c0ecf4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x801a0144329d87cc; op2val:0x80015be852c0ecf4;
valaddr_reg:x9; val_offset:1858*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1858*FLEN/8, x10, x6, x7)

inst_953:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x15be852c0ecf4 and fs2 == 1 and fe2 == 0x001 and fm2 == 0xa0144329d87cc and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80015be852c0ecf4; op2val:0x801a0144329d87cc;
valaddr_reg:x9; val_offset:1860*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1860*FLEN/8, x10, x6, x7)

inst_954:// fs1 == 1 and fe1 == 0x001 and fm1 == 0xa0144329d87cc and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x801a0144329d87cc; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:1862*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1862*FLEN/8, x10, x6, x7)

inst_955:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:1864*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1864*FLEN/8, x10, x6, x7)

inst_956:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:1866*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1866*FLEN/8, x10, x6, x7)

inst_957:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0x0;
valaddr_reg:x9; val_offset:1868*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1868*FLEN/8, x10, x6, x7)

inst_958:// fs1 == 1 and fe1 == 0x400 and fm1 == 0xcee7468323917 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xc00cee7468323917; op2val:0x0;
valaddr_reg:x9; val_offset:1870*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1870*FLEN/8, x10, x6, x7)

inst_959:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x400 and fm2 == 0xcee7468323917 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0xc00cee7468323917;
valaddr_reg:x9; val_offset:1872*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1872*FLEN/8, x10, x6, x7)

inst_960:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x299ba050fc0c8 and fs2 == 1 and fe2 == 0x400 and fm2 == 0xcee7468323917 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800299ba050fc0c8; op2val:0xc00cee7468323917;
valaddr_reg:x9; val_offset:1874*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1874*FLEN/8, x10, x6, x7)

inst_961:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:1876*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1876*FLEN/8, x10, x6, x7)

inst_962:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0x0c90875ccb5d8 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffb0c90875ccb5d8; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:1878*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1878*FLEN/8, x10, x6, x7)

inst_963:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 1 and fe2 == 0x7fb and fm2 == 0x0c90875ccb5d8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0xffb0c90875ccb5d8;
valaddr_reg:x9; val_offset:1880*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1880*FLEN/8, x10, x6, x7)

inst_964:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:1882*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1882*FLEN/8, x10, x6, x7)

inst_965:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:1884*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1884*FLEN/8, x10, x6, x7)

inst_966:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x4fb4a933fe34f and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe4fb4a933fe34f; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:1886*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1886*FLEN/8, x10, x6, x7)

inst_967:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x4fb4a933fe34f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0xffe4fb4a933fe34f;
valaddr_reg:x9; val_offset:1888*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1888*FLEN/8, x10, x6, x7)

inst_968:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:1890*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1890*FLEN/8, x10, x6, x7)

inst_969:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0x0c90875ccb5d8 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffb0c90875ccb5d8; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:1892*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1892*FLEN/8, x10, x6, x7)

inst_970:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:1894*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1894*FLEN/8, x10, x6, x7)

inst_971:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x4fb4a933fe34f and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe4fb4a933fe34f; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:1896*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1896*FLEN/8, x10, x6, x7)

inst_972:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:1898*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1898*FLEN/8, x10, x6, x7)

inst_973:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x4fb4a933fe34f and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe4fb4a933fe34f; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:1900*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1900*FLEN/8, x10, x6, x7)

inst_974:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:1902*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1902*FLEN/8, x10, x6, x7)

inst_975:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0x0c90875ccb5d8 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffb0c90875ccb5d8; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:1904*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1904*FLEN/8, x10, x6, x7)

inst_976:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:1906*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1906*FLEN/8, x10, x6, x7)

inst_977:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x4fb4a933fe34f and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe4fb4a933fe34f; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:1908*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1908*FLEN/8, x10, x6, x7)

inst_978:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:1910*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1910*FLEN/8, x10, x6, x7)

inst_979:// fs1 == 1 and fe1 == 0x7fe and fm1 == 0x4fb4a933fe34f and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffe4fb4a933fe34f; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:1912*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1912*FLEN/8, x10, x6, x7)

inst_980:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:1914*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1914*FLEN/8, x10, x6, x7)

inst_981:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0x0c90875ccb5d8 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffb0c90875ccb5d8; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:1916*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1916*FLEN/8, x10, x6, x7)

inst_982:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:1918*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1918*FLEN/8, x10, x6, x7)

inst_983:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0x0c90875ccb5d8 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffb0c90875ccb5d8; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:1920*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1920*FLEN/8, x10, x6, x7)

inst_984:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:1922*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1922*FLEN/8, x10, x6, x7)

inst_985:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0d8fae5b11a26 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000d8fae5b11a26; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:1924*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1924*FLEN/8, x10, x6, x7)

inst_986:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0d8fae5b11a26 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0x8000d8fae5b11a26;
valaddr_reg:x9; val_offset:1926*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1926*FLEN/8, x10, x6, x7)

inst_987:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:1928*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1928*FLEN/8, x10, x6, x7)

inst_988:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x015b2b091b5d1 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800015b2b091b5d1; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:1930*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1930*FLEN/8, x10, x6, x7)

inst_989:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x015b2b091b5d1 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0x800015b2b091b5d1;
valaddr_reg:x9; val_offset:1932*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1932*FLEN/8, x10, x6, x7)

inst_990:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:1934*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1934*FLEN/8, x10, x6, x7)

inst_991:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0d8fae5b11a26 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000d8fae5b11a26; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:1936*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1936*FLEN/8, x10, x6, x7)

inst_992:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:1938*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1938*FLEN/8, x10, x6, x7)

inst_993:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0d8fae5b11a26 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000d8fae5b11a26; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:1940*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1940*FLEN/8, x10, x6, x7)

inst_994:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:1942*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1942*FLEN/8, x10, x6, x7)

inst_995:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:1944*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1944*FLEN/8, x10, x6, x7)

inst_996:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:1946*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1946*FLEN/8, x10, x6, x7)

inst_997:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0d8fae5b11a26 and fs2 == 1 and fe2 == 0x002 and fm2 == 0x4b32977d93970 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000d8fae5b11a26; op2val:0x8024b32977d93970;
valaddr_reg:x9; val_offset:1948*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1948*FLEN/8, x10, x6, x7)

inst_998:// fs1 == 1 and fe1 == 0x002 and fm1 == 0x4b32977d93970 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x0d8fae5b11a26 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8024b32977d93970; op2val:0x8000d8fae5b11a26;
valaddr_reg:x9; val_offset:1950*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1950*FLEN/8, x10, x6, x7)

inst_999:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x0d8fae5b11a26 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8000d8fae5b11a26; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:1952*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1952*FLEN/8, x10, x6, x7)

inst_1000:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0x0;
valaddr_reg:x9; val_offset:1954*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1954*FLEN/8, x10, x6, x7)

inst_1001:// fs1 == 1 and fe1 == 0x3ff and fm1 == 0x2dbf77d539bae and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbff2dbf77d539bae; op2val:0x0;
valaddr_reg:x9; val_offset:1956*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1956*FLEN/8, x10, x6, x7)

inst_1002:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x3ff and fm2 == 0x2dbf77d539bae and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0xbff2dbf77d539bae;
valaddr_reg:x9; val_offset:1958*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1958*FLEN/8, x10, x6, x7)

inst_1003:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x879ccf8eb0579 and fs2 == 1 and fe2 == 0x3ff and fm2 == 0x2dbf77d539bae and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800879ccf8eb0579; op2val:0xbff2dbf77d539bae;
valaddr_reg:x9; val_offset:1960*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1960*FLEN/8, x10, x6, x7)

inst_1004:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:1962*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1962*FLEN/8, x10, x6, x7)

inst_1005:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0xae9e55abc765f and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffbae9e55abc765f; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:1964*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1964*FLEN/8, x10, x6, x7)

inst_1006:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 1 and fe2 == 0x7fb and fm2 == 0xae9e55abc765f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0xffbae9e55abc765f;
valaddr_reg:x9; val_offset:1966*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1966*FLEN/8, x10, x6, x7)

inst_1007:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:1968*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1968*FLEN/8, x10, x6, x7)

inst_1008:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:1970*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1970*FLEN/8, x10, x6, x7)

inst_1009:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:1972*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1972*FLEN/8, x10, x6, x7)

inst_1010:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:1974*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1974*FLEN/8, x10, x6, x7)

inst_1011:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0xae9e55abc765f and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffbae9e55abc765f; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:1976*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1976*FLEN/8, x10, x6, x7)

inst_1012:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:1978*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1978*FLEN/8, x10, x6, x7)

inst_1013:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:1980*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1980*FLEN/8, x10, x6, x7)

inst_1014:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:1982*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1982*FLEN/8, x10, x6, x7)

inst_1015:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0xae9e55abc765f and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffbae9e55abc765f; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:1984*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1984*FLEN/8, x10, x6, x7)

inst_1016:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:1986*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1986*FLEN/8, x10, x6, x7)

inst_1017:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:1988*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1988*FLEN/8, x10, x6, x7)

inst_1018:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:1990*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1990*FLEN/8, x10, x6, x7)

inst_1019:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0xae9e55abc765f and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffbae9e55abc765f; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:1992*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1992*FLEN/8, x10, x6, x7)

inst_1020:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:1994*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1994*FLEN/8, x10, x6, x7)

inst_1021:// fs1 == 1 and fe1 == 0x7fb and fm1 == 0xae9e55abc765f and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffbae9e55abc765f; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:1996*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1996*FLEN/8, x10, x6, x7)

inst_1022:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:1998*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 1998*FLEN/8, x10, x6, x7)

inst_1023:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x15be852c0ecf4 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80015be852c0ecf4; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:2000*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2000*FLEN/8, x10, x6, x7)

inst_1024:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x15be852c0ecf4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0x80015be852c0ecf4;
valaddr_reg:x9; val_offset:2002*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2002*FLEN/8, x10, x6, x7)

inst_1025:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:2004*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2004*FLEN/8, x10, x6, x7)

inst_1026:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x022ca6eace47f and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800022ca6eace47f; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:2006*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2006*FLEN/8, x10, x6, x7)

inst_1027:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x022ca6eace47f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0x800022ca6eace47f;
valaddr_reg:x9; val_offset:2008*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2008*FLEN/8, x10, x6, x7)

inst_1028:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:2010*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2010*FLEN/8, x10, x6, x7)

inst_1029:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x15be852c0ecf4 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80015be852c0ecf4; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:2012*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2012*FLEN/8, x10, x6, x7)

inst_1030:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:2014*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2014*FLEN/8, x10, x6, x7)

inst_1031:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x15be852c0ecf4 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80015be852c0ecf4; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:2016*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2016*FLEN/8, x10, x6, x7)

inst_1032:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:2018*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2018*FLEN/8, x10, x6, x7)

inst_1033:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x15be852c0ecf4 and fs2 == 1 and fe2 == 0x002 and fm2 == 0x4b32977d93970 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80015be852c0ecf4; op2val:0x8024b32977d93970;
valaddr_reg:x9; val_offset:2020*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2020*FLEN/8, x10, x6, x7)

inst_1034:// fs1 == 1 and fe1 == 0x002 and fm1 == 0x4b32977d93970 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x15be852c0ecf4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8024b32977d93970; op2val:0x80015be852c0ecf4;
valaddr_reg:x9; val_offset:2022*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2022*FLEN/8, x10, x6, x7)

inst_1035:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x15be852c0ecf4 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x80015be852c0ecf4; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:2024*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2024*FLEN/8, x10, x6, x7)

inst_1036:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0x0;
valaddr_reg:x9; val_offset:2026*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2026*FLEN/8, x10, x6, x7)

inst_1037:// fs1 == 1 and fe1 == 0x3ff and fm1 == 0xe3d32f95a320d and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xbffe3d32f95a320d; op2val:0x0;
valaddr_reg:x9; val_offset:2028*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2028*FLEN/8, x10, x6, x7)

inst_1038:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x3ff and fm2 == 0xe3d32f95a320d and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0xbffe3d32f95a320d;
valaddr_reg:x9; val_offset:2030*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2030*FLEN/8, x10, x6, x7)

inst_1039:// fs1 == 1 and fe1 == 0x000 and fm1 == 0xd97133b894184 and fs2 == 1 and fe2 == 0x3ff and fm2 == 0xe3d32f95a320d and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800d97133b894184; op2val:0xbffe3d32f95a320d;
valaddr_reg:x9; val_offset:2032*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2032*FLEN/8, x10, x6, x7)

inst_1040:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:2034*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2034*FLEN/8, x10, x6, x7)

inst_1041:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0x47f2e5cadc271 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffd47f2e5cadc271; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:2036*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2036*FLEN/8, x10, x6, x7)

inst_1042:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0x47f2e5cadc271 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0xffd47f2e5cadc271;
valaddr_reg:x9; val_offset:2038*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2038*FLEN/8, x10, x6, x7)

inst_1043:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:2040*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2040*FLEN/8, x10, x6, x7)

inst_1044:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:2042*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2042*FLEN/8, x10, x6, x7)

inst_1045:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 1 and fe2 == 0x7ff and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0xfff0000000000000;
valaddr_reg:x9; val_offset:2044*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2044*FLEN/8, x10, x6, x7)

inst_1046:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:2046*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2046*FLEN/8, x10, x6, x7)

inst_1047:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0x47f2e5cadc271 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffd47f2e5cadc271; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:2048*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2048*FLEN/8, x10, x6, x7)

inst_1048:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:2050*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2050*FLEN/8, x10, x6, x7)

inst_1049:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:2052*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2052*FLEN/8, x10, x6, x7)
RVTEST_SIGBASE(x6,signature_x6_8)

inst_1050:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:2054*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2054*FLEN/8, x10, x6, x7)

inst_1051:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0x47f2e5cadc271 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffd47f2e5cadc271; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:2056*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2056*FLEN/8, x10, x6, x7)

inst_1052:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:2058*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2058*FLEN/8, x10, x6, x7)

inst_1053:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:2060*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2060*FLEN/8, x10, x6, x7)

inst_1054:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:2062*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2062*FLEN/8, x10, x6, x7)

inst_1055:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0x47f2e5cadc271 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffd47f2e5cadc271; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:2064*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2064*FLEN/8, x10, x6, x7)

inst_1056:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:2066*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2066*FLEN/8, x10, x6, x7)

inst_1057:// fs1 == 1 and fe1 == 0x7fd and fm1 == 0x47f2e5cadc271 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xffd47f2e5cadc271; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:2068*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2068*FLEN/8, x10, x6, x7)

inst_1058:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:2070*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2070*FLEN/8, x10, x6, x7)

inst_1059:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x069fbb598d312 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800069fbb598d312; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:2072*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2072*FLEN/8, x10, x6, x7)

inst_1060:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x069fbb598d312 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0x800069fbb598d312;
valaddr_reg:x9; val_offset:2074*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2074*FLEN/8, x10, x6, x7)

inst_1061:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:2076*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2076*FLEN/8, x10, x6, x7)

inst_1062:// fs1 == 1 and fe1 == 0x002 and fm1 == 0x4b32977d93970 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8024b32977d93970; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:2078*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2078*FLEN/8, x10, x6, x7)

inst_1063:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 1 and fe2 == 0x002 and fm2 == 0x4b32977d93970 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0x8024b32977d93970;
valaddr_reg:x9; val_offset:2080*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2080*FLEN/8, x10, x6, x7)

inst_1064:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:2082*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2082*FLEN/8, x10, x6, x7)

inst_1065:// fs1 == 1 and fe1 == 0x002 and fm1 == 0x4b32977d93970 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8024b32977d93970; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:2084*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2084*FLEN/8, x10, x6, x7)

inst_1066:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:2086*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2086*FLEN/8, x10, x6, x7)

inst_1067:// fs1 == 1 and fe1 == 0x002 and fm1 == 0x4b32977d93970 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8024b32977d93970; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:2088*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2088*FLEN/8, x10, x6, x7)

inst_1068:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:2090*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2090*FLEN/8, x10, x6, x7)

inst_1069:// fs1 == 1 and fe1 == 0x002 and fm1 == 0x4b32977d93970 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8024b32977d93970; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:2092*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2092*FLEN/8, x10, x6, x7)

inst_1070:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:2094*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2094*FLEN/8, x10, x6, x7)

inst_1071:// fs1 == 1 and fe1 == 0x002 and fm1 == 0x4b32977d93970 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x8024b32977d93970; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:2096*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2096*FLEN/8, x10, x6, x7)

inst_1072:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0x0;
valaddr_reg:x9; val_offset:2098*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2098*FLEN/8, x10, x6, x7)

inst_1073:// fs1 == 1 and fe1 == 0x401 and fm1 == 0x707836e56fe8b and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0xc01707836e56fe8b; op2val:0x0;
valaddr_reg:x9; val_offset:2100*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2100*FLEN/8, x10, x6, x7)

inst_1074:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x401 and fm2 == 0x707836e56fe8b and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0xc01707836e56fe8b;
valaddr_reg:x9; val_offset:2102*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2102*FLEN/8, x10, x6, x7)

inst_1075:// fs1 == 1 and fe1 == 0x000 and fm1 == 0x423d517f83eb0 and fs2 == 1 and fe2 == 0x401 and fm2 == 0x707836e56fe8b and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x800423d517f83eb0; op2val:0xc01707836e56fe8b;
valaddr_reg:x9; val_offset:2104*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2104*FLEN/8, x10, x6, x7)

inst_1076:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fc and fm2 == 0xe759ff97b7507 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x7fce759ff97b7507;
valaddr_reg:x9; val_offset:2106*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2106*FLEN/8, x10, x6, x7)

inst_1077:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x0000000000000 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x0;
valaddr_reg:x9; val_offset:2108*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2108*FLEN/8, x10, x6, x7)

inst_1078:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:2110*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2110*FLEN/8, x10, x6, x7)

inst_1079:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fd and fm2 == 0x09941946801c5 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x7fd09941946801c5;
valaddr_reg:x9; val_offset:2112*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2112*FLEN/8, x10, x6, x7)

inst_1080:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0xac44ace32d282 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x7feac44ace32d282;
valaddr_reg:x9; val_offset:2114*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2114*FLEN/8, x10, x6, x7)

inst_1081:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x450c74c9b42e4 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x7fe450c74c9b42e4;
valaddr_reg:x9; val_offset:2116*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2116*FLEN/8, x10, x6, x7)

inst_1082:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7fd and fm2 == 0xd2b592ef4e4e6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0xffdd2b592ef4e4e6;
valaddr_reg:x9; val_offset:2118*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2118*FLEN/8, x10, x6, x7)

inst_1083:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0xde7300593ddb7 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0xffede7300593ddb7;
valaddr_reg:x9; val_offset:2120*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2120*FLEN/8, x10, x6, x7)

inst_1084:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x8805c5b3ba76f and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0xffe8805c5b3ba76f;
valaddr_reg:x9; val_offset:2122*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2122*FLEN/8, x10, x6, x7)

inst_1085:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7fe and fm2 == 0x0c1b6ea69558e and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0xffe0c1b6ea69558e;
valaddr_reg:x9; val_offset:2124*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2124*FLEN/8, x10, x6, x7)

inst_1086:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x7fc and fm2 == 0x0e3e4312fc728 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0xffc0e3e4312fc728;
valaddr_reg:x9; val_offset:2126*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2126*FLEN/8, x10, x6, x7)

inst_1087:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:2128*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2128*FLEN/8, x10, x6, x7)

inst_1088:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x035efa3d150a6 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x35efa3d150a6;
valaddr_reg:x9; val_offset:2130*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2130*FLEN/8, x10, x6, x7)

inst_1089:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xfee29476f2e06 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0xfee29476f2e06;
valaddr_reg:x9; val_offset:2132*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2132*FLEN/8, x10, x6, x7)

inst_1090:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0xa399f83b8d7e3 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0xa399f83b8d7e3;
valaddr_reg:x9; val_offset:2134*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2134*FLEN/8, x10, x6, x7)

inst_1091:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x85ef342c7a5c9 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x85ef342c7a5c9;
valaddr_reg:x9; val_offset:2136*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2136*FLEN/8, x10, x6, x7)

inst_1092:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x65657f10d48db and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x80065657f10d48db;
valaddr_reg:x9; val_offset:2138*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2138*FLEN/8, x10, x6, x7)

inst_1093:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x299ba050fc0c8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x800299ba050fc0c8;
valaddr_reg:x9; val_offset:2140*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2140*FLEN/8, x10, x6, x7)

inst_1094:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x879ccf8eb0579 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x800879ccf8eb0579;
valaddr_reg:x9; val_offset:2142*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2142*FLEN/8, x10, x6, x7)

inst_1095:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0xd97133b894184 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x800d97133b894184;
valaddr_reg:x9; val_offset:2144*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2144*FLEN/8, x10, x6, x7)

inst_1096:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x0000000000000 and fs2 == 1 and fe2 == 0x000 and fm2 == 0x423d517f83eb0 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x0; op2val:0x800423d517f83eb0;
valaddr_reg:x9; val_offset:2146*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2146*FLEN/8, x10, x6, x7)

inst_1097:// fs1 == 0 and fe1 == 0x7fc and fm1 == 0xe759ff97b7507 and fs2 == 0 and fe2 == 0x7fe and fm2 == 0x405e69652cae2 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x7fce759ff97b7507; op2val:0x7fe405e69652cae2;
valaddr_reg:x9; val_offset:2148*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2148*FLEN/8, x10, x6, x7)

inst_1098:// fs1 == 0 and fe1 == 0x000 and fm1 == 0x3137cb6875068 and fs2 == 0 and fe2 == 0x000 and fm2 == 0x5eb561bd4f6b8 and  fcsr == 0  
/* opcode: fleq.d ; op1:f31; op2:f30; dest:x31; op1val:0x3137cb6875068; op2val:0x5eb561bd4f6b8;
valaddr_reg:x9; val_offset:2150*FLEN/8; correctval:??; testreg:x7;
fcsr_val: 0*/
TEST_FCMP_OP(fleq.d, x31, f31, f30, 0, 0, x9, 2150*FLEN/8, x10, x6, x7)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
test_dataset_0:
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9200859229056023528,64,FLEN)
NAN_BOXED(9200859229056023528,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9202377779058983425,64,FLEN)
NAN_BOXED(9202377779058983425,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9200925092249089411,64,FLEN)
NAN_BOXED(9200925092249089411,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(18426456050155434335,64,FLEN)
NAN_BOXED(18426456050155434335,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
test_dataset_1:
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(18425239702822959398,64,FLEN)
NAN_BOXED(18425239702822959398,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(865851289325672,64,FLEN)
NAN_BOXED(9213606570546665311,64,FLEN)
NAN_BOXED(9213606570546665311,64,FLEN)
NAN_BOXED(865851289325672,64,FLEN)
NAN_BOXED(865851289325672,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(865851289325672,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(86585128932567,64,FLEN)
NAN_BOXED(9206726202665674239,64,FLEN)
NAN_BOXED(9206726202665674239,64,FLEN)
NAN_BOXED(86585128932567,64,FLEN)
NAN_BOXED(86585128932567,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(86585128932567,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(8658512893256719,64,FLEN)
NAN_BOXED(9205230441304230916,64,FLEN)
NAN_BOXED(9205230441304230916,64,FLEN)
NAN_BOXED(8658512893256719,64,FLEN)
NAN_BOXED(8658512893256719,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(8658512893256719,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(8658512893256719,64,FLEN)
NAN_BOXED(9202050188941425894,64,FLEN)
NAN_BOXED(9202050188941425894,64,FLEN)
NAN_BOXED(8658512893256719,64,FLEN)
NAN_BOXED(8658512893256719,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(8658512893256719,64,FLEN)
NAN_BOXED(9201016611344614279,64,FLEN)
NAN_BOXED(9201016611344614279,64,FLEN)
NAN_BOXED(8658512893256719,64,FLEN)
NAN_BOXED(8658512893256719,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(865851289325672,64,FLEN)
NAN_BOXED(18437561114907824645,64,FLEN)
NAN_BOXED(18437561114907824645,64,FLEN)
NAN_BOXED(865851289325672,64,FLEN)
NAN_BOXED(865851289325672,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(865851289325672,64,FLEN)
NAN_BOXED(18431474016099777779,64,FLEN)
NAN_BOXED(18431474016099777779,64,FLEN)
NAN_BOXED(865851289325672,64,FLEN)
NAN_BOXED(865851289325672,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(8658512893256719,64,FLEN)
NAN_BOXED(18424447113745970648,64,FLEN)
NAN_BOXED(18424447113745970648,64,FLEN)
NAN_BOXED(8658512893256719,64,FLEN)
NAN_BOXED(8658512893256719,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(8658512893256719,64,FLEN)
NAN_BOXED(18427297996618888799,64,FLEN)
NAN_BOXED(18427297996618888799,64,FLEN)
NAN_BOXED(8658512893256719,64,FLEN)
NAN_BOXED(8658512893256719,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(865851289325672,64,FLEN)
NAN_BOXED(18434499011834397297,64,FLEN)
NAN_BOXED(18434499011834397297,64,FLEN)
NAN_BOXED(865851289325672,64,FLEN)
NAN_BOXED(865851289325672,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4616502476100471174,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4616502476100471174,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(4616502476100471174,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9200859229056023528,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9200859229056023528,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9200859229056023528,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9200859229056023528,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9200859229056023528,64,FLEN)
NAN_BOXED(9200859229056023528,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9200859229056023528,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9200859229056023528,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(227672801075598,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(227672801075598,64,FLEN)
NAN_BOXED(227672801075598,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(227672801075598,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(22767280107560,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(22767280107560,64,FLEN)
NAN_BOXED(22767280107560,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(22767280107560,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(2276728010755978,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(2276728010755978,64,FLEN)
NAN_BOXED(2276728010755978,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(2276728010755978,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(2276728010755978,64,FLEN)
NAN_BOXED(9216985925286255647,64,FLEN)
NAN_BOXED(9216985925286255647,64,FLEN)
NAN_BOXED(2276728010755978,64,FLEN)
NAN_BOXED(2276728010755978,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(2276728010755978,64,FLEN)
NAN_BOXED(9215693953290241129,64,FLEN)
NAN_BOXED(9215693953290241129,64,FLEN)
NAN_BOXED(2276728010755978,64,FLEN)
NAN_BOXED(2276728010755978,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(227672801075598,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(227672801075598,64,FLEN)
NAN_BOXED(227672801075598,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(227672801075598,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(2276728010755978,64,FLEN)
NAN_BOXED(18439139072078242639,64,FLEN)
NAN_BOXED(18439139072078242639,64,FLEN)
NAN_BOXED(2276728010755978,64,FLEN)
NAN_BOXED(2276728010755978,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(2276728010755978,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(2276728010755978,64,FLEN)
NAN_BOXED(2276728010755978,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(227672801075598,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4607744707152311142,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4607744707152311142,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(4607744707152311142,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(943678102254157,64,FLEN)
NAN_BOXED(9213606570546665311,64,FLEN)
NAN_BOXED(9213606570546665311,64,FLEN)
NAN_BOXED(943678102254157,64,FLEN)
NAN_BOXED(943678102254157,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(943678102254157,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(94367810225416,64,FLEN)
NAN_BOXED(9206726202665674239,64,FLEN)
NAN_BOXED(9206726202665674239,64,FLEN)
NAN_BOXED(94367810225416,64,FLEN)
NAN_BOXED(94367810225416,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(94367810225416,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9221990138641281,64,FLEN)
NAN_BOXED(9205230441304230916,64,FLEN)
NAN_BOXED(9205230441304230916,64,FLEN)
NAN_BOXED(9221990138641281,64,FLEN)
NAN_BOXED(9221990138641281,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9221990138641281,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9221990138641281,64,FLEN)
NAN_BOXED(9202050188941425894,64,FLEN)
NAN_BOXED(9202050188941425894,64,FLEN)
NAN_BOXED(9221990138641281,64,FLEN)
NAN_BOXED(9221990138641281,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9221990138641281,64,FLEN)
NAN_BOXED(9201016611344614279,64,FLEN)
NAN_BOXED(9201016611344614279,64,FLEN)
NAN_BOXED(9221990138641281,64,FLEN)
NAN_BOXED(9221990138641281,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(943678102254157,64,FLEN)
NAN_BOXED(18437561114907824645,64,FLEN)
NAN_BOXED(18437561114907824645,64,FLEN)
NAN_BOXED(943678102254157,64,FLEN)
NAN_BOXED(943678102254157,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(943678102254157,64,FLEN)
NAN_BOXED(18431474016099777779,64,FLEN)
NAN_BOXED(18431474016099777779,64,FLEN)
NAN_BOXED(943678102254157,64,FLEN)
NAN_BOXED(943678102254157,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9221990138641281,64,FLEN)
NAN_BOXED(18424447113745970648,64,FLEN)
NAN_BOXED(18424447113745970648,64,FLEN)
NAN_BOXED(9221990138641281,64,FLEN)
NAN_BOXED(9221990138641281,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9221990138641281,64,FLEN)
NAN_BOXED(18427297996618888799,64,FLEN)
NAN_BOXED(18427297996618888799,64,FLEN)
NAN_BOXED(9221990138641281,64,FLEN)
NAN_BOXED(9221990138641281,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(943678102254157,64,FLEN)
NAN_BOXED(18434499011834397297,64,FLEN)
NAN_BOXED(18434499011834397297,64,FLEN)
NAN_BOXED(943678102254157,64,FLEN)
NAN_BOXED(943678102254157,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4616935402117816430,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4616935402117816430,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(4616935402117816430,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9202377779058983425,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9202377779058983425,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9202377779058983425,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9202377779058983425,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9202377779058983425,64,FLEN)
NAN_BOXED(9202377779058983425,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9202377779058983425,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9202377779058983425,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(304352472427542,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(304352472427542,64,FLEN)
NAN_BOXED(304352472427542,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(304352472427542,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(30435247242754,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(30435247242754,64,FLEN)
NAN_BOXED(30435247242754,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(30435247242754,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(3043524724275422,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(3043524724275422,64,FLEN)
NAN_BOXED(3043524724275422,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(3043524724275422,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(3043524724275422,64,FLEN)
NAN_BOXED(9216985925286255647,64,FLEN)
NAN_BOXED(9216985925286255647,64,FLEN)
NAN_BOXED(3043524724275422,64,FLEN)
NAN_BOXED(3043524724275422,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(3043524724275422,64,FLEN)
NAN_BOXED(9215693953290241129,64,FLEN)
NAN_BOXED(9215693953290241129,64,FLEN)
NAN_BOXED(3043524724275422,64,FLEN)
NAN_BOXED(3043524724275422,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(304352472427542,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(304352472427542,64,FLEN)
NAN_BOXED(304352472427542,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(304352472427542,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(3043524724275422,64,FLEN)
NAN_BOXED(18439139072078242639,64,FLEN)
NAN_BOXED(18439139072078242639,64,FLEN)
NAN_BOXED(3043524724275422,64,FLEN)
NAN_BOXED(3043524724275422,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(3043524724275422,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(3043524724275422,64,FLEN)
NAN_BOXED(3043524724275422,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(304352472427542,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4609450886474352491,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4609450886474352491,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(4609450886474352491,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9200925092249089411,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9200925092249089411,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9200925092249089411,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9200925092249089411,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9200925092249089411,64,FLEN)
NAN_BOXED(9200925092249089411,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9200925092249089411,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9200925092249089411,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(230998584216514,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(230998584216514,64,FLEN)
NAN_BOXED(230998584216514,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(230998584216514,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(23099858421651,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(23099858421651,64,FLEN)
NAN_BOXED(23099858421651,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(23099858421651,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(2309985842165136,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(2309985842165136,64,FLEN)
NAN_BOXED(2309985842165136,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(2309985842165136,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(2309985842165136,64,FLEN)
NAN_BOXED(9216985925286255647,64,FLEN)
NAN_BOXED(9216985925286255647,64,FLEN)
NAN_BOXED(2309985842165136,64,FLEN)
NAN_BOXED(2309985842165136,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(2309985842165136,64,FLEN)
NAN_BOXED(9215693953290241129,64,FLEN)
NAN_BOXED(9215693953290241129,64,FLEN)
NAN_BOXED(2309985842165136,64,FLEN)
NAN_BOXED(2309985842165136,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(230998584216514,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(230998584216514,64,FLEN)
NAN_BOXED(230998584216514,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(230998584216514,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(2309985842165136,64,FLEN)
NAN_BOXED(18439139072078242639,64,FLEN)
NAN_BOXED(18439139072078242639,64,FLEN)
NAN_BOXED(2309985842165136,64,FLEN)
NAN_BOXED(2309985842165136,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(2309985842165136,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(2309985842165136,64,FLEN)
NAN_BOXED(2309985842165136,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(230998584216514,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4607818708283570298,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4607818708283570298,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(4607818708283570298,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18426456050155434335,64,FLEN)
NAN_BOXED(18426456050155434335,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18425239702822959398,64,FLEN)
NAN_BOXED(18425239702822959398,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9225030391366272477,64,FLEN)
NAN_BOXED(9213606570546665311,64,FLEN)
NAN_BOXED(9213606570546665311,64,FLEN)
NAN_BOXED(9225030391366272477,64,FLEN)
NAN_BOXED(9225030391366272477,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9225030391366272477,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9223537872305925475,64,FLEN)
NAN_BOXED(9206726202665674239,64,FLEN)
NAN_BOXED(9206726202665674239,64,FLEN)
NAN_BOXED(9223537872305925475,64,FLEN)
NAN_BOXED(9223537872305925475,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9223537872305925475,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9236167409039629648,64,FLEN)
NAN_BOXED(9205230441304230916,64,FLEN)
NAN_BOXED(9205230441304230916,64,FLEN)
NAN_BOXED(9236167409039629648,64,FLEN)
NAN_BOXED(9236167409039629648,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9236167409039629648,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9236167409039629648,64,FLEN)
NAN_BOXED(9202050188941425894,64,FLEN)
NAN_BOXED(9202050188941425894,64,FLEN)
NAN_BOXED(9236167409039629648,64,FLEN)
NAN_BOXED(9236167409039629648,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9236167409039629648,64,FLEN)
NAN_BOXED(9201016611344614279,64,FLEN)
NAN_BOXED(9201016611344614279,64,FLEN)
NAN_BOXED(9236167409039629648,64,FLEN)
NAN_BOXED(9236167409039629648,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9225030391366272477,64,FLEN)
NAN_BOXED(18437561114907824645,64,FLEN)
NAN_BOXED(18437561114907824645,64,FLEN)
NAN_BOXED(9225030391366272477,64,FLEN)
NAN_BOXED(9225030391366272477,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9225030391366272477,64,FLEN)
NAN_BOXED(18431474016099777779,64,FLEN)
NAN_BOXED(18431474016099777779,64,FLEN)
NAN_BOXED(9225030391366272477,64,FLEN)
NAN_BOXED(9225030391366272477,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9236167409039629648,64,FLEN)
NAN_BOXED(18424447113745970648,64,FLEN)
NAN_BOXED(18424447113745970648,64,FLEN)
NAN_BOXED(9236167409039629648,64,FLEN)
NAN_BOXED(9236167409039629648,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9236167409039629648,64,FLEN)
NAN_BOXED(18427297996618888799,64,FLEN)
NAN_BOXED(18427297996618888799,64,FLEN)
NAN_BOXED(9236167409039629648,64,FLEN)
NAN_BOXED(9236167409039629648,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9225030391366272477,64,FLEN)
NAN_BOXED(18434499011834397297,64,FLEN)
NAN_BOXED(18434499011834397297,64,FLEN)
NAN_BOXED(9225030391366272477,64,FLEN)
NAN_BOXED(9225030391366272477,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(13844174106499120105,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(13844174106499120105,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(13844174106499120105,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(18426456050155434335,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(18426456050155434335,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(18426456050155434335,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(18426456050155434335,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(18426456050155434335,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(18426456050155434335,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9223712050852634572,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9223712050852634572,64,FLEN)
NAN_BOXED(9223712050852634572,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9223712050852634572,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9223406038254561684,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9223406038254561684,64,FLEN)
NAN_BOXED(9223406038254561684,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9223406038254561684,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9226772176833363448,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9226772176833363448,64,FLEN)
NAN_BOXED(9226772176833363448,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9226772176833363448,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9226772176833363448,64,FLEN)
NAN_BOXED(9216985925286255647,64,FLEN)
NAN_BOXED(9216985925286255647,64,FLEN)
NAN_BOXED(9226772176833363448,64,FLEN)
NAN_BOXED(9226772176833363448,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9226772176833363448,64,FLEN)
NAN_BOXED(9215693953290241129,64,FLEN)
NAN_BOXED(9215693953290241129,64,FLEN)
NAN_BOXED(9226772176833363448,64,FLEN)
NAN_BOXED(9226772176833363448,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9223712050852634572,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9223712050852634572,64,FLEN)
NAN_BOXED(9223712050852634572,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9223712050852634572,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9226772176833363448,64,FLEN)
NAN_BOXED(18439139072078242639,64,FLEN)
NAN_BOXED(18439139072078242639,64,FLEN)
NAN_BOXED(9226772176833363448,64,FLEN)
NAN_BOXED(9226772176833363448,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9226772176833363448,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9226772176833363448,64,FLEN)
NAN_BOXED(9226772176833363448,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9223712050852634572,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(13833616418609043313,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(13833616418609043313,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(13833616418609043313,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(18425239702822959398,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(18425239702822959398,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(18425239702822959398,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(18425239702822959398,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(18425239702822959398,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(18425239702822959398,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9223650631002433923,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9223650631002433923,64,FLEN)
NAN_BOXED(9223650631002433923,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(9223650631002433923,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9223399896269541619,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9223399896269541619,64,FLEN)
NAN_BOXED(9223399896269541619,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(9223399896269541619,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9226157978331356956,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(9226157978331356956,64,FLEN)
NAN_BOXED(9226157978331356956,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(9226157978331356956,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9226157978331356956,64,FLEN)
NAN_BOXED(9216985925286255647,64,FLEN)
NAN_BOXED(9216985925286255647,64,FLEN)
NAN_BOXED(9226157978331356956,64,FLEN)
NAN_BOXED(9226157978331356956,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9226157978331356956,64,FLEN)
NAN_BOXED(9215693953290241129,64,FLEN)
NAN_BOXED(9215693953290241129,64,FLEN)
NAN_BOXED(9226157978331356956,64,FLEN)
NAN_BOXED(9226157978331356956,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9223650631002433923,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9223650631002433923,64,FLEN)
NAN_BOXED(9223650631002433923,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9223650631002433923,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9226157978331356956,64,FLEN)
NAN_BOXED(18439139072078242639,64,FLEN)
NAN_BOXED(18439139072078242639,64,FLEN)
NAN_BOXED(9226157978331356956,64,FLEN)
NAN_BOXED(9226157978331356956,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9226157978331356956,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9226157978331356956,64,FLEN)
NAN_BOXED(9226157978331356956,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9223650631002433923,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(13832249781578294385,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(13832249781578294385,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(13832249781578294385,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9225277363099856128,64,FLEN)
NAN_BOXED(9213606570546665311,64,FLEN)
NAN_BOXED(9213606570546665311,64,FLEN)
NAN_BOXED(9225277363099856128,64,FLEN)
NAN_BOXED(9225277363099856128,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9225277363099856128,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9223562569479283840,64,FLEN)
NAN_BOXED(9206726202665674239,64,FLEN)
NAN_BOXED(9206726202665674239,64,FLEN)
NAN_BOXED(9223562569479283840,64,FLEN)
NAN_BOXED(9223562569479283840,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9223562569479283840,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9237142551722217600,64,FLEN)
NAN_BOXED(9205230441304230916,64,FLEN)
NAN_BOXED(9205230441304230916,64,FLEN)
NAN_BOXED(9237142551722217600,64,FLEN)
NAN_BOXED(9237142551722217600,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9237142551722217600,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9237142551722217600,64,FLEN)
NAN_BOXED(9202050188941425894,64,FLEN)
NAN_BOXED(9202050188941425894,64,FLEN)
NAN_BOXED(9237142551722217600,64,FLEN)
NAN_BOXED(9237142551722217600,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9237142551722217600,64,FLEN)
NAN_BOXED(9201016611344614279,64,FLEN)
NAN_BOXED(9201016611344614279,64,FLEN)
NAN_BOXED(9237142551722217600,64,FLEN)
NAN_BOXED(9237142551722217600,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9225277363099856128,64,FLEN)
NAN_BOXED(18437561114907824645,64,FLEN)
NAN_BOXED(18437561114907824645,64,FLEN)
NAN_BOXED(9225277363099856128,64,FLEN)
NAN_BOXED(9225277363099856128,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9225277363099856128,64,FLEN)
NAN_BOXED(18431474016099777779,64,FLEN)
NAN_BOXED(18431474016099777779,64,FLEN)
NAN_BOXED(9225277363099856128,64,FLEN)
NAN_BOXED(9225277363099856128,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9237142551722217600,64,FLEN)
NAN_BOXED(18424447113745970648,64,FLEN)
NAN_BOXED(18424447113745970648,64,FLEN)
NAN_BOXED(9237142551722217600,64,FLEN)
NAN_BOXED(9237142551722217600,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9237142551722217600,64,FLEN)
NAN_BOXED(18427297996618888799,64,FLEN)
NAN_BOXED(18427297996618888799,64,FLEN)
NAN_BOXED(9237142551722217600,64,FLEN)
NAN_BOXED(9237142551722217600,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9225277363099856128,64,FLEN)
NAN_BOXED(18434499011834397297,64,FLEN)
NAN_BOXED(18434499011834397297,64,FLEN)
NAN_BOXED(9225277363099856128,64,FLEN)
NAN_BOXED(9225277363099856128,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(13844861019434354089,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(13844861019434354089,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(13844861019434354089,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9223852163427951031,64,FLEN)
NAN_BOXED(9213606570546665311,64,FLEN)
NAN_BOXED(9213606570546665311,64,FLEN)
NAN_BOXED(9223852163427951031,64,FLEN)
NAN_BOXED(9223852163427951031,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9223852163427951031,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9223420049512093330,64,FLEN)
NAN_BOXED(9206726202665674239,64,FLEN)
NAN_BOXED(9206726202665674239,64,FLEN)
NAN_BOXED(9223420049512093330,64,FLEN)
NAN_BOXED(9223420049512093330,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9223420049512093330,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9228173302586528035,64,FLEN)
NAN_BOXED(9205230441304230916,64,FLEN)
NAN_BOXED(9205230441304230916,64,FLEN)
NAN_BOXED(9228173302586528035,64,FLEN)
NAN_BOXED(9228173302586528035,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9228173302586528035,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9228173302586528035,64,FLEN)
NAN_BOXED(9202050188941425894,64,FLEN)
NAN_BOXED(9202050188941425894,64,FLEN)
NAN_BOXED(9228173302586528035,64,FLEN)
NAN_BOXED(9228173302586528035,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9228173302586528035,64,FLEN)
NAN_BOXED(9201016611344614279,64,FLEN)
NAN_BOXED(9201016611344614279,64,FLEN)
NAN_BOXED(9228173302586528035,64,FLEN)
NAN_BOXED(9228173302586528035,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9223852163427951031,64,FLEN)
NAN_BOXED(18437561114907824645,64,FLEN)
NAN_BOXED(18437561114907824645,64,FLEN)
NAN_BOXED(9223852163427951031,64,FLEN)
NAN_BOXED(9223852163427951031,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9223852163427951031,64,FLEN)
NAN_BOXED(18431474016099777779,64,FLEN)
NAN_BOXED(18431474016099777779,64,FLEN)
NAN_BOXED(9223852163427951031,64,FLEN)
NAN_BOXED(9223852163427951031,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9228173302586528035,64,FLEN)
NAN_BOXED(18424447113745970648,64,FLEN)
NAN_BOXED(18424447113745970648,64,FLEN)
NAN_BOXED(9228173302586528035,64,FLEN)
NAN_BOXED(9228173302586528035,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9228173302586528035,64,FLEN)
NAN_BOXED(18427297996618888799,64,FLEN)
NAN_BOXED(18427297996618888799,64,FLEN)
NAN_BOXED(9228173302586528035,64,FLEN)
NAN_BOXED(9228173302586528035,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9223852163427951031,64,FLEN)
NAN_BOXED(18434499011834397297,64,FLEN)
NAN_BOXED(18434499011834397297,64,FLEN)
NAN_BOXED(9223852163427951031,64,FLEN)
NAN_BOXED(9223852163427951031,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(13835896041088527380,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(13835896041088527380,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(13835896041088527380,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9213606570546665311,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9213606570546665311,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9213606570546665311,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9213606570546665311,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9213606570546665311,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9213606570546665311,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(166612995020972,64,FLEN)
NAN_BOXED(593033618597499,64,FLEN)
NAN_BOXED(593033618597499,64,FLEN)
NAN_BOXED(166612995020972,64,FLEN)
NAN_BOXED(166612995020972,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(166612995020972,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(12834249378419096,64,FLEN)
NAN_BOXED(448398571019828,64,FLEN)
NAN_BOXED(448398571019828,64,FLEN)
NAN_BOXED(12834249378419096,64,FLEN)
NAN_BOXED(12834249378419096,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(12834249378419096,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(12834249378419096,64,FLEN)
NAN_BOXED(287810703961904,64,FLEN)
NAN_BOXED(287810703961904,64,FLEN)
NAN_BOXED(12834249378419096,64,FLEN)
NAN_BOXED(12834249378419096,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(12834249378419096,64,FLEN)
NAN_BOXED(235619870412948,64,FLEN)
NAN_BOXED(235619870412948,64,FLEN)
NAN_BOXED(12834249378419096,64,FLEN)
NAN_BOXED(12834249378419096,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(12834249378419096,64,FLEN)
NAN_BOXED(9223610608961788454,64,FLEN)
NAN_BOXED(9223610608961788454,64,FLEN)
NAN_BOXED(12834249378419096,64,FLEN)
NAN_BOXED(12834249378419096,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(12834249378419096,64,FLEN)
NAN_BOXED(9223754565210402036,64,FLEN)
NAN_BOXED(9223754565210402036,64,FLEN)
NAN_BOXED(12834249378419096,64,FLEN)
NAN_BOXED(12834249378419096,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4620823695801117841,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4620823695801117841,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(4620823695801117841,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9206726202665674239,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9206726202665674239,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9206726202665674239,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9206726202665674239,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9206726202665674239,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9206726202665674239,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(593033618597499,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(593033618597499,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(5930336185974994,64,FLEN)
NAN_BOXED(44839857101983,64,FLEN)
NAN_BOXED(44839857101983,64,FLEN)
NAN_BOXED(5930336185974994,64,FLEN)
NAN_BOXED(5930336185974994,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(5930336185974994,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(5930336185974994,64,FLEN)
NAN_BOXED(28781070396190,64,FLEN)
NAN_BOXED(28781070396190,64,FLEN)
NAN_BOXED(5930336185974994,64,FLEN)
NAN_BOXED(5930336185974994,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(5930336185974994,64,FLEN)
NAN_BOXED(23561987041295,64,FLEN)
NAN_BOXED(23561987041295,64,FLEN)
NAN_BOXED(5930336185974994,64,FLEN)
NAN_BOXED(5930336185974994,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(593033618597499,64,FLEN)
NAN_BOXED(9223550415411434518,64,FLEN)
NAN_BOXED(9223550415411434518,64,FLEN)
NAN_BOXED(593033618597499,64,FLEN)
NAN_BOXED(593033618597499,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(593033618597499,64,FLEN)
NAN_BOXED(9223445234272906465,64,FLEN)
NAN_BOXED(9223445234272906465,64,FLEN)
NAN_BOXED(593033618597499,64,FLEN)
NAN_BOXED(593033618597499,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(5930336185974994,64,FLEN)
NAN_BOXED(9223395894065477073,64,FLEN)
NAN_BOXED(9223395894065477073,64,FLEN)
NAN_BOXED(5930336185974994,64,FLEN)
NAN_BOXED(5930336185974994,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(5930336185974994,64,FLEN)
NAN_BOXED(9223410289690338431,64,FLEN)
NAN_BOXED(9223410289690338431,64,FLEN)
NAN_BOXED(5930336185974994,64,FLEN)
NAN_BOXED(5930336185974994,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(593033618597499,64,FLEN)
NAN_BOXED(9223488566659175186,64,FLEN)
NAN_BOXED(9223488566659175186,64,FLEN)
NAN_BOXED(593033618597499,64,FLEN)
NAN_BOXED(593033618597499,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4613780136809803538,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4613780136809803538,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(4613780136809803538,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9205230441304230916,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9205230441304230916,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9218868437227405312,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9205230441304230916,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9205230441304230916,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9205230441304230916,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9205230441304230916,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(448398571019828,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(448398571019828,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(44839857101983,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(44839857101983,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(448398571019828,64,FLEN)
NAN_BOXED(9236794564315081799,64,FLEN)
NAN_BOXED(9236794564315081799,64,FLEN)
NAN_BOXED(448398571019828,64,FLEN)
NAN_BOXED(448398571019828,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(448398571019828,64,FLEN)
NAN_BOXED(9230691778667841484,64,FLEN)
NAN_BOXED(9230691778667841484,64,FLEN)
NAN_BOXED(448398571019828,64,FLEN)
NAN_BOXED(448398571019828,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(448398571019828,64,FLEN)
NAN_BOXED(9233702126702115184,64,FLEN)
NAN_BOXED(9233702126702115184,64,FLEN)
NAN_BOXED(448398571019828,64,FLEN)
NAN_BOXED(448398571019828,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4612171018492858427,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4612171018492858427,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(4612171018492858427,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9202050188941425894,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9202050188941425894,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9216985925286255647,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9216985925286255647,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9202050188941425894,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9216985925286255647,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9216985925286255647,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9202050188941425894,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9216985925286255647,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(9216985925286255647,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9202050188941425894,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9202050188941425894,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(287810703961904,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(287810703961904,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(28781070396190,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(28781070396190,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(287810703961904,64,FLEN)
NAN_BOXED(9236794564315081799,64,FLEN)
NAN_BOXED(9236794564315081799,64,FLEN)
NAN_BOXED(287810703961904,64,FLEN)
NAN_BOXED(287810703961904,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(287810703961904,64,FLEN)
NAN_BOXED(9230691778667841484,64,FLEN)
NAN_BOXED(9230691778667841484,64,FLEN)
NAN_BOXED(287810703961904,64,FLEN)
NAN_BOXED(287810703961904,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(287810703961904,64,FLEN)
NAN_BOXED(9233702126702115184,64,FLEN)
NAN_BOXED(9233702126702115184,64,FLEN)
NAN_BOXED(287810703961904,64,FLEN)
NAN_BOXED(287810703961904,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4609082819908488795,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4609082819908488795,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(4609082819908488795,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9201016611344614279,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9201016611344614279,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9215693953290241129,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9215693953290241129,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9201016611344614279,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9215693953290241129,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9215693953290241129,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9201016611344614279,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9215693953290241129,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(9215693953290241129,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9201016611344614279,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9201016611344614279,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(235619870412948,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(235619870412948,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(23561987041295,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(23561987041295,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(235619870412948,64,FLEN)
NAN_BOXED(9236794564315081799,64,FLEN)
NAN_BOXED(9236794564315081799,64,FLEN)
NAN_BOXED(235619870412948,64,FLEN)
NAN_BOXED(235619870412948,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(235619870412948,64,FLEN)
NAN_BOXED(9230691778667841484,64,FLEN)
NAN_BOXED(9230691778667841484,64,FLEN)
NAN_BOXED(235619870412948,64,FLEN)
NAN_BOXED(235619870412948,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(235619870412948,64,FLEN)
NAN_BOXED(9233702126702115184,64,FLEN)
NAN_BOXED(9233702126702115184,64,FLEN)
NAN_BOXED(235619870412948,64,FLEN)
NAN_BOXED(235619870412948,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4607921535314653963,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4607921535314653963,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(4607921535314653963,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(18437561114907824645,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(18437561114907824645,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(18437561114907824645,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(18437561114907824645,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(18437561114907824645,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(18437561114907824645,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9223550415411434518,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9223550415411434518,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9236794564315081799,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9236794564315081799,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9236794564315081799,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9236794564315081799,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9236794564315081799,64,FLEN)
NAN_BOXED(9223610608961788454,64,FLEN)
NAN_BOXED(9223610608961788454,64,FLEN)
NAN_BOXED(9236794564315081799,64,FLEN)
NAN_BOXED(9236794564315081799,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9236794564315081799,64,FLEN)
NAN_BOXED(9223754565210402036,64,FLEN)
NAN_BOXED(9223754565210402036,64,FLEN)
NAN_BOXED(9236794564315081799,64,FLEN)
NAN_BOXED(9236794564315081799,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(13844522973201278472,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(13844522973201278472,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(13844522973201278472,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(18431474016099777779,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(18431474016099777779,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(18431474016099777779,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(18431474016099777779,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(18431474016099777779,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(18431474016099777779,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9223445234272906465,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9223445234272906465,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9230691778667841484,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9230691778667841484,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9230691778667841484,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9230691778667841484,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9230691778667841484,64,FLEN)
NAN_BOXED(9223610608961788454,64,FLEN)
NAN_BOXED(9223610608961788454,64,FLEN)
NAN_BOXED(9230691778667841484,64,FLEN)
NAN_BOXED(9230691778667841484,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9230691778667841484,64,FLEN)
NAN_BOXED(9223754565210402036,64,FLEN)
NAN_BOXED(9223754565210402036,64,FLEN)
NAN_BOXED(9230691778667841484,64,FLEN)
NAN_BOXED(9230691778667841484,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(13838697938734430487,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(13838697938734430487,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(13838697938734430487,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(18424447113745970648,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(18424447113745970648,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(18439139072078242639,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(18439139072078242639,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(18424447113745970648,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(18439139072078242639,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(18439139072078242639,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(18424447113745970648,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(18439139072078242639,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(18439139072078242639,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(18424447113745970648,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(18424447113745970648,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9223610608961788454,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9223610608961788454,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9223395894065477073,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9223395894065477073,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9223610608961788454,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9223610608961788454,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9223610608961788454,64,FLEN)
NAN_BOXED(9233702126702115184,64,FLEN)
NAN_BOXED(9233702126702115184,64,FLEN)
NAN_BOXED(9223610608961788454,64,FLEN)
NAN_BOXED(9223610608961788454,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(13831359261614250926,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(13831359261614250926,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(13831359261614250926,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(18427297996618888799,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(18427297996618888799,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(18427297996618888799,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(18427297996618888799,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(18427297996618888799,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(18427297996618888799,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9223754565210402036,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9223754565210402036,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9223410289690338431,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9223410289690338431,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9223754565210402036,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9223754565210402036,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9223754565210402036,64,FLEN)
NAN_BOXED(9233702126702115184,64,FLEN)
NAN_BOXED(9233702126702115184,64,FLEN)
NAN_BOXED(9223754565210402036,64,FLEN)
NAN_BOXED(9223754565210402036,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(13834562394469839373,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(13834562394469839373,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(13834562394469839373,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(18434499011834397297,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(18434499011834397297,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(18442240474082181120,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(18434499011834397297,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(18434499011834397297,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(18434499011834397297,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(18434499011834397297,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9223488566659175186,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9223488566659175186,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9233702126702115184,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9233702126702115184,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9233702126702115184,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9233702126702115184,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9233702126702115184,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9233702126702115184,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(13841540240819814027,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(13841540240819814027,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(13841540240819814027,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9210029744914432453,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9217395412933202562,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9215579554420835044,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(18436940111564563686,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(18441650242590072247,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(18440129808424478575,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(18437949865815790990,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(18428980244417333032,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(59303361859750,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(4483985710198278,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(2878107039619043,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(2356198704129481,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9225155822421362907,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9224104011036082376,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9225757757924902265,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9227197320411038084,64,FLEN)
NAN_BOXED(0,64,FLEN)
NAN_BOXED(9224537334898769584,64,FLEN)
NAN_BOXED(9209427617965110535,64,FLEN)
NAN_BOXED(9215497225429502690,64,FLEN)
NAN_BOXED(865851289325672,64,FLEN)
NAN_BOXED(1666129950209720,64,FLEN)
RVTEST_DATA_END

RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;



signature_x1_0:
    .fill 0*((SIGALIGN)/4),4,0xdeadbeef


signature_x1_1:
    .fill 52*((SIGALIGN)/4),4,0xdeadbeef


signature_x6_0:
    .fill 256*((SIGALIGN)/4),4,0xdeadbeef


signature_x6_1:
    .fill 256*((SIGALIGN)/4),4,0xdeadbeef


signature_x6_2:
    .fill 256*((SIGALIGN)/4),4,0xdeadbeef


signature_x6_3:
    .fill 256*((SIGALIGN)/4),4,0xdeadbeef


signature_x6_4:
    .fill 256*((SIGALIGN)/4),4,0xdeadbeef


signature_x6_5:
    .fill 256*((SIGALIGN)/4),4,0xdeadbeef


signature_x6_6:
    .fill 256*((SIGALIGN)/4),4,0xdeadbeef


signature_x6_7:
    .fill 256*((SIGALIGN)/4),4,0xdeadbeef


signature_x6_8:
    .fill 98*((SIGALIGN)/4),4,0xdeadbeef

#ifdef rvtest_mtrap_routine
tsig_begin_canary:
CANARY;

mtrap_sigptr:
    .fill 64*XLEN/32,4,0xdeadbeef

tsig_end_canary:
CANARY;
#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*XLEN/32,4,0xdeadbeef

#endif


sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
